# Packmol

Packmol - Creates Initial Configurations for Molecular Dynamics Simulations

**https://m3g.github.io/packmol**

## What is Packmol

Packmol creates an initial point for molecular dynamics simulations by packing molecules in defined regions of space. The packing guarantees that short range repulsive interactions do not disrupt the simulations.

The great variety of types of spatial constraints that can be attributed to the molecules, or atoms within the molecules, makes it easy to create ordered systems, such as lamellar, spherical or tubular lipid layers.

The user must provide only the coordinates of one molecule of each type, the number of molecules of each type and the spatial constraints that each type of molecule must satisfy.

The package is compatible with input files of PDB, TINKER, and XYZ.

## Usage

User guide, examples, and tutorials, are available at: https://m3g.github.io/packmol

## Installation instructions

### Multi-platform package provider with Julia

If you are not familiar with compiling packages, you may find it easier to get the Julia interface for
`packmol`, which provides executables for all common platforms: https://github.com/m3g/Packmol.jl

Installation of the Julia programming language and of the Julia `Packmol` package are necessary, but
these follow simple instructions which are described in the link above.

Compilation of the package, particularly on Linux platforms is, nevertheless, easy, following the instructions
below.

### Downloading

1. Download the `.tar.gz` or `.zip` files of the latest version from: https://github.com/m3g/packmol/releases

2. Unpack the files, for example with: 
   ```bash
   tar -xzvf packmol-21.0.0.tar.gz
   ```
   or
   ```bash
   unzip -xzvf packmol-21.0.0.zip
   ```
   substituting the `21.0.0` with the correct version number.

### Using `make`

3. Go into the `packmol` directory, and compile the package (we assume `gfortran` or other compiler is available):
    ```bash
    cd packmol
    ./configure [optional: path to fortran compiler]
    make
    ```

4. An executable called `packmol` will be created in the main directory. Add that directory to your path.

### Using the Fortran Package Manager (`fpm`)

3. Install the Fortran Package Manager from: https://fpm.fortran-lang.org/en/install/index.html#install

4. Go into the `packmol` directory, and run:
   ```bash
   fpm install --profile release
   ```
   this will compile and send the executable somewhere in your `PATH`.
   By default (on Linux systems) it will be `~/.local/bin`. Making it available
   as a `packmol` command anywhere in your computer.

   `fpm` will look for Fortran compilers automatically and will use `gfortran`
   as default. To use another compiler modify the environment variable
   `FPM_FC=compiler`, for example for `ifort`, use in bash, `export FPM_FC=ifort`.

## References

Please always cite one of the following references in publications for which Packmol was useful:

L Martinez, R Andrade, EG Birgin, JM Martinez, Packmol: A package for building initial configurations for molecular dynamics simulations. Journal of Computational Chemistry, 30, 2157-2164, 2009. (http://www3.interscience.wiley.com/journal/122210103/abstract)

JM Martinez, L Martinez, Packing optimization for the automated generation of complex system's initial configurations for molecular dynamics and docking. Journal of Computational Chemistry, 24, 819-825, 2003.
(http://www3.interscience.wiley.com/journal/104086246/abstract)

{::nomarkdown}

<!-- https://github.com/leandromartinez98/packmol/raw/master/docs/imgs/pbc.jpg -->

<h3>User guide</h3>
<i>Important:</i> always download the latest version of Packmol
in order that all features are available.
<br><br>

<!-- START SECTION -->
<b> Contents </b>

<br>
<a href="#need">1. What do you need?</a><br>
<a href="#comp">2. How to compile Packmol.</a><br>
<a href="#run">3. Running Packmol.</a><br>
<a href="#basic">4. Basic input structure.</a><br>
<a href="#more">5. More types of molecules.</a><br>
<a href="#atom">6. Atom selections.</a><br>
<a href="#types">7. Types of constraints.</a><br>
<a href="#pbc">8. Periodic boundary conditions.</a><br>
<a href="#radii">9. Different radii for different atoms.</a><br>
<a href="#numb">10. Controlling residue numbering in PDB files.</a><br>
<a href="#restart">11. Building very large systems: using restart files.</a><br>
<a href="#conv">12. Convergence problems: what to try.</a><br>
<a href="#add">13. Additional input options and keywords.</a>
<br><br>

<!-- END SECTION -->


<!-- START SECTION -->
<a name="need"></a><b>What do you need? </b>
<br><br>

You need coordinate files for each type of molecule you want your
simulation to have. For example, if you are going to simulate a solution
of water and ions, you will need a coordinate file for <i>one</i>  water
molecule, and independent coordinates files for each of the ions. This
coordinate files may be in the PDB, TINKER, MOLDEN or MOLDY format.
<br><br>
Of course, you also need the <code>Packmol</code> package, which you can get from
<pre><code>  http://www.ime.unicamp.br/~martinez/packmol
</code></pre>
or by clicking on the <a target="contents" href="https://github.com/leandromartinez98/packmol/releases/latest">
[Latest Release]</a> link. By following this link you will download the file
<code>packmol.tar.gz</code> which contains the whole source code of
Packmol. 
<br><br>

<!-- END SECTION -->

<!-- START SECTION -->
<a name="comp"></a><b>How to compile Packmol </b>
<br><br>

Once you have downloaded the <code>packmol.tar.gz</code> file from the home-page,
you need to expand the files and compile the package. This is done by:
<br><br>
Expanding the files:
<pre>tar -xvzf packmol.tar.gz</pre>
This will create a directory called <code>packmol</code> inside which you can find
the source code. You can build the executable by:
<pre>
  cd packmol
  make
</pre>
<br>
That's it, if no error was reported the packmol executable was 
built.
<br><br>
-----
<br><br>
If you have problems, let the configure script find a suitable
compiler for you:<br><br>
<code>chmod +x ./configure </code>  (this makes the script executable)
<br><br>
<code>./configure </code> (this executes the script)
<br><br>
If the script was not able to find a suitable compiler, then
you can manually set the compiler by:
<br><br>
<code>./configure /path/to/your/compiler/yourcompiler</code>
<br><br>
Then, run the "make" command again:
<br><br>
<code>make</code>
<br><br>
If no error was
detected, an executable called packmol is now ready.
<br><br>
<!-- END SECTION -->

<!-- START SECTION -->
<a name="run"></a><b>Running Packmol </b>
<br><br>

Once you have compiled and built your input file, run Packmol  with
<br>
<pre>
packmol < packmol.inp
</pre>
<br>
Where <code>packmol.inp</code> is the input file (you can obtain example files by
clicking at the 'Input examples' link on the left). <br><br> 
A successful packing will end with something like
<br>
<pre>
-------------------------------------------------
                Success!
Final objective function value: .22503E-01
Maximum violation of target distance:   0.000000
Maximum violation of the constraints: .78985E-02
-------------------------------------------------
</pre>
<br>
Where the maximum violation of the target distance indicates the
difference between the minimum distance between atoms required by
the user and that of the solution. It will not be greater than 10<sup>-2</sup> 
The maximum violation of the constrains must not be greater than 10<sup>-2</sup>.
<br><br>
A good idea is to check if your constraints are correct by using
the "check" keyword in the input file. With this option a rough
initial approximation will be built but no actual packing will
be performed. You can look at the output to see if the molecules
are within the desired regions (but do not expect a good structure
at this point!). Just add the word "check" to any line of your
input file (available since 28 Feb 2008).
<br><br>
<hr
><br>
<u>Common issues:</u> <br><br>
 - If you get "Command not found" when running Packmol, use <br>
<pre>
./packmol < packmol.inp
</pre>
(with a "./" before "packmol") 
or add the directory where the packmol executable is located to your path.
<br><br>
 - If you run packmol and get the message "Killed", this is because the
package is trying to allocate more memory than available for static                          
storage. Open the "sizes.i" file and decrease the "maxatom" parameter to
the number of atoms of your system, compile the package again, and try
again.
<br><br>
<!-- END SECTION -->

<!-- START SECTION -->
<a name="basic"></a><b>Basic input structure </b>
<br><br>

The minimal input file must contain the distance tolerance required (for
systems at room temperature and pressure and coordinates in Angstroms,
2.0 Å is a good value. This is specified with
<br><br>
<code>tolerance 2.0</code>
<br><br>
The file must contain also the name of the output file to be created,
specified with
<br><br>
<code>output test.pdb</code>
<br><br>
and the file type (pdb, tinker, xyz or moldy, pdb is the default value),
<br><br>
<code>filetype pdb</code>
<br><br>
At least one type of molecule must be present. This is set by the
<code>structure ... end structure</code> section, for example, if
<code>water.pdb</code> is the
file containing the coordinates of a single water molecule, you could
add to your input file something like
<br>
<pre>
structure water.pdb
  number 2000
  inside cube 0. 0. 0. 40. 
end structure
</pre>
<br>
This section specifies that 2000 molecules of the <code>water.pdb</code> type, will
be placed inside a cube with minimum coordinates
(<i>x</i>,<i>y</i>,<i>z</i>) = (0,0,0) and
maximum coordinates (40,40,40). Therefore, this minimum input file must
be:
<br>
<pre>
tolerance 2.0
output test.pdb
filetype pdb
structure water.pdb
  number 2000 
  inside cube 0. 0. 0. 40. 
end structure
</pre>
<br>
Running Packmol with this input file will fill a cube of side 40.0 Å
with 2000 water molecules. Every pair of atoms of different molecules
will be separated by, at least, 2.0 Å and the molecules will be
randomly distributed inside de cube.
<br><br>
<!-- END SECTION -->

<!-- START SECTION -->
<a name="more"></a><b>More types of molecules </b>
<br><br>

You can add more types of molecules to the same region, or to different
regions of the space, simply adding other <code>structure ... end
structure</code>
section to the input file.
<br><br>
<!-- END SECTION -->

<!-- START SECTION -->
<a name="atom"></a><b>Atom selections </b>
<br><br>

The coordinate file of a single molecule contains, for example, 10
atoms. You can restrain a part of the molecule to be in a specified
region of the space. This is useful for building vesicles where the
hydrophilic  part of the surfactants must be pointing to the aqueous
environment, for example. For the 10 atoms molecule, this is done by
using the keyword atoms, as in
<br>
<pre>
structure molecule.pdb     
  inside cube 0. 0. 0. 20.
  atoms 9 10              
    inside box 0. 0. 15. 20. 20. 20.
  end atoms 
end structure                     
</pre>
<br>
In this case, all the atoms of the molecule will be put inside the
defined cube, but atoms 9 and 10 will be restrained to be inside the
box.
<br><br>
<!-- END SECTION -->

<!-- START SECTION -->
<a name="types"></a><b>Types  of constraints </b>
<br><br>

There are several types of constraints that can be applied both to whole
molecules or to parts of the molecule. These constraints define the
region of the space in which the molecules must be at the solution. Very
ordered systems can be built in such a way. The constraints  are:
<br><br>

<table align="center" width="80%">
<!-- START CONSTRAINT -->
<tr>
<td valign="bottom" align="right" width="20" height="30"> 1. </td>
<td valign="bottom"><code>
fixed
</code></td>
</tr>

<tr><td></td>
<td>
Usage: <code>fixed </code><i>x   y   z  a   b   g</i><br><br>
This options holds the molecule
fixed in the position specified by the parameters. <i>x, y, z, a, b,
g,</i>
which are six real numbers. The first three determine the translation of
the molecule relative to its position in the coordinate file. The former
three parameters are rotation angles (in radians). For this option it is
required that only one molecule is set. It may be accompanied by the
keyword <code>center</code>. If this keyword is present the first three numbers
are the position of the baricenter (not really the center of mass,
because we suppose that all atoms have the same mass). Therefore this
keyword must be used in the following context:
<br><br>
<pre>
structure molecule.pdb
  number 1  
  center    
  fixed 0. 0. 0. 0. 0. 0.
end structure
</pre>
<br><br>
In this example, the molecule will be fixed with its center 
the origin and no rotation.

<br><br></td></tr>
<!-- END CONSTRAINT -->


<!-- START CONSTRAINT -->
<tr>
<td valign="bottom" align="right" width="20" height="30"> 
2. 
</td>
<td valign="bottom"><code>
inside cube
</code></td>
</tr>

<tr><td></td>
<td>
Usage: <code>inside cube </code><i>x<sub>min</sub>&nbsp; y<sub>min</sub>&nbsp; z<sub>min</sub>&nbsp;    d</i><br><br>

<i>x<sub>min</sub> ,  y<sub>min</sub> ,  z<sub>min</sub></i> and <i>d</i>
are four real numbers. The coordinates (<i>x</i>,<i>y</i>,<i>z</i>) of the atoms restrained
by this option will satisfy, at the solution:
<center>
<br><br>
<i>x<sub>min</sub></i> < <i>x</i> < <i>x<sub>min</sub></i> + <i>d</i><br>
<i>y<sub>min</sub></i> < <i>y</i> < <i>y<sub>min</sub></i> + <i>d</i><br>
<i>z<sub>min</sub></i> < <i>z</i> < <i>z<sub>min</sub></i> + <i>d</i>
</center>

<br><br></td></tr>
<!-- END CONSTRAINT -->


<!-- START CONSTRAINT -->
<tr>
<td valign="bottom" align="right" width="20" height="30"> 
3. 
</td>
<td valign="bottom"><code>
outside cube
</code></td>
</tr>

<tr><td></td>
<td>
Usage: <code>outside cube </code><i>x<sub>min</sub>&nbsp; y<sub>min</sub>&nbsp; z<sub>min</sub>&nbsp;    d</i><br><br>

<i>x<sub>min</sub> ,  y<sub>min</sub> ,  z<sub>min</sub></i> and <i>d</i>
are four real numbers. The coordinates (<i>x</i>,<i>y</i>,<i>z</i>) of the atoms restrained
by this option will satisfy, at the solution:
<center>
<br><br>
<i>x</i> < <i>x<sub>min</sub></i> or <i>x</i> > <i>x<sub>min</sub></i> + <i>d</i><br>
<i>y</i> < <i>y<sub>min</sub></i> or <i>y</i> > <i>y<sub>min</sub></i> + <i>d</i><br>
<i>z</i> < <i>z<sub>min</sub></i> or <i>z</i> > <i>z<sub>min</sub></i> + <i>d</i>
</center>

<br><br></td></tr>
<!-- END CONSTRAINT -->


<!-- START CONSTRAINT -->
<tr>
<td valign="bottom" align="right" width="20" height="30"> 
4. 
</td>
<td valign="bottom"><code>
inside box
</code></td>
</tr>

<tr><td></td>
<td>
Usage: <code>inside box</code>&nbsp; 
<i>x<sub>min</sub>&nbsp;
y<sub>min</sub>&nbsp;
z<sub>min</sub>&nbsp;
x<sub>max</sub>&nbsp;   
y<sub>max</sub>&nbsp; 
z<sub>max</sub></i><br><br>

<i>x<sub>min</sub>&nbsp;,
y<sub>min</sub>&nbsp;,
z<sub>min</sub>&nbsp;,
x<sub>max</sub>&nbsp;,   
y<sub>max</sub>&nbsp;</i> and <i> 
z<sub>max</sub></i>
are six real numbers. The coordinates
(<i>x</i>,<i>y</i>,<i>z</i>) of the atoms restrained by this option will satisfy, at the
solution:
<br><br>
<center>
<i>x<sub>min</sub></i> < <i>x</i> < <i>x<sub>max</sub></i><br>
<i>y<sub>min</sub></i> < <i>y</i> < <i>y<sub>max</sub></i><br>
<i>z<sub>min</sub></i> < <i>z</i> < <i>z<sub>max</sub></i>
</center>


<br><br></td></tr>
<!-- END CONSTRAINT -->


<!-- START CONSTRAINT -->
<tr>
<td valign="bottom" align="right" width="20" height="30"> 
5. 
</td>
<td valign="bottom"><code>
outside box
</code></td>
</tr>

<tr><td></td>
<td>
Usage: <code>outside box</code>&nbsp; 
<i>x<sub>min</sub>&nbsp;
y<sub>min</sub>&nbsp;
z<sub>min</sub>&nbsp;
x<sub>max</sub>&nbsp;   
y<sub>max</sub>&nbsp; 
z<sub>max</sub></i><br><br>

<i>x<sub>min</sub>&nbsp;,
y<sub>min</sub>&nbsp;,
z<sub>min</sub>&nbsp;,
x<sub>max</sub>&nbsp;,   
y<sub>max</sub>&nbsp;</i> and <i> 
z<sub>max</sub></i>
are six real numbers. The coordinates
(<i>x</i>,<i>y</i>,<i>z</i>) of the atoms restrained by this option will satisfy, at the
solution:
<br><br>
<center>
<i>x</i> < <i>x<sub>min</sub></i> or <i>x</i> > <i>x<sub>max</sub></i><br>
<i>y</i> < <i>y<sub>min</sub></i> or <i>y</i> > <i>y<sub>max</sub></i><br>
<i>z</i> < <i>z<sub>min</sub></i> or <i>z</i> > <i>z<sub>max</sub></i>
</center>
<br><br></td></tr>
<!-- END CONSTRAINT -->


<!-- START CONSTRAINT -->
<tr>
<td valign="bottom" align="right" width="20" height="30"> 
6. 
</td>
<td valign="bottom"><code>
inside (or outside) sphere
</code></td>
</tr>
<tr><td></td>
<td>
Spheres are defined by equations of the general form <br><br>
<center>
<img src=https://github.com/leandromartinez98/packmol/raw/master/docs//imgs/img31.png>
</center>
<br>
and, therefore, you must provide four real parameters <i>a</i>,
<i>b</i>, <i>c</i> and <i>d</i>  in
order to define it. The input syntax is, for example,
<br><br><code>
inside sphere 2.30 3.40 4.50 8.0
</code><br><br>
and therefore the coordinates of the atoms will satisfy the equation
<br><br>
<center>
<img src=https://github.com/leandromartinez98/packmol/raw/master/docs//imgs/img36.png>
</center><br>  
Other input alternative would be:
<br><br><code>
outside sphere 2.30 3.40 4.50 8.0
</code><br><br>
The <code>outside</code> parameter is similar to the <code>inside</code> parameter, but the
equation above uses <img src=https://github.com/leandromartinez98/packmol/raw/master/docs//imgs/img37.png>  instead of  <img src=https://github.com/leandromartinez98/packmol/raw/master/docs//imgs/img38.png> 
and, therefore, the
atoms will be placed outside the defined sphere.
<br><br></td></tr>
<!-- END CONSTRAINT -->


<!-- START CONSTRAINT -->
<tr>
<td valign="bottom" align="right" width="20" height="30"> 
7. 
</td>
<td valign="bottom"><code>
inside (or outside) ellipsoid 
</code></td>
</tr>

<tr><td></td>
<td>
Ellipsoids are defined by the general equation
<br><br>
<center>
<img src=https://github.com/leandromartinez98/packmol/raw/master/docs//imgs/img39.png>
</center>
<br>
The parameters must be given as in the sphere example, but now they are
7, and must be entered in the following order:
<br><br><code>
inside ellipsoid</code> <i>&nbsp;
a<sub>1</sub>&nbsp;  
b<sub>1</sub>&nbsp;  
c<sub>1</sub>&nbsp;  
a<sub>2</sub>&nbsp;  
b<sub>2</sub>&nbsp;
c<sub>2</sub>&nbsp;  
d</i>
<br><br>
The coordinates
(<i>a<sub>1</sub></i>,<i>b<sub>1</sub></i>,<i>c<sub>1</sub></i>) 
will define the center of the ellipsoid, the
coordinates 
(<i>a<sub>2</sub></i>,<i>b<sub>2</sub></i>,<i>c<sub>2</sub></i>) 
will define the relative size of the axes and <i>d</i>
will define the volume of the ellipsoid. Of course, the commands
<br><br><code>
outside ellipsoid</code> <i>&nbsp;
a<sub>1</sub>&nbsp;  
b<sub>1</sub>&nbsp;  
c<sub>1</sub>&nbsp;  
a<sub>2</sub>&nbsp;  
b<sub>2</sub>&nbsp;
c<sub>2</sub>&nbsp;  
d</i>
<br><br>
can also be used in the same manner as the parameters for spheres. Note
that the case 
<i>a<sub>2</sub></i> = 
<i>b<sub>2</sub></i> = 
<i>c<sub>2</sub></i> = 1.0 provides the exactly the same as the
sphere parameter. The parameters for the ellipsoid are not normalized.
Therefore, if 
<i>a<sub>2</sub></i>, 
<i>b<sub>2</sub></i> and 
<i>c<sub>2</sub></i> are large, the ellipsoid will be large, even
for a small <i>d</i>.
<br><br></td></tr>
<!-- END CONSTRAINT -->


<!-- START CONSTRAINT -->
<tr>
<td valign="bottom" align="right" width="20" height="30"> 
8. 
</td>
<td valign="bottom"><code>
over (or below) plane 
</code></td>
</tr>

<tr><td></td>
<td>
The planes are defined by the general equation
<br><br>
<center>
<i>ax</i> + <i>by</i> + <i>cz</i> - <i>d</i> = 0
</center><br>
And it is possible to restrict atoms to be over or below the plane. The syntax is
<br><pre>
over plane 2.5 3.2 1.2 6.2

below plane 2.5 3.2 1.2 6.2
</pre><br>
where the <code>over</code> keyword will make the atoms satisfy the condition
<br><center>
2.5<i>x</i> + 3.2<i>y</i> + 1.2<i>z</i> - 6.2 <img src=https://github.com/leandromartinez98/packmol/raw/master/docs//imgs/img37.png> 0
</center><br><br>
the <code>below</code> keyword will make the atoms satisfy
<br><br><center>
2.5<i>x</i> + 3.2<i>y</i> + 1.2<i>z</i> - 6.2 <img src=https://github.com/leandromartinez98/packmol/raw/master/docs//imgs/img38.png> 0
</center><br>
<br><br></td></tr>
<!-- END CONSTRAINT -->


<!-- START CONSTRAINT -->
<tr>
<td valign="bottom" align="right" width="20" height="30"> 
9. 
</td>
<td valign="bottom"><code>
inside (or outside) cylinder
</code></td>
</tr>
<tr><td></td>
<td>

In order to define a cylinder, it is necessary first to define a
line oriented in space. This line is defined in <code>Packmol</code> by the
parametric equation
<br><br><center>
<i>p</i> = (
<i>a<sub>1</sub>&nbsp;</i>,
<i>b<sub>1</sub>&nbsp;</i>,
<i>c<sub>1</sub>&nbsp;</i>) + <i>t</i>&nbsp;(
<i>a<sub>2</sub>&nbsp;</i>,
<i>b<sub>2</sub>&nbsp;</i>,
<i>c<sub>2</sub></i>)
</center><br>
where <i>t</i> is the independent parameter. The vector 
(<i>a<sub>2</sub>&nbsp;</i>,
<i>b<sub>2</sub>&nbsp;</i>,
<i>c<sub>2</sub></i>)                        
defines the
direction of the line. The cylinder is therefore defined by the distance
to this line, <i>d</i>, and a length <i>l</i>. Therefore, the usage must be:
<br><br>
inside cylinder 
&nbsp;<i>a<sub>1</sub></i>  
&nbsp;<i>b<sub>1</sub></i>  
&nbsp;<i>c<sub>1</sub></i>  
&nbsp;<i>a<sub>2</sub></i>  
&nbsp;<i>b<sub>2</sub></i>  
&nbsp;<i>c<sub>2</sub></i>  
&nbsp;<i>d </i> 
&nbsp;<i>l </i>
<br><br>
outside cylinder 
&nbsp;<i>a<sub>1</sub></i>  
&nbsp;<i>b<sub>1</sub></i>  
&nbsp;<i>c<sub>1</sub></i>  
&nbsp;<i>a<sub>2</sub></i>  
&nbsp;<i>b<sub>2</sub></i>  
&nbsp;<i>c<sub>2</sub></i>  
&nbsp;<i>d </i> 
&nbsp;<i>l </i>
<br><br>

Here, the first three parameters define the point where the cylinder
starts, and <i>l</i> defines the length of the cylinder. <i>d</i> defines de
radius of the cylinder. The simpler example is a cylinder oriented in
the <i>x</i> axis and starting at the origin, such as
<br><br><pre>
inside cylinder 0. 0. 0. 1. 0. 0. 10. 20.
</pre><br><br>
This cylinder is specified by the points that have a distance of 10. to
the <i>x</i> axis (the cylinder has a radius of 10.). Furthermore, it starts at
the origin, therefore no atom restricted by this cylinder will have an
<i>x</i>
coordinate less than 0. Furthermore, it has a length of 20. and, as
such, no atom will have an <i>x</i> coordinate greater than 20. The orientation
of the cylinder, parallel to the <i>x</i> axis is defined by the director
vector (1,0,0), the fourth, fifth and sixth parameters. Cylinders can be
oriented in space in anyway.

<br><br></td></tr>
<!-- END CONSTRAINT -->

<!-- START CONSTRAINT -->
<tr>
<td valign="bottom" align="right" width="20" height="30"> 
10. 
</td>
<td valign="bottom"><code>
Constrain rotations
</code></td>
</tr>

<tr><td></td>
<td>
It is possible to constrain rotations of all molecules of each type, so
that they have some average orientation in space.
<br><br>
The keywords to be used are, within a structure...end structure section:
<br><br><pre>
constrain_rotation x 180. 20. 
constrain_rotation y 180. 20. 
constrain_rotation z 180. 20. 
</pre>
<br><br>
Each of these keywords restricts the possible rotation angles around
each axis to be within 180&plusmn;20 degrees (or any other value). For a
technical reason the rotation around the <code>z</code> axis will, alone, be
identical to the rotation around the <code>y</code> axis (we hope to fix
this some day). Constraining the three rotations will constrain
completely the rotations. Note that to have your molecules oriented
parallel to an axis, you need to constrain the rotations relative to the
other two.
<br><br>
For example, to constrain the rotation of your molecule along the
<code>z</code> axis, use something like:
<br><br><pre>
constrain_rotation x 0. 20. 
constrain_rotation y 0. 20. 
</pre><br>
Note that these rotations are defined relative to the molecule in the
orientation which was provided by the user, in the input PDB file.
Therefore, it is a good idea to orient the molecule in a reasonable way
in order to understand the rotations. For example, if the molecule is
elongated in one direction, a good idea is to provide the molecule with
the larger dimension oriented along the <code>z</code> axis.<br><br>
<br><br></td></tr>
<!-- END CONSTRAINT -->
</table>
<br><br>
<!-- END SECTION -->

<!-- START SECTION -->
<a name="pbc"></a><b>Periodic Boundary Conditions </b>
<br><br>

Periodic Boundary Conditions for cubic and rectangular boxes are often
requested by users. We aim to implement that in the future. At the same
time, there is a simple workaround we suggest: If your system will be
simulated in a, for example, 100. Angs box, define your cubic constraints
such that the packing is done in a 98. Angs box. That way, when the actual
simulation box with PBC is built, images will be 2. Angs apart from each
other, as illustrated in the figure below. There will be an empty space
at the boundary, but that will readily disappear with energy
minimization and equilibration.

<center>
<br>
<img src="https://github.com/leandromartinez98/packmol/raw/master/docs//imgs/pbc.jpg">
</center>
<br><br>
<!-- END SECTION -->

<!-- START SECTION -->
<a name="radii"></a><b>Different radii for different atoms </b>
<br><br>

It is possible (from version 15.133 on) to attribute different radii to
different atoms during the packing procedure. The default behavior is
that all atoms will be distant to each other at the final structure at least
the distance defined by the <code>tolerance</code> parameter. In this
case it is possible to think that the radius of every atom is half the
distance tolerance. A tolerance of 2.0 Angs is usually fine for
simulation of molecular systems using all-atom models.  
<br><br>
Most times, therefore, you won't need this option. This was requested by
users that want to pack multiscale models, in which all-atom and
coarse-grained representations are combined in the same system.
<br><br>
It is easy to define different radii to different molecules, or to atoms
within a molecule. Just add the "<code>radius</code>" keyword within the
<code>structure ... end structure</code> section of a molecule type, or
within <code>atoms ... end atoms</code> section of an atom selection.
<br><br>
For example, in this case:<br><br>
<pre>
tolerance 2.0
structure water.pdb
  number 500
  inside box 0. 0. 0. 30. 30. 30.
  radius 1.5
end structure
</pre>
the radius of the atoms of the water molecules will be 1.5. Note that
this implies a distance tolerance of 3.0 within water molecules.
<br><br>
In this case, on the other side:<br><br>
<pre>
tolerance 2.0
structure water.pdb
  number 500
  inside box 0. 0. 0. 30. 30. 30.
  atoms 1 2
    radius 1.5
  end atoms
end structure
</pre>
only atoms 1 and 2 of the water molecule (as listed in the water.pdb
file) will have a radius of 1.5, while atom 3 will have a radius of 1.0,
as defined by the tolerance of 2.0 
<br><br>
Always remember that the distance tolerance is the sum of the radii of
each pair of atoms, and that the greatest the radii the harder the
packing. Also, keep in mind that your minimization and equilibration
will take care of the actual atom radii, and Packmol is designed only to
give a first coordinate file.  
<br><br>
Finally, currently the restrictions are set to be fulfilled by the
<b>center</b> of the atoms. Therefore, if you are using large radii, you
might want to adjust the sizes of the boxes, spheres, etc., so that the
whole atoms are within the desired regions. For standard all-atom
simulations this is not usually an issue because the radii are small.
<br><br>
<!-- END SECTION -->

<!-- START SECTION -->
<a name="numb"></a><b>Controlling residue numbering in PDB files.</b>
<br><br>

Since Packmol will create one or more copies of your molecules in a
new PDB file, there are some options on how residue numbers are set to
these new molecules. There are four options, which are set with the
<code>resnumbers</code> keyword. This keyword may assume three values, 0, 1,
2 or 3, and may be inserted within the <code>structure ... end structure</code>
section of each type of molecule. The options are: <br><br>
<code>
resnumbers 0 
</code><br><br>
In this case the residue numbers of all residues will correspond to the
molecule of each type, independently of the residue
numbering of the original pdb file. This means that if you pack 10
water molecules and 10 ethanol molecules, the water molecules will be numbered 
1 to 10, and the ethanol molecules will be numbered 1 to 10. 
<br><br>
<code>
resnumbers 1
</code><br><br>
In this case, the residue numbers of the original pdb files are kept
unmodified. This means that if you pack 10 proteins of 5 residues, the
residue numbers will be preserved and, therefore, they will be
repeated for equivalent residues in each molecule of the same protein.
<br><br>
<code>
resnumbers 2
</code><br><br>
In this case, the residue numbers of all residues for this structure
will be numbered sequentially according to the number of residues that
are printed previously in the same file. This means that if you pack
10 proteins of 5 residues, there will be residue numbers ranging
from 1 to 50.
<br><br>
<code>
resnumbers 3
</code><br><br>
In this case, the numbering of the residues will correspond to the
sequential numbering of all residues in the file. That is, if you
pack a protein with 150 residues followed by 10 water molecules, the
water molecules will be numbered from 151 to 161.
<br><br>
For example, this keyword may be used as in:
<pre><code>structure peptide.pdb  
  number 10               
  resnumbers 1            
  inside box 0. 0. 0. 20. 20. 20.
end structure        
</code></pre>
<em>Default:</em> The default behavior is to use 0 for structures with
only one residue and 1 for structures with more than one residue.
<br><br>
<em> Chain identifier: </em><br>
It is also possible to modify the "chain" identifiers of PDB files.
By default, each type of molecule is set to a "chain". On the otherside,
using the <br><br><code>changechains</code><br><br> 
whithin the <code>structure...end structure</code>
section of a type of molecule, the chains will alternate between
two values ("A" and "B" for example). This might be useful if the
molecules are peptides, and topology builders sometimes think
that the peptides of the same chain must be join by covalent bonds.
This is avoided by alternating the chain from molecule to molecule.
<br><br>
Additionally each structure can have a specific chain identifier, set
by the user with the option: <br><br><code>chain D</code><br><br>
where "D" is the desired identifier (Do not use "#"). 
<br><br>
<!-- END SECTION -->

<!-- START SECTION -->
<a name="restart"></a><b>Building very large systems: using restart files </b>
<br><br>
From version 16.143 on, it is possible to build the system from multiple
and independent executions of Packmol by the use of restart files. In
order to write a restart file, the following keyword must be used:
<code>
restart_to restart.pack
</code>
where <code>restart.pack</code> is the name of the restart file to be
created. It is possible to write restart files for the whole system, if
the keyword is put outside <code>structure...end structure</code> sections,
or to write a restart file for a specific part of the system, using, for
instance:
<pre>
structure water.pdb
  number 1000
  inside cube 0. 0. 0. 40.
  restart_to water1.pack
end structure
</pre>
This will generate a restart file for the water molecules only.
<br><br>

These restart files can be used to start a new execution of Packmol with
more molecules. The <code>restart_from</code> keyword must then be used. For
example: 
<pre>
structure water.pdb
  number 1000
  inside cube 0. 0. 0. 40.
  restart_from water1.pack
end structure
</pre>
The new input file might contain other molecules, as a regular Packmol
input file, and these water molecules will be packed together with the
new molecules, but starting from the previous runs. This can be used,
for example, to build solvated bilayers by parts. For instance, the
bilayers could be built and, later, different solvents can be added to
the bilayer, without having to restart the whole system construction
from scratch every time. This could also be used to add some molecule to
the bilayer.
<br><br>
<em>Tip:</em> the restart file can be used to restart the position of a
<em>smaller</em> number of molecules of the same type. 
For instance, if a new molecule is introduced
inside a previous set of molecules (a lipid bilayer, for instance), you
can tell Packmol to pack less molecules of the original set, in order to
provide space for the new structure, while using the original restart
file of more molecules. That is, a <code> restart_from water1.pack </code>
similar to the ones of the example above could be used to restart the
positions of 800 molecules.  
<br><br>
<!-- END SECTION -->

<!-- START SECTION -->
<a name="conv"></a><b>Convergence problems: what to try </b>
<br><br>
Sometimes Packmol is not able to find an adequate packing solution. Here
are some tips to try to overcome these difficulties:<br><br>
<table>
<tr><td>&bull; Look at the best solution obtained, many times it is good enough to
be used. </td></tr>
<tr><td>&bull; Simulate the same problem with only a few molecules of each type. For
example, instead of using 20 thousand water molecules, put 300, and see
if they are in the correct regions. </td></tr>
<tr><td>&bull; If you have large molecules, try running the program twice, one to
pack these molecules, and then use the solution as fixed molecule for
the next packing, in which solvation is included. This may be
particularly useful for building solvated membranes. Build the membrane
first and then use it as a fixed molecule for a solvation run.</td></tr>
<tr><td>&bull; You can change some options of the packing procedure to try
improve the optimization: 
<table width=90% align=center>
<tr><td valign=top>1.</td>
<td><code>discale [real]</code><br>
This option controls the distance tolerance actually used in the
local optimization method. It was found that using larger distances
helps sometimes. Try setting <code>discale</code> to 1.5, for example.
</td></tr>

<tr><td valign=top>2.</td>
<td><code>maxit [integer]</code><br>
This is the maximum number of iterations of the local optimizer (GENCAN)
per loop. The default value is currently 20, changing it may improve (or
worse) the convergence.
</td></tr>

<tr><td valign=top>2.</td>
<td><code>movebadrandom</code><br>
 One of the convergence heuristics of Packmol consists in moving
 molecules that are badly placed. If this option is set, the molecules
will be placed in new random position in the box. If not (default), the
molecules are moved to positions nearby molecules that are well packed.
Using this option can help when the restraints are complex, but will
probably be bad if there are large structures, because the new random
position might overlap with those.
</td></tr>
</table>
</td></tr>
</table>
<br><br>
<!-- END SECTION -->

<!-- START SECTION -->
<a name="add"></a><b>Additional input options and keywords</b>
<br><br>

There are some input options which are probably not of interest of the
general user, but may be useful in specific contexts. These keywords may
be added in the input file in any position.<br><br>

Add the TER flag betwen every molecule (AMBER uses this): <br>
Usage: <code> add_amber_ter </code> <br><br>

Add box side information to output PDB File (GROMACS uses this): <br>
Usage: <code> add_box_sides 1.0 </code> <br>
Where the "1.0" is an optional real number that will be added to
the length of each side, if the actual sides of your simulation box
will not be exactly the same as the maximum and minimum coordinates
of the molecules of the system (usually, if you are using periodic
boundary conditions, you may want to add "1.0" to avoid clashes
at the boundary).
<br><br>

Increase maximum system dimensions: <br>
Usage: <code> sidemax [real] </code> (ex: sidemax 2000.d0) <br>
"<code>sidemax</code>" is used to build an initial approximation of the molecular
distribution. Increase "<code>sidemax</code>" if your system is very large, or your
system may look cut out by this maximum dimension. All system
coordinates must fit within <code>-sidemax</code> and <code>+sidemax</code>, and
using a <code>sidemax</code>
that approximately fits your system may accelerate a little bit the
packing calculation. The default value is 1000.d0. <br><br>

Change random number generator seed: <br>
Usage: <code> seed [integer] </code> (ex: seed 191917) <br>
Use <code> seed -1 </code> to generate a seed automatically from the computer
time.
<br><br>

Use a truly random initial point for the minimization (the default
option is to generate an homogeneous-density initial): <br>
Usage: <code> randominitialpoint </code> <br><br>
Avoid, or not, overlap with fixed molecules at initial point
(avoiding this overlaps is generally recommended, but sometimes
generates gaps that are too large):<br>
Usage: <code> avoid_overlap yes/no </code> <br><br>
Change the maximum number of Gencan iterations per loop:<br> Usage: <code>
maxit [integer] </code> <br><br>

Change the maximum number of loops:<br>
Usage: <code> nloop [integer] </code><br><br>

Change the frequency of output file writing: <br>
Usage: <code> writeout [integer] </code><br><br>

Write the current point to output file even if it is worst than the the
best point so far (used for checking purposes only): <br>
Usage: <code> writebad </code><br><br>

Check the initial point: This is only for testing purposes,
just build the initial approximation, writes it to the output
file and exits. <br>
Usage: <code>check</code><br><br>

Change the optimization subroutine printing output: <br>
Usage: <code> iprint1 [integer] </code> and/or <code> iprint2 [integer]
</code><br>
where the integer must be 0, 1, 2 or 3.
<br><br>

Change the number of bins of the linked-cell method (technical): <br>
Usage: <code> fbins [real] </code> 
</code><br>
The default value is the square root of three.
<br><br>

Compare analytical and finite-difference gradients: This is only for
testing purposes. Writes chkgrad.log file containing the comparison.<br>
Usage: <code>chkgrad</code>
<br><br>
<!-- END SECTION -->

{:/nomarkdown}

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine that sets the sizes of all allocatable arrays
!

subroutine setsizes()

   use exit_codes
   use sizes
   use compute_data
   use input
   use usegencan
   use flashsort

   implicit none
   integer :: i, ival, ilast, iline, itype
   integer :: ioerr
   integer :: un
   integer :: strlength
   character(len=strl) :: record, blank, alltospace
   logical :: inside_structure

   ! Instructions on how to run packmol

   write(*,*) ' Packmol must be run with: packmol < inputfile.inp '
   write(*,*)
   write(*,*) ' Userguide at: http://m3g.iqm.unicamp.br/packmol '
   write(*,*)

   ! Getting input lines from the input file

   write(*,*) ' Reading input file... (Control-C aborts)'

   if (len(trim(input_file_name)) == 0) then
      un = 5
   else
      un = 100
      open(unit=un, file=trim(input_file_name), status="unknown", iostat=ioerr)
      if (ioerr /= 0) then
         write(*, *) "ERROR: file-open error with file: " // trim(input_file_name)
         stop exit_code_open_file
      end if
   end if

   do i = 1, strl
      blank(i:i) = ' '
   end do
   nlines = 0
   maxkeywords = 0
   ntype = 0
   do
      read(un,str_format,iostat=ioerr) record

      ! Replace any strange blank character by spaces
      record = alltospace(record)

      if ( ioerr /= 0 ) exit

      ! Remove comments
      i = 0
      do while( i < strl )
         i = i + 1
         if ( record(i:i) == '#' ) exit
      end do
      i = i - 1
      if ( i > 0 ) then
         record = record(1:i)//blank(i+1:strl)
      else
         cycle
      end if
      if ( strlength(record) < 1 ) cycle
      record = trim(record)

      !
      ! Convert file name paths with spaces to single strings
      !
      ! check for quotes and replace spaces by @
      call parse_spaces(record)

      ! Number of lines of the input file

      nlines = nlines + 1

      ! Check the number of keywords in this line

      i = 0
      ival = 0
      do while(i < strl)
         i = i + 1
         ilast = i
         do while(record(i:i) > ' ' .and. i < strl)
            i = i + 1
         end do
         if(i > ilast) then
            ival = ival + 1
            maxkeywords = max(maxkeywords,ival)
         end if
      end do
   end do
   rewind(un)

   allocate(inputfile(nlines),keyword(nlines,maxkeywords))

   ! Read input to inputfile array

   iline = 0
   do
      read(un,str_format,iostat=ioerr) record
      if ( ioerr /= 0 ) exit

      ! Convert all strange blank characters to spaces

      record = alltospace(record)
      call parse_spaces(record)

      ! Remove comments

      i = 0
      do while( i < strl )
         i = i + 1
         if ( record(i:i) == '#' ) exit
      end do
      i = i - 1
      if ( i > 0 ) then
         record = record(1:i)//blank(i+1:strl)
      else
         cycle
      end if
      if ( strlength(record) < 1 ) cycle

      iline = iline + 1
      inputfile(iline) = record
   end do

   ! Read all keywods into keyword array

   call getkeywords()

   ! Checking the filetype of coordinate files (default is pdb)

   tinker = .false.
   pdb = .false.
   xyz = .false.
   fbins = dsqrt(3.d0)
   do i = 1, nlines
      if(keyword(i,1).eq.'filetype') then
         if(keyword(i,2).eq.'tinker') tinker = .true.
         if(keyword(i,2).eq.'pdb') pdb = .true.
         if(keyword(i,2).eq.'xyz') xyz = .true.
         write(*,*)' Types of coordinate files specified: ', trim(keyword(i,2))
      end if
      if(keyword(i,1).eq.'fbins') then
         record = keyword(i,2)
         read(record,*,iostat=ioerr) fbins
         if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Invalid value for fbins. '
            stop exit_code_input_error
         end if
      end if
   end do
   if(.not.pdb.and..not.tinker.and..not.xyz) then
      pdb = .true.
      write(*,*)
      write(*,*)' WARNING: File type not (correctly?) specified, using PDB'
   end if

   ! Getting the number of different types of molecules

   ntype = 0
   do iline = 1, nlines
      if ( keyword(iline,1) == "structure" ) then
         ntype = ntype + 1
         if ( keyword(iline,2) == "none" ) then
            write(*,*) ' ERROR: structure without filename. '
            write(*,*) ' The syntax must be, for example: structure water.pdb '
            stop exit_code_input_error
         end if
      end if
   end do

   allocate(nmols(ntype),natoms(ntype),idfirst(ntype),constrain_rot(ntype,3),&
      rot_bound(ntype,3,2),dmax(ntype),&
      comptype(ntype),compsafe(ntype),&
      restart_from(0:ntype),restart_to(0:ntype),&
      nloop_type(ntype),nloop0_type(ntype))

   ! Reading the number of molecules of each type, and the number of atoms
   ! of each molecule type

   itype = 0
   inside_structure = .false.
   do iline = 1, nlines
      if ( keyword(iline,1) == "structure" ) then
         inside_structure = .true.
         itype = itype + 1
         natoms(itype) = 0
         nmols(itype) = 0
         nloop_type(itype) = 0
         nloop0_type(itype) = 0

         ! Read the number of atoms of this type of molecule

         open(10,file=keyword(iline,2),status='old',iostat=ioerr)
         if( ioerr /= 0 ) call failopen(keyword(iline,2))
         if ( pdb ) then
            do
               read(10,str_format,iostat=ioerr) record
               if ( ioerr /= 0 ) exit
               if ( record(1:4) == "ATOM" .or. record(1:6) == "HETATM" ) then
                  natoms(itype) = natoms(itype) + 1
               end if
            end do
         end if
         if ( tinker ) then
            do
               read(10,*,iostat=ioerr) i
               if ( ioerr /= 0 ) cycle
               natoms(itype) = i
               exit
            end do
         end if
         if ( xyz ) then
            read(10,*,iostat=ioerr) i
            if ( ioerr == 0 ) natoms(itype) = i
         end if
         close(10)
         if ( natoms(itype) == 0 ) then
            write(*,*) ' ERROR: Could not read any atom from file: ', &
               trim(adjustl(keyword(iline,2)))
            stop exit_code_input_error
         end if

      end if

      if ( keyword(iline,1) == "end" .and. &
         keyword(iline,2) == "structure" ) inside_structure = .false.

      ! Read number of molecules for each type

      if ( keyword(iline,1) == "number" ) then
         read(keyword(iline,2),*,iostat=ioerr) nmols(itype)
         if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Error reading number of molecules of type ', itype
            stop exit_code_input_error
         end if
         if ( nmols(itype) < 1 ) then
            write(*,*) ' ERROR: Number of molecules of type ', itype, ' set to less than 1 '
            stop exit_code_input_error
         end if
      end if

      ! Read the (optional) number of gencan loops for this molecule

      if ( keyword(iline,1) == "nloop" ) then
         if ( inside_structure ) then
            read(keyword(iline,2),*,iostat=ioerr) nloop_type(itype)
            if ( ioerr /= 0 ) then
               write(*,*) ' ERROR: Error reading number of loops of type ', itype
               stop exit_code_input_error
            end if
            if ( nloop_type(itype) < 1 ) then
               write(*,*) ' ERROR: Number of loops of type ', itype, ' set to less than 1 '
               stop exit_code_input_error
            end if
         end if
      end if

      ! Read the (optional) number of gencan loops for initial setup for this molecule

      if ( keyword(iline,1) == "nloop0" ) then
         if ( inside_structure ) then
            read(keyword(iline,2),*,iostat=ioerr) nloop0_type(itype)
            if ( ioerr /= 0 ) then
               write(*,*) ' ERROR: Error reading number of loops-0 of type ', itype
               stop exit_code_input_error
            end if
            if ( nloop0_type(itype) < 1 ) then
               write(*,*) ' ERROR: Number of loops-0 of type ', itype, ' set to less than 1 '
               stop exit_code_input_error
            end if
         end if
      end if

   end do
   do itype = 1, ntype
      if ( nmols(itype) == 0 ) then
         write(*,*) ' Warning: Number of molecules not set for type '&
            ,itype,': assuming 1 '
         nmols(itype) = 1
      end if
   end do

   ! Total number of atoms and molecules

   ntotat = 0
   ntotmol = 0
   do itype = 1, ntype
      ntotat = ntotat + nmols(itype)*natoms(itype)
      ntotmol = ntotmol + nmols(itype)
   end do

   ! The number of variables of the problem
   nn = ntotmol*6

   ! Checking the total number of restrictions defined
   i = 0
   do iline = 1, nlines
      if ( keyword(iline,1) == 'fixed' .or. &
         keyword(iline,1) == 'inside' .or. &
         keyword(iline,1) == 'outside' .or. &
         keyword(iline,1) == 'over' .or. &
         keyword(iline,1) == 'above' .or. &
         keyword(iline,1) == 'below' .or. &
         keyword(iline,1) == 'constrain_rotation' .or. &
         keyword(iline,1) == 'pbc') then
         i = i + 1
      end if
   end do
   maxrest = i
   mrperatom = i

   ! Allocate arrays depending on ntotat, nn, maxrest, and mrperatom

   allocate(nratom(ntotat),iratom(ntotat,mrperatom),ibmol(ntotat),&
      ibtype(ntotat),xcart(ntotat,3),coor(ntotat,3),&
      radius(ntotat),radius_ini(ntotat),fscale(ntotat),&
      use_short_radius(ntotat), short_radius(ntotat), short_radius_scale(ntotat),&
      gxcar(ntotat,3),&
      latomnext(ntotat),&
      fdist_atom(ntotat), frest_atom(ntotat),&
      fmol(ntotat),radiuswork(ntotat),&
      fixedatom(ntotat))
   allocate(ityperest(maxrest),restpars(maxrest,9))
   allocate(xmol(nn))

   ! Allocate other arrays used for input and output data

   allocate(nconnect(ntotat,9),maxcon(ntotat),&
      amass(ntotat),charge(ntotat),ele(ntotat))

   allocate(irestline(maxrest),linestrut(ntype,2),resnumbers(ntype),&
      input_itype(ntype),changechains(ntype),chain(ntype),&
      fixedoninput(ntype),pdbfile(ntype),name(ntype),&
      segid(ntype),maxmove(ntype),connect(ntype))

   ! Allocate vectors for flashsort

   allocate(indflash(ntotat),lflash(ntotat))

   ! Allocate arrays for GENCAN

   allocate(l(nn),u(nn),wd(8*nn),wi(nn),g(nn))

   if (un /= 5) then
      close(un)
   end if

end subroutine setsizes

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
!  Module that contains the temporary data for swap molecules
!  for individual packing
!

module swaptypemod

   integer :: ntemp, ntottemp
   double precision, allocatable :: xfull(:) ! (nn)

end module swaptypemod

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine output: Subroutine that writes the output file
!

subroutine output(n, x, output_file_name)

   use exit_codes
   use sizes
   use compute_data
   use input
   use pbc

   implicit none
   integer :: n, k, i, ilugan, ilubar, itype, imol, idatom,&
      iimol, ichain, iatom, irec, ilres, ifres,&
      iires, ciires, irescount,&
      icart, i_ref_atom, ioerr, ifirst_mol
   integer :: nres, imark
   integer :: i_fixed, i_not_fixed

   double precision :: x(n)
   double precision :: v1(3), v2(3), v3(3)
   double precision :: xcm(3), beta, gama, teta 

   character :: write_chain, even_chain, odd_chain
   character(len=64) :: title
   character(len=strl) :: pdb_atom_line, tinker_atom_line, crd_format
   character(len=8) :: crdires,crdresn,crdsegi,atmname
   character(len=strl) :: record
   character(len=strl) :: output_file_name
   character(len=5) :: i5hex
   character(len=4) :: i4hex

   ! Job title

   title = ' Built with Packmol '

   !
   ! Write restart files, if required
   !

   ! Restart file for all system

   if ( restart_to(0) /= 'none' ) then
      record = restart_to(0)
      open(10,file=restart_to(0),iostat=ioerr)
      if ( ioerr /= 0 ) then
         write(*,*) ' ERROR: Could not open restart_to file: ', trim(adjustl(record))
         stop exit_code_open_file
      end if
      ilubar = 0
      ilugan = ntotmol*3
      do i = 1, ntotmol
         write(10,"(6(tr1,es23.16))") x(ilubar+1:ilubar+3), x(ilugan+1:ilugan+3)
         ilubar = ilubar + 3
         ilugan = ilugan + 3
      end do
      close(10)
      write(*,*) ' Wrote restart file for all system: ', trim(adjustl(record))
   end if

   ! Restart files for specific molecule types

   ilubar = 0
   ilugan = ntotmol*3
   do itype = 1, ntype
      if ( restart_to(itype) /= 'none' ) then
         record = restart_to(itype)
         open(10,file=record,iostat=ioerr)
         if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Could not open restart_to file: ', trim(adjustl(record))
            stop exit_code_open_file
         end if
         do i = 1, nmols(itype)
            write(10,"(6(tr1,es23.16))") x(ilubar+1:ilubar+3), x(ilugan+1:ilugan+3)
            ilubar = ilubar + 3
            ilugan = ilugan + 3
         end do
         close(10)
         write(*,*) ' Wrote restart file: ', trim(adjustl(record))
      else
         ilubar = ilubar + nmols(itype)*3
         ilugan = ilugan + nmols(itype)*3
      end if
   end do

   ! Write the output (xyz file)

   if(xyz) then
      open(30,file=output_file_name,status='unknown')
      write(30,*) ntotat
      write(30,*) title
      ilubar = 0
      ilugan = ntotmol*3
      icart = 0
      i_not_fixed = 0
      i_fixed = ntype
      do itype = 1, ntype_with_fixed
         if ( .not. fixedoninput(itype) ) then
            i_not_fixed = i_not_fixed + 1
            do imol = 1, nmols(i_not_fixed)
               xcm = x(ilubar+1:ilubar+3)
               beta = x(ilugan+1)
               gama = x(ilugan+2)
               teta = x(ilugan+3)
               call eulerrmat(beta,gama,teta,v1,v2,v3)
               idatom = idfirst(i_not_fixed) - 1
               do iatom = 1, natoms(i_not_fixed)
                  icart = icart + 1
                  idatom = idatom + 1
                  call compcart(xcart(icart,1:3),xcm,coor(idatom,1:3),v1,v2,v3)
                  write(30,"( tr2,a3,tr2,3(tr2,f14.6) )") ele(idatom), xcart(icart, 1:3)
               end do
               ilugan = ilugan + 3
               ilubar = ilubar + 3
            end do
         else
            i_fixed = i_fixed + 1
            idatom = idfirst(i_fixed) - 1
            do iatom = 1, natoms(i_fixed)
               idatom = idatom + 1
               write(30,"( tr2,a3,tr2,3(tr2,f14.6) )") ele(idatom), coor(idatom,1:3)
            end do
         end if
      end do
      close(30)
   end if

   ! write the output as pdb file
   if(pdb) then
      pdb_atom_line = "( t1,a6,t7,a5,t12,a10,t22,a1,t23,&
      &a4,t27,a1,t31,f8.3,t39,f8.3,t47,&
      &f8.3,t55,a26 )"
      crd_format='(2I10,2X,A8,2X,A8,3F20.10,2X,A8,2X,A8,F20.10)'

      open(30,file=output_file_name,status='unknown')
      if ( crd ) then
         open(40,file=crdfile,status='unknown')
         write(40,'("* TITLE ", a64,/&
         &"* Packmol generated CHARMM CRD File",/&
         &"* Home-Page:",/&
         &"* http://m3g.iqm.unicamp.br/packmol",/&
         &"* ")') title
         write(40,'(i10,2x,a)') ntotat,'EXT'
      end if

      write(30,"( &
      &'HEADER ',/&
      &'TITLE    ', a64,/&
      &'REMARK   Packmol generated pdb file ',/&
      &'REMARK   Home-Page: ',&
      &'http://m3g.iqm.unicamp.br/packmol',/,&
      &'REMARK' )" ) title

      if (hexadecimal_indices) then
          write(30,"(a)") 'REMARK  Atom and residue indices are in hexadecimal format.'
          write(30,"(a)") 'REMARK'
      end if

      if(add_box_sides .or. using_pbc) then
         if(.not.using_pbc) then
            write(30,"('REMARK  CRYST1 info below is (extrema(coordinates) +/- 1.1*tolerance) because no explicit')")
            write(30,"('REMARK  PBCs were defined. To apply PBCs, use the `pbc` keyword.')")
         end if
         write(30,"( 'CRYST1',t7,f9.2,t16,f9.2,t25,f9.2,t34,f7.2,t41,f7.2,t48,f7.2,t56,'P 1           1' )") &
            pbc_max-pbc_min, 90., 90., 90.
      end if

      ilubar = 0
      ilugan = ntotmol*3
      icart = 0
      i_ref_atom = 0
      iimol = 0
      ichain = 0
      i_not_fixed = 0
      i_fixed = ntype
      irescount = 1
      do itype = 1, ntype_with_fixed
         if ( .not. fixedoninput(itype) ) then
            i_not_fixed = i_not_fixed + 1

            ! Counting the number of residues of this molecule

            open(15,file=pdbfile(i_not_fixed),status='old')
            ifres = 0
            do
               read(15,str_format,iostat=ioerr) record
               if ( ioerr /= 0 ) exit
               if ( record(1:4).eq.'ATOM'.or.record(1:6).eq.'HETATM' ) then
                  read(record(23:26),*,iostat=ioerr) imark
                  if ( ioerr /= 0 ) then
                     record = pdbfile(i_not_fixed)
                     write(*,*) ' ERROR: Failed reading residue number ',&
                        ' from PDB file: ', trim(adjustl(record))
                     write(*,*) ' Residue numbers are integers that must',&
                        ' be between columns 23 and 26. '
                     write(*,*) ' Other characters within these columns',&
                        ' will cause input/output errors. '
                     write(*,*) ' Standard PDB format specifications can',&
                        ' be found at: '
                     write(*,*) ' www.rcsb.org/pdb '
                     stop exit_code_input_error
                  end if
                  if ( ifres .eq. 0 ) ifres = imark
                  ilres = imark
               end if
            end do
            nres = ilres - ifres + 1

            do irec = 1, strl
               record(irec:irec) = ' '
            end do

            mol: do imol = 1, nmols(i_not_fixed)
               iimol = iimol + 1

               if( chain(i_not_fixed) == "#" ) then
                  if(imol.eq.1.or.mod(imol,9999).eq.1) then
                     ichain = ichain + 1
                     if( changechains(i_not_fixed) ) then
                        call chainc(ichain,odd_chain)
                        ichain = ichain + 1
                        call chainc(ichain,even_chain)
                     else
                        call chainc(ichain,even_chain)
                        odd_chain = even_chain
                     end if
                  end if
                  if ( mod(imol,2) == 0 ) write_chain = even_chain
                  if ( mod(imol,2) /= 0 ) write_chain = odd_chain
               else
                  write_chain = chain(i_not_fixed)
               end if

               xcm = x(ilubar+1:ilubar+3)
               beta = x(ilugan+1)
               gama = x(ilugan+2)
               teta = x(ilugan+3)
               call eulerrmat(beta,gama,teta,v1,v2,v3)

               rewind(15)
               idatom = idfirst(i_not_fixed) - 1
               iatom = 0
               do while(iatom.lt.natoms(i_not_fixed))

                  read(15,str_format,iostat=ioerr) record
                  if ( ioerr /= 0 ) exit mol
                  if(record(1:4).ne.'ATOM'.and.record(1:6).ne.'HETATM') then
                     if(amber_ter_preserve .and. record(1:3).eq.'TER') then
                        write(30,"('TER')")
                     end if
                     cycle
                  end if

                  iatom = iatom + 1
                  icart = icart + 1
                  idatom = idatom + 1
                  i_ref_atom = i_ref_atom + 1
                  call compcart(xcart(icart,1:3),xcm,coor(idatom,1:3),v1,v2,v3)

                  ! Setting residue numbers for this molecule

                  imark = 0
                  read(record(23:26),*,iostat=ioerr) imark
                  if ( ioerr /= 0 ) imark = 1
                  if(resnumbers(i_not_fixed).eq.0) then
                     iires = mod(imol,9999)
                     ciires = mod(imol,99999999)
                  else if(resnumbers(i_not_fixed).eq.1) then
                     iires = imark
                     ciires = imark
                  else if(resnumbers(i_not_fixed).eq.2) then
                     iires = mod(imark-ifres+irescount,9999)
                     ciires = mod(imark-ifres+irescount,99999999)
                  else if(resnumbers(i_not_fixed).eq.3) then
                     iires = mod(iimol,9999)
                     ciires = mod(iimol,99999999)
                  end if
                  if(iires.eq.0) iires = 9999
                  if(ciires.eq.0) ciires = 99999999

                  ! Writing output line
                  if(record(1:4).eq.'ATOM') then
                     write(30,pdb_atom_line) "ATOM  ", i5hex(i_ref_atom),&
                        record(12:21), write_chain, i4hex(iires),&
                        record(27:27),&
                        xcart(icart,1:3),&
                        record(55:80)
                  end if
                  if(record(1:6).eq.'HETATM') then
                     write(30,pdb_atom_line) "HETATM", i5hex(i_ref_atom),&
                        record(12:21), write_chain, i4hex(iires),&
                        record(27:27),&
                        xcart(icart,1:3),&
                        record(55:80)
                  end if

                  if ( crd ) then
                     write(crdires,'(I8)') ciires
                     crdires = adjustl(crdires)
                     crdresn = trim(adjustl(record(18:21)))
                     crdsegi = crdresn
                     if (len(trim(adjustl(segid(i_not_fixed))))/=0) crdsegi = trim(adjustl(segid(i_not_fixed)))
                     atmname = adjustl(record(13:16))
                     write(40,crd_format) i_ref_atom, ciires,crdresn, atmname, &
                        (xcart(icart,k), k = 1, 3), crdsegi,&
                        crdires, 0.
                  end if

               end do
               irescount = irescount + nres
               ilugan = ilugan + 3
               ilubar = ilubar + 3

               if(add_amber_ter) write(30,"('TER')")
            end do mol
            close(15)

            ! If fixed molecule on input:
         else
            i_fixed = i_fixed + 1

            ! Counting the number of residues of this molecule

            open(15,file=pdbfile(i_fixed),status='old')
            ifres = 0
            do
               read(15,str_format,iostat=ioerr) record
               if ( ioerr /= 0 ) exit
               if ( record(1:4).eq.'ATOM'.or.record(1:6).eq.'HETATM' ) then
                  read(record(23:26),*,iostat=ioerr) imark
                  if ( ioerr /= 0 ) then
                     record = pdbfile(i_not_fixed)
                     write(*,*) ' ERROR: Failed reading residue number ',&
                        ' from PDB file: ', trim(adjustl(record))
                     write(*,*) ' Residue numbers are integers that must',&
                        ' be between columns 23 and 26. '
                     write(*,*) ' Other characters within these columns',&
                        ' will cause input/output errors. '
                     write(*,*) ' Standard PDB format specifications can',&
                        ' be found at: '
                     write(*,*) ' www.rcsb.org/pdb '
                     stop exit_code_input_error
                  end if
                  if ( ifres .eq. 0 ) ifres = imark
                  ilres = imark
               end if
            end do
            nres = ilres - ifres + 1

            iimol = iimol + 1
            idatom = idfirst(i_fixed) - 1

            rewind(15)
            iatom = 0
            do while(iatom.lt.natoms(i_fixed))

               read(15,str_format,iostat=ioerr) record
               if ( ioerr /= 0 ) exit
               if(record(1:4).ne.'ATOM'.and.record(1:6).ne.'HETATM') then
                  if(amber_ter_preserve .and. record(1:3).eq.'TER') then
                     write(30,"('TER')")
                  end if
                  !write(30,"( a80 )") record(1:80)
                  cycle
               end if

               iatom = iatom + 1
               idatom = idatom + 1
               i_ref_atom = i_ref_atom + 1

               read(record(23:26),*) imark
               if(resnumbers(i_fixed).eq.0) then
                  iires = 1
                  ciires = 1
               else if(resnumbers(i_fixed).eq.1) then
                  iires = imark
                  ciires = imark
               else if(resnumbers(i_fixed).eq.2) then
                  iires = mod(imark-ifres+irescount,9999)
                  ciires = mod(imark-ifres+irescount,99999999)
               else if(resnumbers(i_fixed).eq.3) then
                  iires = mod(iimol,9999)
                  ciires = mod(iimol,99999999)
               end if

               if ( chain(i_fixed) == "#" ) then
                  write_chain = record(22:22)
               else
                  write_chain = chain(i_fixed)
               end if

               if(record(1:4).eq.'ATOM') then
                  write(30,pdb_atom_line) "ATOM  ", i5hex(i_ref_atom),&
                     record(12:21), write_chain, i4hex(iires),&
                     record(27:27),&
                     coor(idatom,1:3),&
                     record(55:80)
               end if
               if(record(1:6).eq.'HETATM') then
                  write(30,pdb_atom_line) "HETATM", i5hex(i_ref_atom),&
                     record(12:21), write_chain, i4hex(iires),&
                     record(27:27),&
                     coor(idatom,1:3),&
                     record(55:80)
               end if

               if ( crd ) then
                  write(crdires,'(I8)') ciires
                  crdires = adjustl(crdires)
                  crdresn = trim(adjustl(record(18:21)))
                  crdsegi = crdresn
                  if (len(trim(adjustl(segid(i_fixed))))/=0) crdsegi = trim(adjustl(segid(i_fixed)))
                  atmname = adjustl(record(13:16))
                  write(40,crd_format) i_ref_atom, iires,crdresn, atmname, xcart(icart,1:3), crdsegi, crdires, 0.
               end if

            end do
            irescount = irescount + nres
            close(15)
            if(add_amber_ter) write(30,"('TER')")
         end if
      end do
      !
      ! Write connectivity if available
      !
      i_ref_atom = 0
      i_not_fixed = 0
      i_fixed = ntype
      do itype = 1, ntype_with_fixed
         if ( .not. fixedoninput(itype) ) then
            i_not_fixed = i_not_fixed + 1
            idatom = idfirst(i_not_fixed) - 1
            do imol = 1, nmols(i_not_fixed)
               iatom = 0
               ifirst_mol = i_ref_atom + 1
               do while(iatom.lt.natoms(i_not_fixed))
                  iatom = iatom + 1
                  i_ref_atom = i_ref_atom + 1
                  if(.not. ignore_conect .and. connect(itype)) then
                     call write_connect(30,idatom,iatom,ifirst_mol)
                  end if
               end do
            end do
            close(15)
            ! If fixed molecule on input:
         else
            i_fixed = i_fixed + 1
            idatom = idfirst(i_fixed) - 1
            iatom = 0
            ifirst_mol = i_ref_atom + 1
            idatom = idfirst(i_fixed) - 1
            do while(iatom.lt.natoms(i_fixed))
               iatom = iatom + 1
               i_ref_atom = i_ref_atom + 1
               if(.not. ignore_conect .and. connect(itype)) then
                  call write_connect(30,idatom,iatom,ifirst_mol)
               end if
            end do
         end if
      end do
      write(30,"('END')")
      close(30)
      if ( crd ) close(40)
   end if

   ! Write the output (tinker xyz file)

   if(tinker) then

      tinker_atom_line = "( i7,tr2,a3,3(tr2,f10.6),9(tr2,i7) )"

      open(30, file = output_file_name,status='unknown')

      write(30,"( i6,tr2,a64 )") ntotat, title

      ilubar = 0
      ilugan = ntotmol*3
      icart = 0
      i_ref_atom = 0
      i_not_fixed = 0
      i_fixed = ntype

      do itype = 1, ntype_with_fixed

         if ( .not. fixedoninput(itype) ) then
            i_not_fixed = i_not_fixed + 1

            do imol = 1, nmols(i_not_fixed)

               xcm = x(ilubar+1:ilubar+3)
               beta = x(ilugan+1)
               gama = x(ilugan+2)
               teta = x(ilugan+3)

               call eulerrmat(beta,gama,teta,v1,v2,v3)

               idatom = idfirst(i_not_fixed) - 1
               do iatom = 1, natoms(i_not_fixed)
                  icart = icart + 1
                  idatom = idatom + 1
                  call compcart(xcart(icart,1:3),xcm,coor(idatom,1:3),v1,v2,v3)
                  ntcon(1) = nconnect(idatom,1)
                  ntcon(2:maxcon(idatom)) = nconnect(idatom,2:maxcon(idatom)) + i_ref_atom
                  write(30,tinker_atom_line) i_ref_atom+iatom, ele(idatom), xcart(icart, 1:3), ntcon(1:maxcon(idatom))
               end do
               i_ref_atom = i_ref_atom + natoms(i_not_fixed)

               ilugan = ilugan + 3
               ilubar = ilubar + 3

            end do

         else

            i_fixed = i_fixed + 1
            idatom = idfirst(i_fixed) - 1
            do iatom = 1, natoms(i_fixed)
               idatom = idatom + 1
               ntcon(1) = nconnect(idatom,1)
               do k = 2, maxcon(idatom)
                  ntcon(k) = nconnect(idatom,k) + i_ref_atom
               end do
               write(30,tinker_atom_line) i_ref_atom+iatom, ele(idatom), coor(idatom,1:3), ntcon(1:maxcon(idatom))
            end do
            i_ref_atom = i_ref_atom + natoms(i_fixed)

         end if

      end do
      close(30)
   end if

   return
end subroutine output

function i5hex(i)
   use input, only: hexadecimal_indices
   implicit none
   integer :: i
   character(len=5) i5hex
   if(hexadecimal_indices .or. i > 99999) then
      write(i5hex,"(z5)") i
   else
      write(i5hex,"(i5)") i
   end if
end

function i4hex(i)
   use input, only: hexadecimal_indices
   implicit none
   integer :: i
   character(len=4) i4hex
   if(hexadecimal_indices .or. i > 9999) then
      write(i4hex,"(z4)") i
   else
      write(i4hex,"(i4)") i
   end if
end

subroutine write_connect(iostream,idatom,iatom,ifirst)
   use sizes
   use input
   implicit none
   integer :: iostream, iatom, idatom, ifirst, iiat, icon
   character(len=5) :: i5hex, idatom_i5hex, str_conat
   character(len=strl) :: str
   iiat = iatom + idatom
   if(maxcon(iiat) == 0) return
   idatom_i5hex = i5hex(iatom+ifirst-1)
   icon = 1
   ! start CONECT line
   write(str, "(a7,a5)") "CONECT", idatom_i5hex
   do 
      str_conat = i5hex(nconnect(iiat,icon)+ifirst-1)
      ! finish CONECT line
      if (icon >= maxcon(iiat)) then
         write(str, "(a,a5)") trim(str), str_conat
         write(iostream, "(a)") trim(adjustl(str))
         exit
      end if
      ! Next atom in CONECT line (for a maximum of 4, must be in increasing order)
      if (nconnect(iiat,icon+1) > nconnect(iiat,icon) .and. mod(icon,5) /= 0) then
         write(str, "(a,a5)") trim(str), str_conat
      else
         ! finish connect line
         write(str, "(a,a5)") trim(str), str_conat
         write(iostream, "(a)") trim(adjustl(str))
         ! Start a new CONECT line
         write(str, "(a7,a5)") "CONECT", idatom_i5hex
      end if
      icon = icon + 1
   end do
end subroutine write_connect

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Function that computes the atom-to-atom component of the objective
! function
!

double precision function fparc(icart,firstjcart)

   use sizes
   use compute_data
   use pbc, only : delta_vector, pbc_length
   implicit none

   ! SCALAR ARGUMENTS
   integer, intent(in) :: icart,firstjcart

   ! LOCAL SCALARS
   integer :: jcart
   double precision :: datom, tol, short_tol, short_tol_penalty, short_tol_scale
   double precision :: vdiff(3)

   fparc = 0.0d0
   jcart = firstjcart
   do while ( jcart > 0 )
      !
      ! Cycle if this type is not to be computed
      !
      if ( .not. comptype(ibtype(jcart))) then
         jcart = latomnext(jcart)
         cycle
      end if
      !
      ! Cycle if the atoms are from the same molecule
      !
      if ( ibmol(icart) == ibmol(jcart) .and. &
         ibtype(icart) == ibtype(jcart) ) then
         jcart = latomnext(jcart)
         cycle
      end if
      !
      ! Cycle if both atoms are from fixed molecules
      !
      if ( fixedatom(icart) .and. fixedatom(jcart) ) then
         jcart = latomnext(jcart)
         cycle
      end if
      !
      ! Otherwise, compute distance and evaluate function for this pair
      !
      vdiff = delta_vector(xcart(icart,:), xcart(jcart,:), pbc_length)
      datom = ( vdiff(1) )**2 + ( vdiff(2) )**2 + ( vdiff(3) )**2
      tol = (radius(icart)+radius(jcart))**2
      if ( datom < tol ) then
         fparc = fparc + fscale(icart)*fscale(jcart)*(datom-tol)**2
         if ( use_short_radius(icart) .or. use_short_radius(jcart) ) then
            short_tol = (short_radius(icart)+short_radius(jcart))**2
            if ( datom < short_tol ) then
               short_tol_penalty = datom-short_tol
               short_tol_scale = dsqrt(short_radius_scale(icart)*short_radius_scale(jcart))
               short_tol_scale = short_tol_scale*(tol**2/short_tol**2)
               fparc = fparc + fscale(icart)*fscale(jcart)*short_tol_scale*short_tol_penalty**2
            end if
         end if
      end if
      tol = (radius_ini(icart)+radius_ini(jcart))**2
      fdist = dmax1(tol-datom,fdist)
      if ( move ) then
         fdist_atom(icart) = dmax1(tol-datom,fdist_atom(icart))
         fdist_atom(jcart) = dmax1(tol-datom,fdist_atom(jcart))
      end if
      jcart = latomnext(jcart)
   end do

end function fparc

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Function that determines the length of a string (better than
! intrinsic "len" because considers tabs as empty characters)
!
function strlength(string)

   use sizes
   implicit none
   integer :: strlength
   character(len=strl) :: string
   logical empty_char

   strlength = strl
   do while(empty_char(string(strlength:strlength)))
      strlength = strlength - 1
      if ( strlength == 0 ) exit
   end do

end function strlength

!
! Function that determines if a character is empty (empty, space, or tab)
! (nice suggestion from Ian Harvey -IanH0073- at github)
!

function empty_char(ch)
   character :: ch
   logical empty_char
   empty_char = .false.
   if ( ch == '' .or. &
      ch == achar(9) .or. &
      ch == achar(32) ) then
      empty_char = .true.
   end if
end function empty_char

!
! Function that replaces all non-space empty characters by spaces
!

function alltospace(record)

   use sizes
   implicit none
   integer :: i
   logical :: empty_char
   character(len=strl) :: alltospace, record

   do i = 1, strl
      if ( empty_char(record(i:i)) ) then
         alltospace(i:i) = " "
      else
         alltospace(i:i) = record(i:i)
      end if
   end do

end function alltospace

subroutine parse_spaces(record)
   use exit_codes
   use input, only : forbidden_char
   use sizes
   implicit none
   integer :: i, strlength
   character(len=strl) :: record
   ! Replace spaces within quotes by ~
   i = 0
   do while(i < strlength(record))
      i = i + 1
      if ( record(i:i) == '"' ) then
         i = i + 1
         do while(record(i:i) /= '"')
            i = i + 1
            if( i > strlength(record) ) then
               write(*,*) ' ERROR: Could not find ending quotes in line: ', trim(record)
               stop exit_code_input_error
            end if
            if(record(i:i) == " ") then
               record(i:i) = forbidden_char
            end if
         end do
      end if
   end do
   ! Replace spaces after \ by the forbidden_char and remove the \
   i = 0
   do while(i < strlength(record)-1)
      i = i + 1
      if (record(i:i) == "\" .and. record(i+1:i+1) == " ") then
         record(i:i) = forbidden_char
         record = record(1:i)//record(i+2:strlength(record))
      end if
   end do
end

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
module compute_data

   use sizes

   integer :: ntotmol, ntype, nfixedat, ntotat
   integer :: ncells(3)

   integer, allocatable :: nmols(:) ! (ntype)
   integer, allocatable :: natoms(:) ! (ntype)
   integer, allocatable :: idfirst(:) ! (ntype)
   integer, allocatable :: nratom(:) ! (ntotat)
   integer, allocatable :: iratom(:,:) ! (ntotat,mrperatom)
   integer, allocatable :: ityperest(:) ! (maxrest)
   integer, allocatable :: ibmol(:) ! (ntotat)
   integer, allocatable :: ibtype(:) ! (ntotat)

   double precision :: scale, scale2
   double precision :: fdist, frest
   double precision :: sizemin(3), sizemax(3)
   double precision :: cell_length(3), system_length(3)
   double precision :: radmax

   double precision, allocatable :: xcart(:,:) ! (ntotat,3)
   double precision, allocatable :: coor(:,:) ! (ntotat,3)
   double precision, allocatable :: restpars(:,:) ! (maxrest,9)
   double precision, allocatable :: rot_bound(:,:,:) ! (ntype,3,2)
   double precision, allocatable :: radius(:), radius_ini(:), fscale(:) ! (ntotat)
   double precision, allocatable :: short_radius(:), short_radius_scale(:) ! ntotat
   double precision, allocatable :: gxcar(:,:) ! (ntotat,3)

   double precision, allocatable :: fdist_atom(:), frest_atom(:) ! (ntotat)
   double precision, allocatable :: dmax(:) ! (ntype)

   logical, allocatable :: constrain_rot(:,:) ! (ntype,3)
   logical, allocatable :: comptype(:) ! (ntype)
   logical, allocatable :: fixedatom(:) ! (ntotat)
   logical, allocatable :: use_short_radius(:) ! ntotat
   logical :: init1, move

   ! For linked lists
   integer, allocatable :: latomnext(:) ! (ntotat)
   integer, allocatable :: latomfirst(:,:,:) !  (ncells(1),ncells(2),ncells3))
   integer, allocatable :: latomfix(:,:,:) ! (ncells(1),ncells(2),ncells(3))

   ! For movebad
   double precision, allocatable :: fmol(:), radiuswork(:) ! (ntotat)

   ! For restmol
   double precision, allocatable :: xmol(:) ! (nn)
   logical, allocatable :: compsafe(:) ! (ntype)

   ! For cells with atoms linked lists
   integer :: lcellfirst
   integer, allocatable :: lcellnext(:) ! (ncells(1)*ncells(2)*ncells(3))
   logical, allocatable :: empty_cell(:,:,:) ! (ncells(1),ncells(2),ncells(3))

end module compute_data

!  
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!  
!
! sizes.i: Define the maximum dimensions of the problems
!
!   maxrest:     Maximum number of restrictions
!   mrperatom:   Maximum number of restrictions per atom
!   maxtry:      Number of tries for building the initial point  
!   nbp:         Maximum number of boxes for fast function evaluation (nbp**3)
!   nn:          Maximum number of variables 
!                (at least the number of molecules*6)
!   maxkeywords: Maximum number of keywords in input file
!

module sizes

  integer :: maxrest  
  integer :: mrperatom
  integer :: maxtry   
  integer :: nbp      
  integer :: nn       
  integer :: maxkeywords

end module sizes

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine getinp: subroutine that reads the input file
!

subroutine getinp()

   use exit_codes
   use sizes
   use compute_data, only : ntype, natoms, idfirst, nmols, ityperest, coor, restpars
   use input
   use usegencan
   use pbc

   implicit none
   integer :: i, k, ii, iarg, iline, idatom, iatom, in, irest, itype, itest,&
      imark, ioerr, nloop0, iread, idfirstatom
   double precision :: clen
   character(len=strl) :: record, blank
   logical :: inside_structure

   ! Clearing the blank character arrays

   do i = 1, strl
      blank(i:i) = ' '
   end do

   ! Getting random seed and optional optimization parameters if set

   seed = 1234567
   randini = .false.
   check = .false.
   chkgrad = .false.
   iprint1 = 2
   iprint2 = 2
   discale = 1.1d0
   writeout = 10
   maxit = 20
   nloop = 0
   nloop0 = 0
   movefrac = 0.05
   movebadrandom = .false.
   disable_movebad = .false.
   precision = 1.d-2
   writebad = .false.
   add_amber_ter = .false.
   amber_ter_preserve = .false.
   add_box_sides = .false.
   add_sides_fix = 0.d0
   sidemax = 1000.d0
   ioerr = 0
   avoidoverlap = .true.
   packall = .false.
   use_short_tol = .false.
   crd = .false.
   hexadecimal_indices = .false.
   inside_structure = .false.
   ignore_conect = .false.
   non_standard_conect = .true.

   do i = 1, nlines

      if ( keyword(i,1).eq.'structure') inside_structure = .true.
      if ( keyword(i,1).eq.'end' .and. &
         keyword(i,2).eq.'structure') inside_structure = .false.

      if(keyword(i,1).eq.'seed') then
         read(keyword(i,2),*,iostat=ioerr) seed
         if ( ioerr /= 0 ) exit
         if ( seed == -1 ) call seed_from_time(seed)
      else if(keyword(i,1).eq.'randominitialpoint') then
         randini = .true.
      else if(keyword(i,1).eq.'check') then
         check = .true.
      else if(keyword(i,1).eq.'writebad') then
         writebad = .true.
      else if(keyword(i,1).eq.'ignore_conect') then
         ignore_conect = .true.
      else if(keyword(i,1).eq.'non_standard_conect') then
         non_standard_conect = .true.
      else if(keyword(i,1).eq.'precision') then
         read(keyword(i,2),*,iostat=ioerr) precision
         if ( ioerr /= 0 ) exit
         write(*,*) ' Optional precision set: ', precision
      else if(keyword(i,1).eq.'movefrac') then
         read(keyword(i,2),*,iostat=ioerr) movefrac
         if ( ioerr /= 0 ) exit
         write(*,*) ' Optional movefrac set: ', movefrac
      else if(keyword(i,1).eq.'movebadrandom') then
         movebadrandom = .true.
         write(*,*) ' Will move randomly bad molecues (movebadrandom) '
      else if(keyword(i,1).eq.'disable_movebad') then
         disable_movebad = .true.
         write(*,*) ' Move-bad heursitic is dsabled. '
      else if(keyword(i,1).eq.'chkgrad') then
         chkgrad = .true.
      else if(keyword(i,1).eq.'writeout') then
         read(keyword(i,2),*,iostat=ioerr) writeout
         if ( ioerr /= 0 ) exit
         write(*,*) ' Output frequency: ', writeout
      else if(keyword(i,1).eq.'hexadecimal_indices') then
         hexadecimal_indices = .true.
      else if(keyword(i,1).eq.'maxit') then
         read(keyword(i,2),*,iostat=ioerr) maxit
         if ( ioerr /= 0 ) exit
         write(*,*) ' User defined GENCAN number of iterations: ', maxit
      else if(keyword(i,1).eq.'nloop') then
         if( .not. inside_structure ) then
            read(keyword(i,2),*,iostat=ioerr) nloop
            if ( ioerr /= 0 ) exit
         end if
      else if(keyword(i,1).eq.'nloop0') then
         if( .not. inside_structure ) then
            read(keyword(i,2),*,iostat=ioerr) nloop0
            if ( ioerr /= 0 ) exit
         end if
      else if(keyword(i,1).eq.'discale') then
         read(keyword(i,2),*,iostat=ioerr) discale
         if ( ioerr /= 0 ) exit
         write(*,*) ' Optional initial tolerance scale: ', discale
      else if(keyword(i,1).eq.'sidemax') then
         read(keyword(i,2),*,iostat=ioerr) sidemax
         if ( ioerr /= 0 ) exit
         write(*,*) ' User set maximum system dimensions: ', sidemax
      else if(keyword(i,1).eq.'fbins') then
         read(keyword(i,2),*,iostat=ioerr) fbins
         if ( ioerr /= 0 ) exit
         write(*,*) ' User set linked-cell bin parameter: ', fbins
      else if(keyword(i,1).eq.'add_amber_ter') then
         add_amber_ter = .true.
         write(*,*) ' Will add the TER flag between molecules. '
      else if(keyword(i,1).eq.'amber_ter_preserve') then
         amber_ter_preserve = .true.
         write(*,*) ' TER flags for fixed molecules will be kept if found. '
      else if(keyword(i,1).eq.'avoid_overlap') then
         if ( keyword(i,2).eq.'yes') then
            avoidoverlap = .true.
            write(*,*) ' Will avoid overlap to fixed molecules at initial point. '
         else
            avoidoverlap = .false.
            write(*,*) ' Will NOT avoid overlap to fixed molecules at initial point. '
         end if
      else if(keyword(i,1).eq.'packall') then
         packall = .true.
         write(*,*) ' Will pack all molecule types from the beginning. '
      else if(keyword(i,1).eq.'use_short_tol') then
         use_short_tol = .true.
         write(*,*) ' Will use a short distance penalty for all atoms. '
      else if(keyword(i,1).eq.'writecrd') then
         crd = .true.
         write(*,*) ' Will write output also in CRD format '
         read(keyword(i,2),*,iostat=ioerr) crdfile
      else if(keyword(i,1).eq.'add_box_sides') then
         add_box_sides = .true.
         write(*,*) ' Will print BOX SIDE informations. '
         read(keyword(i,2),*,iostat=ioerr) add_sides_fix
         if ( ioerr /= 0 ) then
            ioerr = 0
            cycle
         end if
         write(*,*) ' Will sum ', add_sides_fix,' to each side length on print'
      else if(keyword(i,1).eq.'iprint1') then
         read(keyword(i,2),*,iostat=ioerr) iprint1
         if ( ioerr /= 0 ) exit
         write(*,*) ' Optional printvalue 1 set: ', iprint1
      else if(keyword(i,1).eq.'iprint2') then
         read(keyword(i,2),*,iostat=ioerr) iprint2
         if ( ioerr /= 0 ) exit
         write(*,*) ' Optional printvalue 2 set: ', iprint2
      else if(keyword(i,1).eq.'pbc') then
         read(keyword(i,2),*,iostat=ioerr) pbc_min(1)
         read(keyword(i,3),*,iostat=ioerr) pbc_min(2)
         read(keyword(i,4),*,iostat=ioerr) pbc_min(3)
         if ( ioerr /= 0 ) exit
         if (maxkeywords > 4)  then
            if (trim(adjustl(keyword(i,5))) /= "none") then 
               read(keyword(i,5),*,iostat=ioerr) pbc_max(1)
               read(keyword(i,6),*,iostat=ioerr) pbc_max(2)
               read(keyword(i,7),*,iostat=ioerr) pbc_max(3)
               if ( ioerr /= 0 ) exit
            else
               pbc_max = pbc_min
               pbc_min = 0.0
            end if
         else 
            pbc_max = pbc_min
            pbc_min = 0.0
         end if
         if ( ioerr /= 0 ) exit
         using_pbc = .true.
         pbc_length = pbc_max - pbc_min
         if ( any(pbc_length <= 0.0) ) then
            write(*,*) ' ERROR: Length of PBC box must be positive in all directions, got: ', &
              pbc_length
            write(*,*) '        Lower PBC coordinates read: ', pbc_min
            write(*,*) '        Upper PBC coordinates read: ', pbc_max
            stop exit_code_input_error
         end if
         write(*,"(a)") '  Periodic boundary condition activated: '
         write(*,"(a, 3f8.2)") "    Minimum coordinates: ", pbc_min
         write(*,"(a, 3f8.2)") "    Maximum coordinates: ", pbc_max
      else if( keyword(i,1) /= 'tolerance' .and. &
         keyword(i,1) /= 'short_tol_dist' .and. &
         keyword(i,1) /= 'short_tol_scale' .and. &
         keyword(i,1) /= 'structure' .and. &
         keyword(i,1) /= 'end' .and. &
         keyword(i,1) /= 'atoms' .and. &
         keyword(i,1) /= 'output' .and. &
         keyword(i,1) /= 'filetype' .and. &
         keyword(i,1) /= 'number' .and. &
         keyword(i,1) /= 'inside' .and. &
         keyword(i,1) /= 'outside' .and. &
         keyword(i,1) /= 'fixed' .and. &
         keyword(i,1) /= 'center' .and. &
         keyword(i,1) /= 'centerofmass' .and. &
         keyword(i,1) /= 'over' .and. &
         keyword(i,1) /= 'above' .and. &
         keyword(i,1) /= 'below' .and. &
         keyword(i,1) /= 'constrain_rotation' .and. &
         keyword(i,1) /= 'radius' .and. &
         keyword(i,1) /= 'fscale' .and. &
         keyword(i,1) /= 'short_radius' .and. &
         keyword(i,1) /= 'short_radius_scale' .and. &
         keyword(i,1) /= 'resnumbers' .and. &
         keyword(i,1) /= 'connect' .and. &
         keyword(i,1) /= 'changechains' .and. &
         keyword(i,1) /= 'chain' .and. &
         keyword(i,1) /= 'discale' .and. &
         keyword(i,1) /= 'maxit' .and. &
         keyword(i,1) /= 'maxmove' .and. &
         keyword(i,1) /= 'add_amber_ter' .and. &
         keyword(i,1) /= 'amber_ter_preserve' .and. &
         keyword(i,1) /= 'sidemax' .and. &
         keyword(i,1) /= 'seed' .and. &
         keyword(i,1) /= 'randominitialpoint' .and. &
         keyword(i,1) /= 'restart_from' .and. &
         keyword(i,1) /= 'restart_to' .and. &
         keyword(i,1) /= 'nloop' .and. &
         keyword(i,1) /= 'nloop0' .and. &
         keyword(i,1) /= 'writeout' .and. &
         keyword(i,1) /= 'hexadecimal_indices' .and. &
         keyword(i,1) /= 'writebad' .and. &
         keyword(i,1) /= 'check' .and. &
         keyword(i,1) /= 'iprint1' .and. &
         keyword(i,1) /= 'iprint2' .and. &
         keyword(i,1) /= 'writecrd' .and. &
         keyword(i,1) /= 'segid' .and. &
         keyword(i,1) /= 'non_standard_conect' .and. &
         keyword(i,1) /= 'ignore_conect' .and. &
         keyword(i,1) /= 'chkgrad' ) then
         write(*,*) ' ERROR: Keyword not recognized: ', trim(keyword(i,1))
         stop exit_code_input_error
      end if
   end do
   if ( ioerr /= 0 ) then
      write(*,*) ' ERROR: Some optional keyword was not used correctly: ', trim(keyword(i,1))
      stop exit_code_input_error
   end if
   write(*,*) ' Seed for random number generator: ', seed
   call init_random_number(seed)

   ! Checking for the name of the output file to be created

   if (len(trim(xyzout)) == 0) then
      xyzout = '####'
      do iline = 1, nlines
         if(keyword(iline,1).eq.'output') then
            xyzout = keyword(iline,2)
            xyzout = trim(adjustl(xyzout))
         end if
      end do
      if(xyzout(1:4) == '####') then
         write(*,*)' ERROR: Output file not (correctly?) specified. '
         stop exit_code_input_error
      end if
   end if
   write(*,*)' Output file: ', trim(adjustl(xyzout))

   ! Reading structure files

   itype = 0
   do iline = 1, nlines
      if(keyword(iline,1).eq.'structure') then
         itype = itype + 1

         record = keyword(iline,2)
         write(*,*) ' Reading coordinate file: ', trim(adjustl(record))

         ! Reading pdb input files

         if(pdb) then
            name(itype) = trim(adjustl(record))
            record = keyword(iline,2)
            pdbfile(itype) = trim(record)
            idfirst(itype) = 1
            idfirstatom = 0
            do ii = itype - 1, 1, -1
               idfirst(itype) = idfirst(itype) + natoms(ii)
            end do
            open(10,file=keyword(iline,2),status='old',iostat=ioerr)
            if ( ioerr /= 0 ) call failopen(keyword(iline,2))
            ! Read coordinates
            record(1:6) = '######'
            do while(record(1:4).ne.'ATOM'.and.record(1:6).ne.'HETATM')
               read(10,str_format) record
            end do
            idatom = idfirst(itype) - 1
            do while(idatom.lt.natoms(itype)+idfirst(itype)-1)
               if(record(1:4).eq.'ATOM'.or.record(1:6).eq.'HETATM') then
                  idatom = idatom + 1
                  amass(idatom) = 1.d0
                  maxcon(idatom) = 0
                  nconnect(idatom,1:9) = 0
                  ! Read the index of the first atom, to adjust connectivities, if any
                  if(idfirstatom == 0) read(record(7:11),*,iostat=ioerr) idfirstatom
                  read(record,"( t31,f8.3,t39,f8.3,t47,f8.3 )",iostat=ioerr) &
                     (coor(idatom,k),k=1,3)
                  if( ioerr /= 0 ) then
                     record = keyword(iline,2)
                     write(*,*) ' ERROR: Failed to read coordinates from', &
                        ' file: ', trim(adjustl(record))
                     write(*,*) ' Probably the coordinates are not in', &
                        ' standard PDB file format. '
                     write(*,*) ' Standard PDB format specifications', &
                        ' can be found at: '
                     write(*,*) ' www.rcsb.org/pdb '
                     stop exit_code_input_error
                  end if

                  ! This only tests if residue numbers can be read, they are used
                  ! only for  output
                  read(record(23:26),*,iostat=ioerr) itest
                  if( ioerr /= 0 ) then
                     record = pdbfile(itype)
                     write(*,*) ' ERROR: Failed reading residue number',&
                        ' from PDB file: ', trim(adjustl(record))
                     write(*,*) ' Residue numbers are integers that',&
                        ' must be within columns 23 and 26. '
                     write(*,*) ' Other characters within these columns',&
                        ' will cause input/output errors. '
                     write(*,*) ' Standard PDB format specifications',&
                        ' can be found at: '
                     write(*,*) ' www.rcsb.org/pdb '
                     stop exit_code_input_error
                  end if
               end if
               read(10,str_format,iostat=ioerr) record
            end do
            !
            ! Read connectivity, if there is any specified
            !
            if( .not. ignore_conect ) then
               do while(.true.)
                  if ( ioerr /= 0 ) exit
                  if(record(1:6).eq.'CONECT') then
                     ! fixed width connectivity: standard PDB
                     if ( non_standard_conect ) then
                        read(record(7:11),*,iostat=ioerr) iatom
                        if(ioerr /= 0) then
                           write(*,*) " ERROR: Could not read atom index from CONECT line: "
                           write(*,*) trim(adjustl(record))
                           stop exit_code_input_error
                        end if
                        iatom = iatom - idfirstatom + 1
                        idatom = idfirst(itype) - 1 + iatom
                        iread=12
                        do i = 1, 5
                           read(record(iread:iread+4),*,iostat=ioerr) nconnect(idatom,maxcon(idatom) + i)
                           if ( ioerr /= 0 ) exit 
                           iread = iread + 5
                        end do
                     ! reading connectivity expecting indices to be separated by spaces
                     else
                        iread = 7
                        read(record(7:len(record)),*,iostat=ioerr) iatom
                        if(ioerr /= 0) then
                           write(*,*) " ERROR: Could not read atom index from CONECT line: "
                           write(*,*) trim(adjustl(record))
                           stop exit_code_input_error
                        end if
                        iatom = iatom - idfirstatom + 1
                        idatom = idfirst(itype) - 1 + iatom
                        ! count the number of connections
                        read(record(7:len(record)), *, iostat=ioerr)  iatom, &
                           (nconnect(idatom, i), i=maxcon(idatom)+1, 9)
                        if(ioerr > 0) then
                           write(*,*) " ERROR: Error reading CONECT line: "
                           write(*,*) trim(adjustl(record))
                           stop exit_code_input_error
                        end if
                     end if
                  end if
                  do i = maxcon(idatom)+1, 9
                     if (nconnect(idatom,i) /= 0) then
                        nconnect(idatom, i) = nconnect(idatom, i) - idfirstatom + 1
                     end if
                  end do
                  do i = 1, 9
                     if (nconnect(idatom, i) /= 0) then
                        maxcon(idatom) = i
                     end if
                  end do
                  read(10,str_format,iostat=ioerr) record
               end do
            end if
            close(10)
         end if

         ! Reading tinker input files
         if(tinker) then
            open(10,file=keyword(iline,2),status='old',iostat=ioerr)
            if ( ioerr /= 0 ) call failopen(keyword(iline,2))
            idfirst(itype) = 1
            do ii = itype - 1, 1, -1
               idfirst(itype) = idfirst(itype) + natoms(ii)
            end do
            record = keyword(iline,2)
            call setcon(record(1:64),idfirst(itype))
            open(10,file = keyword(iline,2), status = 'old')
            record = blank
            do while(record.le.blank)
               read(10,str_format) record
            end do
            i = 1
            do while(record(i:i).le.' ')
               i = i + 1
               if ( i > strl ) exit
            end do
            iarg = i
            if ( i < strl ) then
               do while(record(i:i).gt.' ')
                  i = i + 1
                  if ( i > strl ) exit
               end do
            end if
            read(record(iarg:i-1),*) natoms(itype)
            if ( i < strl ) then
               do while(record(i:i).le.' ')
                  i = i + 1
                  if ( i > strl ) exit
               end do
            end if
            iarg = i
            if ( i < strl ) then
               do while(record(i:i).gt.' ')
                  i = i + 1
                  if ( i > strl ) exit
               end do
            end if
            read(record(iarg:i-1),str_format) name(itype)
            record = name(itype)
            name(itype) = trim(adjustl(record))
            if(name(itype).lt.' ') name(itype) = 'Without_title'
            idatom = idfirst(itype) - 1
            do iatom = 1, natoms(itype)
               idatom = idatom + 1
               record = blank
               do while(record.le.blank)
                  read(10,str_format) record
               end do
               i = 1
               do while(record(i:i).le.' ')
                  i = i + 1
                  if ( i > strl ) exit
               end do
               iarg = i
               if ( i < strl ) then
                  do while(record(i:i).gt.' ')
                     i = i + 1
                     if ( i > strl ) exit
                  end do
               end if
               read(record(iarg:i-1),*) in
               if ( i < strl ) then
                  do while(record(i:i).le.' ')
                     i = i + 1
                     if ( i > strl ) exit
                  end do
               end if
               iarg = i
               if ( i < strl ) then
                  do while(record(i:i).gt.' ')
                     i = i + 1
                     if ( i > strl ) exit
                  end do
               end if
               read(record(iarg:i-1),*) ele(idatom)
               read(record(i:strl),*) (coor(idatom,k), k = 1, 3),&
                  (nconnect(idatom, k), k = 1, maxcon(idatom))
               amass(idatom) = 1.d0
            end do
            close(10)
         end if

         ! Reading xyz input files
         if(xyz) then
            open(10,file=keyword(iline,2),status='old',iostat=ioerr)
            if ( ioerr /= 0 ) call failopen(keyword(iline,2))
            read(10,*) natoms(itype)
            read(10,str_format) name(itype)
            if(name(itype).lt.' ') name(itype) = 'Without_title'
            idfirst(itype) = 1
            do ii = itype - 1, 1, -1
               idfirst(itype) = idfirst(itype) + natoms(ii)
            end do
            idatom = idfirst(itype) - 1
            do iatom = 1, natoms(itype)
               idatom = idatom + 1
               record = blank
               read(10,str_format) record
               read(record,*) ele(idatom), (coor(idatom,k),k=1,3)
               amass(idatom) = 1.d0
            end do
            close(10)
         end if


      end if

   end do
   ntype = itype

   write(*,*) ' Number of independent structures: ', ntype
   write(*,*) ' The structures are: '

   do itype = 1, ntype
      record = name(itype)
      write(*,*) ' Structure ', itype, ':', trim(adjustl(record)),&
         '(',natoms(itype),' atoms)'
   end do

   ! Setting the vectors for the number of GENCAN loops

   if(nloop.eq.0) then
      nloop_all = 200*ntype
      nloop = nloop_all
   else
      nloop_all = nloop
   end if
   write(*,*) ' Maximum number of GENCAN loops for all molecule packing: ', nloop_all
   do itype = 1, ntype
      if ( nloop_type(itype) == 0 ) then
         nloop_type(itype) = nloop_all
      else
         write(*,*) ' Maximum number of GENCAN loops for type: ', itype, ': ', nloop_type(itype)
      end if
   end do

   ! nloop0 are the number of loops for the initial phase packing

   if(nloop0.eq.0) then
      nloop0 = 20*ntype
   else
      write(*,*) ' Maximum number of GENCAN loops-0 for all molecule packing: ', nloop0
   end if
   do itype = 1, ntype
      if ( nloop0_type(itype) == 0 ) then
         nloop0_type(itype) = nloop0
      else
         write(*,*) ' Maximum number of GENCAN loops-0 for type: ', itype, ': ', nloop0_type(itype)
      end if
   end do

   ! Getting the tolerance

   ioerr = 1
   dism = -1.d0
   do iline = 1, nlines
      if(keyword(iline,1).eq.'tolerance') then
         read(keyword(iline,2),*,iostat=ioerr) dism
         if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Failed reading tolerance. '
            stop exit_code_input_error
         end if
         exit
      end if
   end do
   if ( ioerr /= 0 ) then
      write(*,*) ' ERROR: Overall tolerance not set. Use, for example: tolerance 2.0 '
      stop exit_code_input_error
   end if
   write(*,*) ' Distance tolerance: ', dism

   ! Reading the restrictions that were set

   irest = 0
   ioerr = 0
   do iline = 1, nlines

      if(keyword(iline,1).eq.'fixed') then
         irest = irest + 1
         irestline(irest) = iline
         ityperest(irest) = 1
         read(keyword(iline,2),*,iostat=ioerr) restpars(irest,1)
         read(keyword(iline,3),*,iostat=ioerr) restpars(irest,2)
         read(keyword(iline,4),*,iostat=ioerr) restpars(irest,3)
         read(keyword(iline,5),*,iostat=ioerr) restpars(irest,4)
         read(keyword(iline,6),*,iostat=ioerr) restpars(irest,5)
         read(keyword(iline,7),*,iostat=ioerr) restpars(irest,6)
      end if

      if(keyword(iline,1).eq.'inside') then
         irest = irest + 1
         irestline(irest) = iline
         if(keyword(iline,2).eq.'cube') then
            ityperest(irest) = 2
            read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
            read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
            read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
            read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
         else if(keyword(iline,2).eq.'box') then
            ityperest(irest) = 3
            read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
            read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
            read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
            read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
            read(keyword(iline,7),*,iostat=ioerr) restpars(irest,5)
            read(keyword(iline,8),*,iostat=ioerr) restpars(irest,6)
         else if(keyword(iline,2).eq.'sphere') then
            ityperest(irest) = 4
            read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
            read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
            read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
            read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
         else if(keyword(iline,2).eq.'ellipsoid') then
            ityperest(irest) = 5
            read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
            read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
            read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
            read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
            read(keyword(iline,7),*,iostat=ioerr) restpars(irest,5)
            read(keyword(iline,8),*,iostat=ioerr) restpars(irest,6)
            read(keyword(iline,9),*,iostat=ioerr) restpars(irest,7)
         else if(keyword(iline,2).eq.'cylinder') then
            ityperest(irest) = 12
            read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
            read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
            read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
            read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
            read(keyword(iline,7),*,iostat=ioerr) restpars(irest,5)
            read(keyword(iline,8),*,iostat=ioerr) restpars(irest,6)
            read(keyword(iline,9),*,iostat=ioerr) restpars(irest,7)
            read(keyword(iline,10),*,iostat=ioerr) restpars(irest,9)
            restpars(irest,8) = restpars(irest,4)**2 + &
               restpars(irest,5)**2 + &
               restpars(irest,6)**2
            if(restpars(irest,8).lt.1.d-10) then
               write(*,*) ' ERROR: The norm of the director vector', &
                  ' of the cylinder constraint cannot be zero.'
               ioerr = 1
            else
               clen = dsqrt(restpars(irest,8))
               restpars(irest,4) = restpars(irest,4) / clen
               restpars(irest,5) = restpars(irest,5) / clen
               restpars(irest,6) = restpars(irest,6) / clen
            end if
         else
            ioerr = 1
         end if
      end if

      if(keyword(iline,1).eq.'outside') then
         irest = irest + 1
         irestline(irest) = iline
         if(keyword(iline,2).eq.'cube') then
            ityperest(irest) = 6
            read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
            read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
            read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
            read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
         else if(keyword(iline,2).eq.'box') then
            ityperest(irest) = 7
            read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
            read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
            read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
            read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
            read(keyword(iline,7),*,iostat=ioerr) restpars(irest,5)
            read(keyword(iline,8),*,iostat=ioerr) restpars(irest,6)
         else if(keyword(iline,2).eq.'sphere') then
            ityperest(irest) = 8
            read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
            read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
            read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
            read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
         else if(keyword(iline,2).eq.'ellipsoid') then
            ityperest(irest) = 9
            read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
            read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
            read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
            read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
            read(keyword(iline,7),*,iostat=ioerr) restpars(irest,5)
            read(keyword(iline,8),*,iostat=ioerr) restpars(irest,6)
            read(keyword(iline,9),*,iostat=ioerr) restpars(irest,7)
         else if(keyword(iline,2).eq.'cylinder') then
            ityperest(irest) = 13
            read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
            read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
            read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
            read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
            read(keyword(iline,7),*,iostat=ioerr) restpars(irest,5)
            read(keyword(iline,8),*,iostat=ioerr) restpars(irest,6)
            read(keyword(iline,9),*,iostat=ioerr) restpars(irest,7)
            read(keyword(iline,10),*,iostat=ioerr) restpars(irest,9)
            restpars(irest,8) = restpars(irest,4)**2 + &
               restpars(irest,5)**2 + &
               restpars(irest,6)**2
            if(restpars(irest,8).lt.1.d-10) then
               write(*,*) ' ERROR: The norm of the director vector',&
                  ' of the cylinder constraint cannot be zero.'
               ioerr = 1
            else
               clen = dsqrt(restpars(irest,8))
               restpars(irest,4) = restpars(irest,4) / clen
               restpars(irest,5) = restpars(irest,5) / clen
               restpars(irest,6) = restpars(irest,6) / clen
            end if
         else
            ioerr = 1
         end if
      end if

      if(keyword(iline,1).eq.'over' .or. keyword(iline,1).eq.'above') then
         irest = irest + 1
         irestline(irest) = iline
         read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
         read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
         read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
         read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
         if (keyword(iline,2).eq.'plane') then
            ityperest(irest) = 10
         else if(keyword(iline,2).eq.'xygauss') then
            ityperest(irest) = 14
            read(keyword(iline,7),*,iostat=ioerr) restpars(irest,5)
            read(keyword(iline,8),*,iostat=ioerr) restpars(irest,6)
         else
            ioerr = 1
         end if
      end if

      if(keyword(iline,1).eq.'below') then
         irest = irest + 1
         irestline(irest) = iline
         read(keyword(iline,3),*,iostat=ioerr) restpars(irest,1)
         read(keyword(iline,4),*,iostat=ioerr) restpars(irest,2)
         read(keyword(iline,5),*,iostat=ioerr) restpars(irest,3)
         read(keyword(iline,6),*,iostat=ioerr) restpars(irest,4)
         if (keyword(iline,2).eq.'plane') then
            ityperest(irest) = 11
         else if(keyword(iline,2).eq.'xygauss') then
            ityperest(irest) = 15
            read(keyword(iline,7),*,iostat=ioerr) restpars(irest,5)
            read(keyword(iline,8),*,iostat=ioerr) restpars(irest,6)
         else
            ioerr = 1
         end if
      end if

      if ( ioerr /= 0 ) then
         write(*,*) ' ERROR: Some restriction is not set correctly. '
         stop exit_code_input_error
      end if

   end do

   ! Reading, if defined, the short distance penalty parameters

   ioerr = 1
   short_tol_dist = dism/2.d0
   ! Reading short_tol_dist
   do iline = 1, nlines
      if(keyword(iline,1).eq.'short_tol_dist') then
         read(keyword(iline,2),*,iostat=ioerr) short_tol_dist
         if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Failed reading short_tol_dist. '
            stop exit_code_input_error
         end if
         if ( short_tol_dist > dism ) then
            write(*,*) ' ERROR: The short_tol_dist parameter must be smaller than the tolerance. '
            stop exit_code_input_error
         end if
         write(*,*) ' User defined short tolerance distance: ', short_tol_dist
         short_tol_dist = short_tol_dist**2
         exit
      end if
   end do
   ! Reading short_tol_scale
   short_tol_scale = 3.d0
   do iline = 1, nlines
      if(keyword(iline,1).eq.'short_tol_scale') then
         read(keyword(iline,2),*,iostat=ioerr) short_tol_scale
         if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Failed reading short_tol_scale. '
            stop exit_code_input_error
         end if
         if ( short_tol_dist <= 0.d0 ) then
            write(*,*) ' ERROR: The short_tol_scale parameter must be positive. '
            stop exit_code_input_error
         end if
         write(*,*) ' User defined short tolerance scale: ', short_tol_scale
         exit
      end if
   end do


   ! Default to all non-fixed molecules may be moved.
   do itype = 1, ntype
     maxmove(itype) = nmols(itype)
   end do

   ! Assigning the input lines that correspond to each structure
   itype = 0
   iline = 0
   do while(iline < nlines)
      iline = iline + 1
      if(keyword(iline,1).eq.'structure') then
         itype = itype + 1
         linestrut(itype,1) = iline
         iline = iline + 1
         do while(keyword(iline,1).ne.'end'.or.&
            keyword(iline,2).ne.'structure')
            if(keyword(iline,1).eq.'maxmove') then
               read(keyword(iline,2),*) maxmove(itype)
            end if
            if(keyword(iline,1) == 'structure'.or.&
               iline == nlines) then
               write(*,*) ' ERROR: Structure specification not ending with "end structure"'
               stop exit_code_input_error
            end if
            iline = iline + 1
         end do
         linestrut(itype,2) = iline
      end if
   end do

   ! If pdb files, get the type of residue numbering output for each
   ! molecule

   if(pdb) then
      do itype = 1, ntype
         connect(itype) = .true.
         resnumbers(itype) = -1
         changechains(itype) = .false.
         chain(itype) = "#"
         segid(itype) = ""
         do iline = 1, nlines
            if(iline.gt.linestrut(itype,1).and.&
               iline.lt.linestrut(itype,2)) then
               if(keyword(iline,1).eq.'changechains') then
                  changechains(itype) = .true.
               end if
               if(keyword(iline,1).eq.'resnumbers') then
                  read(keyword(iline,2),*) resnumbers(itype)
               end if
               if(keyword(iline,1).eq.'connect') then
                  if(keyword(iline,2) == "no") then
                     connect(itype) = .false.
                  end if
               end if
               if(keyword(iline,1).eq.'chain') then
                  read(keyword(iline,2),*) chain(itype)
               end if
               if(keyword(iline,1).eq.'segid') then
                  read(keyword(iline,2),*) segid(itype)
               end if
            end if
         end do
         if (crd) then
            if (itype.gt.1 .and. segid(itype)=="") then
               if (segid(itype-1) /= "")  then
                  write(*,*) ' Warning: Type of segid not defined for ', itype,'. Keeping it same as previous'
               endif
               segid(itype) = segid(itype-1)
            endif
         endif
         if ( resnumbers(itype) == -1 ) then
            write(*,*) ' Warning: Type of residue numbering not',&
               ' set for structure ',itype
            call setrnum(pdbfile(itype),imark)
            if(imark.eq.1) resnumbers(itype) = 0
            if(imark.gt.1) resnumbers(itype) = 1
         end if
         write(*,*) ' Residue numbering set for structure ',itype,':',&
            resnumbers(itype)
         write(*,*) ' Swap chains of molecules of structure ',&
            itype,':', changechains(itype)
         if ( chain(itype) /= "#" ) then
            write(*,*) ' Specific chain identifier set for structure ',itype,':',chain(itype)
         end if
         if ( chain(itype) /= "#" .and. changechains(itype) ) then
            write(*,*) " ERROR: 'changechains' and 'chain' input parameters are not compatible "
            write(*,*) "        for a single structure. "
            stop exit_code_input_error
         end if
      end do
   end if

   ! Write the number of molecules of each type

   do itype = 1, ntype
      write(*,*) ' Number of molecules of type ', itype, ': ', nmols(itype)
      if(pdb.and.nmols(itype).gt.9999) then
         write(*,*) ' Warning: There will be more than 9999 molecules of type ',itype
         if (.not. crd)  write(*,*) '          Residue numbering is reset after 9999. '
         if (crd)  write(*,*) '          Residue numbering is reset after 9999 in pdb but not in crd. '
         if ( chain(itype) == "#" ) then
            write(*,*) ' Each set be will be assigned a different chain in the PDB output file. '
         end if
      end if
      if(crd.and.nmols(itype).gt.99999999) then
         write(*,*) ' Warning: There will be more than 99999999 molecules of type ',itype
         write(*,*) '          Residue numbering is reset after 99999999 in crd. '
      endif
   end do

   ! Checking if restart files will be used for each structure or for the whole system

   restart_from(0) = "none"
   restart_to(0) = "none"
   do itype = 1, ntype
      restart_from(itype) = "none"
      restart_to(itype) = "none"
   end do
   lines: do iline = 1, nlines
      if ( keyword(iline,1) == 'restart_from' ) then
         do itype = 1, ntype
            if(iline.gt.linestrut(itype,1).and.&
               iline.lt.linestrut(itype,2)) then
               restart_from(itype) = keyword(iline,2)
               cycle lines
            end if
         end do
         if( restart_from(0) == 'none' ) then
            restart_from(0) = keyword(iline,2)
         else
            write(*,*) ' ERROR: More than one definition of restart_from file for all system. '
            stop exit_code_input_error
         end if
      end if
      if ( keyword(iline,1) == 'restart_to' ) then
         do itype = 1, ntype
            if(iline.gt.linestrut(itype,1).and.&
               iline.lt.linestrut(itype,2)) then
               restart_to(itype) = keyword(iline,2)
               cycle lines
            end if
         end do
         if( restart_to(0) == 'none' ) then
            restart_to(0) = keyword(iline,2)
         else
            write(*,*) ' ERROR: More than one definition of restart_to file for all system. '
            stop exit_code_input_error
         end if
      end if
   end do lines

   ! total number of restrictions
   nrest = irest
   write(*,*) ' Total number of restrictions: ', nrest

   return
end subroutine getinp

!
! Subroutine that stops if failed to open file
!

subroutine failopen(record)
   use exit_codes
   use sizes
   character(len=strl) :: record
   write(*,*)
   write(*,*) ' ERROR: Could not open file. '
   write(*,*) '        Could not find file: ',trim(record)
   write(*,*) '        Please check if all the input and structure '
   write(*,*) '        files are in the current directory or if the'
   write(*,*) '        correct paths are provided.'
   write(*,*)
   stop exit_code_open_file
end subroutine failopen

!
! Subroutine that checks if a pdb structure has one or more than
! one residue
!

subroutine setrnum(file,nres)

   use sizes
   implicit none
   integer :: iread, ires, ireslast, nres, ioerr
   character(len=strl) :: file
   character(len=strl) :: record

   open(10,file=file,status='old')
   iread = 0
   nres = 1
   do while(nres.eq.1)
      read(10,str_format,iostat=ioerr) record
      if ( ioerr /= 0 ) exit
      if(record(1:4).eq.'ATOM'.or.record(1:6).eq.'HETATM') then
         read(record(23:26),*,iostat=ioerr) ires
         if ( ioerr /= 0 ) cycle
         iread = iread + 1
         if(iread.gt.1) then
            if(ires.ne.ireslast) then
               nres = 2
               close(10)
               return
            end if
         end if
         ireslast = ires
      end if
   end do
   close(10)

   return
end subroutine setrnum

!
!  Subroutine that computes de number of connections of each atom
!  for tinker xyz files
!

subroutine setcon(xyzfile,idfirst)

   use sizes
   use input, only : maxcon
   implicit none

   integer :: idfirst
   integer :: natoms, idatom, iatom, ic, i
   character(len=64) :: xyzfile
   character(len=120) :: record

   open(10, file = xyzfile, status='old')
   read(10,*) natoms
   idatom = idfirst - 1
   do iatom = 1, natoms
      idatom = idatom + 1
      read(10,"( a120 )") record
      ic = 0
      do i = 1, 119
         if(record(i:i).gt.' '.and.record(i+1:i+1).le.' ') ic = ic + 1
      end do
      maxcon(idatom) = ic - 5
   end do
   close(10)

   return
end subroutine setcon

!
! Subroutine getkeywords: gets keywords and values from the input
!                         file in a more robust way
!

subroutine getkeywords()

   use sizes
   use input, only : keyword, nlines, inputfile, forbidden_char
   implicit none
   character(len=strl) :: record
   integer :: iline, i, j, k, ilast, ival, ioerr

   ! Clearing keyword array

   do i = 1, nlines
      do j = 1, maxkeywords
         keyword(i,j) = 'none'
      end do
   end do

   ! Filling keyword array
   do iline = 1, nlines
      read(inputfile(iline),str_format,iostat=ioerr) record
      if ( ioerr /= 0 ) exit
      i = 0
      ival = 0
      do while(i < strl)
         i = i + 1
         ilast = i
         do while(record(i:i) > ' '.and. i < strl)
            i = i + 1
         end do
         if(i.gt.ilast) then
            ival = ival + 1
            keyword(iline,ival) = record(ilast:i)
         end if
      end do
   end do

   ! Remove quotes and the forbidden_char from keywords
   do i = 1, nlines
      do j = 1, maxkeywords
         record = keyword(i,j)
         do k = 1,strl
            if (record(k:k) == forbidden_char .or. record(k:k) == '"') then
               record(k:k) = " "
            end if
         end do
         keyword(i,j) = trim(adjustl(record))
      end do
   end do

   return
end subroutine getkeywords

! Subroutine that returns the chain character given an index

subroutine chainc(i,chain)

   implicit none
   integer :: i
   character :: chain

   if(i.eq.0) chain = ' '
   if(i.eq.1) chain = 'A'
   if(i.eq.2) chain = 'B'
   if(i.eq.3) chain = 'C'
   if(i.eq.4) chain = 'D'
   if(i.eq.5) chain = 'E'
   if(i.eq.6) chain = 'F'
   if(i.eq.7) chain = 'G'
   if(i.eq.8) chain = 'H'
   if(i.eq.9) chain = 'I'
   if(i.eq.10) chain = 'J'
   if(i.eq.11) chain = 'K'
   if(i.eq.12) chain = 'L'
   if(i.eq.13) chain = 'M'
   if(i.eq.14) chain = 'N'
   if(i.eq.15) chain = 'O'
   if(i.eq.16) chain = 'P'
   if(i.eq.17) chain = 'Q'
   if(i.eq.18) chain = 'R'
   if(i.eq.19) chain = 'S'
   if(i.eq.20) chain = 'T'
   if(i.eq.21) chain = 'U'
   if(i.eq.22) chain = 'V'
   if(i.eq.23) chain = 'W'
   if(i.eq.24) chain = 'X'
   if(i.eq.25) chain = 'Y'
   if(i.eq.26) chain = 'Z'
   if(i.eq.27) chain = '1'
   if(i.eq.28) chain = '2'
   if(i.eq.29) chain = '3'
   if(i.eq.30) chain = '4'
   if(i.eq.31) chain = '5'
   if(i.eq.32) chain = '6'
   if(i.eq.33) chain = '7'
   if(i.eq.34) chain = '8'
   if(i.eq.35) chain = '9'
   if(i.eq.36) chain = '0'
   if(i.gt.36) chain = '#'

   return
end subroutine chainc

! Subroutine that clears a character variable

subroutine clear(record)

   use sizes
   integer :: i
   character(len=strl) :: record

   do i = 1, strl
      record(i:i) = ' '
   end do

   return
end subroutine clear

!  
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!  
! Optimization variables passed as common go pgencan

module usegencan

  use sizes
  implicit none

  integer :: maxit, iprint1, iprint2
  integer, allocatable :: wi(:) ! (nn)
  double precision, allocatable :: l(:), u(:), g(:) ! (nn)
  double precision, allocatable :: wd(:) ! (8*nn)

end module usegencan

!
! JACOBI
! Jacobi diagonalizer with sorted output.  Same calling sequence as
! EISPACK routine, but must specify nrot!
!
      SUBROUTINE jacobi (a, n, np, d, v, nrot)
      IMPLICIT CHARACTER (A-Z)
!
      INTEGER n, np, nrot
      DOUBLEPRECISION a (np, n)
      DOUBLEPRECISION d (n)
      DOUBLEPRECISION v (np, n)
!
      DOUBLEPRECISION onorm, dnorm
      DOUBLEPRECISION b, dma, q, t, c, s
      DOUBLEPRECISION atemp, vtemp, dtemp
      INTEGER i, j, k, l
!
      DO 10000 j = 1, n
        DO 10010 i = 1, n
          v (i, j) = 0.0D0
10010     CONTINUE
        v (j, j) = 1.0D0
        d (j) = a (j, j)
10000   CONTINUE
!
      DO 20000 l = 1, nrot
        dnorm = 0.0D0
        onorm = 0.0D0
        DO 20100 j = 1, n
          dnorm = dnorm + ABS (d (j))
          DO 20110 i = 1, j - 1
            onorm = onorm + ABS (a (i, j))
20110       CONTINUE
20100     CONTINUE
        IF (onorm / dnorm .LE. 0.0D0) GOTO 19999
        DO 21000 j = 2, n
          DO 21010 i = 1, j - 1
            b = a (i, j)
            IF (ABS (b) .GT. 0.0D0) THEN
              dma = d (j) - d (i)
              IF (ABS (dma) + ABS (b) .LE. ABS (dma)) THEN
                t = b / dma
              ELSE
                q = 0.5D0 * dma / b
                t = SIGN (1.0D0 / (ABS (q) + SQRT (1.0D0 + q * q)), q)
              ENDIF
              c = 1.0D0 / SQRT (t * t + 1.0D0)
              s = t * c
              a (i, j) = 0.0D0
              DO 21110 k = 1, i - 1
                atemp    = c * a (k, i) - s * a (k, j)
                a (k, j) = s * a (k, i) + c * a (k, j)
                a (k, i) = atemp
21110           CONTINUE
              DO 21120 k = i + 1, j - 1
                atemp    = c * a (i, k) - s * a (k, j)
                a (k, j) = s * a (i, k) + c * a (k, j)
                a (i, k) = atemp
21120           CONTINUE
              DO 21130 k = j + 1, n
                atemp    = c * a (i, k) - s * a (j, k)
                a (j, k) = s * a (i, k) + c * a (j, k)
                a (i, k) = atemp
21130           CONTINUE
              DO 21140 k = 1, n
                vtemp    = c * v (k, i) - s * v (k, j)
                v (k, j) = s * v (k, i) + c * v (k, j)
                v (k, i) = vtemp
21140           CONTINUE
              dtemp = c * c * d (i) + s * s * d (j) -&
                      2.0D0 * c * s * b
              d (j) = s * s * d (i) + c * c * d (j) +&
                      2.0D0 * c * s * b
              d (i) = dtemp
              ENDIF
21010       CONTINUE
21000     CONTINUE
20000   CONTINUE
19999 CONTINUE
      nrot = l
!
      DO 30000 j = 1, n - 1
        k = j
        dtemp = d (k)
        DO 30100 i = j + 1, n
          IF (d (i) .LT. dtemp) THEN
            k = i
            dtemp = d (k)
            ENDIF
30100     CONTINUE
        IF (k .GT. j) THEN
          d (k) = d (j)
          d (j) = dtemp
          DO 30200 i = 1, n
            dtemp    = v (i, k)
            v (i, k) = v (i, j)
            v (i, j) = dtemp
30200       CONTINUE
          ENDIF
30000   CONTINUE
!
RETURN
END subroutine jacobi        

 

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine resetboxes: Subroutine that resets the occupancy of
!                        linked cell boxes
!

subroutine resetboxes()

   use sizes
   use compute_data, only : latomfirst, latomfix, &
      lboxfirst, lboxnext, hasfree
   implicit none
   integer :: i, j, k, ibox

   ! Reset data for boxes that contain fixed atom

   ibox = lboxfirst
   do while( ibox > 0 )
      call ibox_to_ijk(ibox,i,j,k)
      latomfirst(i,j,k) = latomfix(i,j,k)
      hasfree(i,j,k) = .false.
      ibox = lboxnext(ibox)
   end do
   lboxfirst = 0

end subroutine resetboxes

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
!
! Subroutine comprest: Compute the function value relative to
!                      to the restrictions for one atom
!

subroutine comprest(icart,f)

   use sizes
   use compute_data, only : xcart, restpars, scale, scale2, nratom, ityperest, iratom

   implicit none
   integer :: iratcount, irest, icart
   double precision :: xmin, ymin, zmin, clength, a1, a2, a3, w, b1, b2, b3, d, a4
   double precision :: f
   double precision :: xmax, ymax, zmax
   double precision :: v1, v2, v3
   double precision :: vnorm
   double precision :: xmed, ymed, zmed
   double precision :: x, y, z

   f = 0.d0
   do iratcount = 1, nratom(icart)
      irest = iratom(icart,iratcount)
      if(ityperest(irest).eq.2) then
         clength = restpars(irest,4)
         xmin = restpars(irest,1)
         ymin = restpars(irest,2)
         zmin = restpars(irest,3)
         xmax = restpars(irest,1) + clength
         ymax = restpars(irest,2) + clength
         zmax = restpars(irest,3) + clength
         a1 = dmin1(xcart(icart,1) - xmin, 0.d0)
         a2 = dmin1(xcart(icart,2) - ymin, 0.d0)
         a3 = dmin1(xcart(icart,3) - zmin, 0.d0)
         f = f + scale*(a1 * a1 + a2 * a2 + a3 * a3)
         a1 = dmax1(xcart(icart,1) - xmax, 0.d0)
         a2 = dmax1(xcart(icart,2) - ymax, 0.d0)
         a3 = dmax1(xcart(icart,3) - zmax, 0.d0)
         f = f + scale*(a1 * a1 + a2 * a2 + a3 * a3)
      else if(ityperest(irest).eq.3) then
         xmin = restpars(irest,1)
         ymin = restpars(irest,2)
         zmin = restpars(irest,3)
         xmax = restpars(irest,4)
         ymax = restpars(irest,5)
         zmax = restpars(irest,6)
         a1 = dmin1(xcart(icart,1) - xmin, 0.d0)
         a2 = dmin1(xcart(icart,2) - ymin, 0.d0)
         a3 = dmin1(xcart(icart,3) - zmin, 0.d0)
         f = f + scale*(a1 * a1 + a2 * a2 + a3 * a3)
         a1 = dmax1(xcart(icart,1) - xmax, 0.d0)
         a2 = dmax1(xcart(icart,2) - ymax, 0.d0)
         a3 = dmax1(xcart(icart,3) - zmax, 0.d0)
         f = f + scale*(a1 * a1 + a2 * a2 + a3 * a3)
      else if(ityperest(irest).eq.4) then
         w = (xcart(icart,1)-restpars(irest,1))**2 + &
            (xcart(icart,2)-restpars(irest,2))**2 + &
            (xcart(icart,3)-restpars(irest,3))**2 - &
            restpars(irest,4)**2
         a1 = dmax1(w,0.d0)
         f = f + scale2*a1*a1
      else if(ityperest(irest).eq.5) then
         a1 = (xcart(icart,1)-restpars(irest,1))**2 / restpars(irest,4)**2
         a2 = (xcart(icart,2)-restpars(irest,2))**2 / restpars(irest,5)**2
         a3 = (xcart(icart,3)-restpars(irest,3))**2 / restpars(irest,6)**2
         a4 = restpars(irest,7)**2
         w = a1 + a2 + a3 - a4
         a1 = dmax1(w,0.d0)
         f = f + scale2*a1*a1
      else if(ityperest(irest).eq.6) then ! outside cube
         xmin = restpars(irest,1)
         ymin = restpars(irest,2)
         zmin = restpars(irest,3)
         xmax = restpars(irest,1) + restpars(irest,4)
         ymax = restpars(irest,2) + restpars(irest,4)
         zmax = restpars(irest,3) + restpars(irest,4)
         x = xcart(icart, 1)
         y = xcart(icart, 2)
         z = xcart(icart, 3)
         a1 = 0.0
         a2 = 0.0
         a3 = 0.0
         if ( ( x > xmin .and. x < xmax ) .and. &
              ( y > ymin .and. y < ymax ) .and. &
              ( z > zmin .and. z < zmax ) ) then
            xmed = (xmax - xmin) / 2
            ymed = (ymax - ymin) / 2
            zmed = (zmax - zmin) / 2
            if ( x <= xmed ) a1 = x - xmin 
            if ( x > xmed ) a1 = xmax - x
            if ( y <= ymed ) a2 = y - ymin
            if ( y > ymed ) a2 = ymax - y
            if ( z <= zmed ) a3 = z - zmin  
            if ( z > zmed ) a3 = zmax - z
         end if
         f = f + scale * (a1 + a2 + a3)
      else if(ityperest(irest).eq.7) then ! outside box
         xmin = restpars(irest,1)
         ymin = restpars(irest,2)
         zmin = restpars(irest,3)
         xmax = restpars(irest,4)
         ymax = restpars(irest,5)
         zmax = restpars(irest,6)
         x = xcart(icart, 1)
         y = xcart(icart, 2)
         z = xcart(icart, 3)
         a1 = 0.0
         a2 = 0.0
         a3 = 0.0
         if ( ( x > xmin .and. x < xmax ) .and. &
              ( y > ymin .and. y < ymax ) .and. &
              ( z > zmin .and. z < zmax ) ) then
            xmed = (xmax - xmin) / 2
            ymed = (ymax - ymin) / 2
            zmed = (zmax - zmin) / 2
            if ( x <= xmed ) a1 = x - xmin 
            if ( x > xmed ) a1 = xmax - x
            if ( y <= ymed ) a2 = y - ymin
            if ( y > ymed ) a2 = ymax - y
            if ( z <= zmed ) a3 = z - zmin  
            if ( z > zmed ) a3 = zmax - z
         end if
         f = f + scale * (a1 + a2 + a3)
      else if(ityperest(irest).eq.8) then
         w = (xcart(icart,1)-restpars(irest,1))**2 + &
            (xcart(icart,2)-restpars(irest,2))**2 + &
            (xcart(icart,3)-restpars(irest,3))**2 - &
            restpars(irest,4)**2
         a1 = dmin1(w,0.d0)
         f = f + scale2*a1*a1
      else if(ityperest(irest).eq.9) then
         a1 = (xcart(icart,1)-restpars(irest,1))**2 / restpars(irest,4)**2
         a2 = (xcart(icart,2)-restpars(irest,2))**2 / restpars(irest,5)**2
         a3 = (xcart(icart,3)-restpars(irest,3))**2 / restpars(irest,6)**2
         a4 = restpars(irest,7)**2
         w = a1 + a2 + a3 - a4
         a1 = dmin1(w,0.d0)
         f = f + a1*a1
      else if(ityperest(irest).eq.10) then
         w = restpars(irest,1)*xcart(icart,1) + &
            restpars(irest,2)*xcart(icart,2) + &
            restpars(irest,3)*xcart(icart,3) - &
            restpars(irest,4)
         a1 = dmin1(w,0.d0)
         f = f + scale * a1*a1
      else if(ityperest(irest).eq.11) then
         w = restpars(irest,1)*xcart(icart,1) + &
            restpars(irest,2)*xcart(icart,2) + &
            restpars(irest,3)*xcart(icart,3) - &
            restpars(irest,4)
         a1 = dmax1(w,0.d0)
         f = f + scale * a1*a1
      else if(ityperest(irest).eq.12) then
         a1 = xcart(icart,1) - restpars(irest,1)
         a2 = xcart(icart,2) - restpars(irest,2)
         a3 = xcart(icart,3) - restpars(irest,3)
         vnorm = sqrt(restpars(irest,4)**2 + restpars(irest,5)**2 + restpars(irest,6)**2)
         v1 = restpars(irest,4)/vnorm
         v2 = restpars(irest,5)/vnorm
         v3 = restpars(irest,6)/vnorm
         b1 = v1 * a1
         b2 = v2 * a2
         b3 = v3 * a3
         w = b1 + b2 + b3
         d = ( a1 - v1*w )**2 + ( a2 - v2*w )**2 + ( a3 - v3*w )**2
         f = f + scale2 * ( &
            dmax1(-w , 0.d0)**2 + &
            dmax1(w - restpars(irest,9), 0.d0)**2 + &
            dmax1(d - restpars(irest,7)**2 , 0.d0 )**2 )
      else if(ityperest(irest).eq.13) then
         a1 = xcart(icart,1) - restpars(irest,1)
         a2 = xcart(icart,2) - restpars(irest,2)
         a3 = xcart(icart,3) - restpars(irest,3)
         vnorm = sqrt(restpars(irest,4)**2 + restpars(irest,5)**2 + restpars(irest,6)**2)
         v1 = restpars(irest,4)/vnorm
         v2 = restpars(irest,5)/vnorm
         v3 = restpars(irest,6)/vnorm
         b1 = v1 * a1
         b2 = v2 * a2
         b3 = v3 * a3
         w = b1 + b2 + b3
         d = ( a1 - v1*w )**2 +( a2 - v2*w )**2 + ( a3 - v3*w )**2
         f = f + scale2 * ( &
            dmin1(-w , 0.d0)**2 * &
            dmin1(w - restpars(irest,9), 0.d0)**2 * &
            dmin1(d - restpars(irest,7)**2 , 0.d0 )**2 )
      else if(ityperest(irest).eq.14) then
         a1 = -(xcart(icart,1) - restpars(irest,1))**2/(2*restpars(irest,3)**2)
         a2 = -(xcart(icart,2) - restpars(irest,2))**2/(2*restpars(irest,4)**2)
         if(a1+a2<=-50) then
            w = -(xcart(icart,3)-restpars(irest,5))
         else
            w = restpars(irest,6)*exp(a1+a2)-(xcart(icart,3)-restpars(irest,5))
         end if
         a1 = dmax1(w,0.d0)
         f = f + scale * a1*a1
      else if(ityperest(irest).eq.15) then
         a1 = -(xcart(icart,1) - restpars(irest,1))**2/(2*restpars(irest,3)**2)
         a2 = -(xcart(icart,2) - restpars(irest,2))**2/(2*restpars(irest,4)**2)
         if(a1+a2<=-50) then
            w = -(xcart(icart,3)-restpars(irest,5))
         else
            w = restpars(irest,6)*exp(a1+a2)-(xcart(icart,3)-restpars(irest,5))
         end if
         a1 = dmin1(w,0.d0)
         f = f + scale * a1*a1
      end if
   end do
   return
end subroutine comprest

!
!  Written by Ernesto G. Birgin, 2009-2011.
!  Copyright (c) 2009-2018, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine pgencan: This is only a interface to set some
!                     parameters. What might be important here
!                     is the setup of the constraint_axis constraint.
!

subroutine pgencan(n,x,fx)

   use sizes
   use compute_data
   use usegencan
   implicit none

   double precision :: lambda(1), rho(1)
   double precision :: epsgpsn,gpsupn,delmin
   double precision :: x(n), fx
   integer :: m,iprint,maxfc,ncomp,iter,fcnt,gcnt,cgcnt,inform
   integer :: n, i
   integer :: trtype1
   integer :: itype, imol

   ! Setup upper and lower bounds for variables. Usually there are none,
   ! but one might want to restrict the rotation of the molecules in one
   ! or more axis

   do i = 1,n/2
      l(i) = - 1.0d+20
      u(i) =   1.0d+20
   end do
   i = n/2
   do itype = 1, ntype
      do imol = 1, nmols(itype)
         if ( constrain_rot(itype,1) ) then
            l(i+1) = rot_bound(itype,1,1) - dabs(rot_bound(itype,1,2))
            u(i+1) = rot_bound(itype,1,1) + dabs(rot_bound(itype,1,2))
         else
            l(i+1) = - 1.0d+20
            u(i+1) =   1.0d+20
         end if
         if ( constrain_rot(itype,2) ) then
            l(i+2) = rot_bound(itype,2,1) - dabs(rot_bound(itype,2,2))
            u(i+2) = rot_bound(itype,2,1) + dabs(rot_bound(itype,2,2))
         else
            l(i+2) = - 1.0d+20
            u(i+2) =   1.0d+20
         end if
         if ( constrain_rot(itype,3) ) then
            l(i+3) = rot_bound(itype,3,1) - dabs(rot_bound(itype,3,2))
            u(i+3) = rot_bound(itype,3,1) + dabs(rot_bound(itype,3,2))
         else
            l(i+3) = - 1.0d+20
            u(i+3) =   1.0d+20
         end if
         i = i + 3
      end do
   end do

   m = 0
   epsgpsn = 1.0d-06
   maxfc   = 10 * maxit
   if(init1) iprint  = iprint1
   if(.not.init1) iprint  = iprint2
   ncomp   = 50
   delmin = 2.d0
   trtype1 = 1

   call easygencan(n,x,l,u,m,lambda,rho,epsgpsn,maxit,maxfc,&
      trtype1,iprint,ncomp,fx,g,gpsupn,iter,fcnt,&
      gcnt,cgcnt,inform,wi,wd,delmin)
   if( inform.ne.7 .and.(iprint1.gt.0 .or. iprint2.gt.0) ) write(*,*)

   return
end subroutine pgencan

!
! Function that test convergence according to Packmol precision
!

function packmolprecision(n,x)
   use input, only : precision
   use compute_data, only : fdist, frest
   implicit none
   integer :: n
   double precision :: f, x(n)
   logical :: packmolprecision

   call computef(n,x,f)

   packmolprecision = .false.
   if ( fdist < precision .and. frest < precision ) then
      packmolprecision = .true.
   end if

end function packmolprecision

println("Initalizing enviroment...")
import Pkg; Pkg.activate(@__DIR__); Pkg.instantiate()
using PDBTools
using CellListMap

# 
# Note: this tests depend on each molecule being identified as a single residue
# in the structure. Thus, the PDB file should have a single residue for each molecule,
# for instance, a protein must have a single residue name for all its atoms.
# The residue numbers are overwritten by the `resnumbers` option of the input
# packmol files .
#

struct MinimumDistance 
    i::Int
    j::Int
    d::Float64 
end
function update_mind(i, j, d2, pdb, md::MinimumDistance)
    residue(pdb[i]) == residue(pdb[j]) && return md
    d = sqrt(d2)
    return d < md.d ?  MinimumDistance(i, j, d) : md
end
CellListMap.reducer(md1::MinimumDistance, md2::MinimumDistance) = md1.d < md2.d ? md1 : md2
CellListMap.copy_output(md::MinimumDistance) = md
CellListMap.reset_output(::MinimumDistance) = MinimumDistance(0, 0, +Inf)

function check_mind(input_file::String)
    tolerance = nothing
    output_name = nothing
    unitcell = nothing
    precision = 0.01
    for line in eachline(input_file)
        line = strip(line)
        isempty(line) && continue
        keyword, values... = split(line)
        keyword == "tolerance" && (tolerance = parse(Float64, values[1]))
        keyword == "output" && (output_name = values[1])
        keyword == "precision" && (precision = parse(Float64,values[1]))
        if keyword == "pbc" 
            if length(values) == 3
                unitcell = parse.(Float64,values[1:3])
            elseif length(values) == 6
                unitcell = parse.(Float64,values[4:6]) - parse.(Float64,values[1:3])
            else
                error("pbc not properly set")
            end
        end
    end
    if isnothing(tolerance) || isnothing(output_name)
        error("tolerance or output not found")
    end
    pdb = readPDB(string(output_name))
    sys = ParticleSystem(
        positions = coor.(pdb),
        unitcell = unitcell,
        cutoff = tolerance * 1.5,
        output = MinimumDistance(0, 0, +Inf),
    )
    mind = map_pairwise((x,y,i,j,d2,md) -> update_mind(i, j, d2, pdb, md), sys)
    if (mind.d < (1 - precision) * tolerance)
        error("""\n

            Packing reported success, but minimum distance is not correct for $input_file
            Obtained minimum-distance = $(mind.d) for tolerance $tolerance and precision $precision.
            Atoms: $(mind.i) and $(mind.j) - VMD: index $(mind.i-1) $(mind.j-1)
            
        """)
    end
    printstyled(" OK. \n"; color=:green, bold=true)
    return nothing
end 

println("Running tests...")
if !isinteractive()
    packmol_arg = findfirst(==("-packmol"), ARGS)
    if !isnothing(packmol_arg)
        packmol = ARGS[packmol_arg + 1]
        popat!(ARGS, packmol_arg + 1)
        popat!(ARGS, packmol_arg)
    else
        packmol = joinpath(@__DIR__,"..","packmol")
    end
    println(" Packmol path: $packmol")
    for input_test in ARGS
        print(" Running test $input_test ...")
        log = IOBuffer()
        if packmol != "nothing"
            run(pipeline(`$packmol`; stdin=input_test, stdout=log))
            if occursin("Success!", String(take!(log)))
                check_mind(input_test)
            else
                error("Failed packing for $input_test")
            end
        else
            println("\n Skipping packmol run. Using available output file.")
            check_mind(input_test)
        end
    end
end

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! subroutine movebad: Move the worse molecules to new positions
!

subroutine movebad(n,x,fx,movebadprint)

   use sizes
   use compute_data
   use input, only : movefrac, movebadrandom, precision, maxmove
   use usegencan
   use flashsort
   use ahestetic
   implicit none

   ! Internal variables
   integer :: n, i, j, icart, itype, iatom, imol, ilubar, ilugan, &
      ilubar2, ilugan2, nbad, igood, ibad, nmove
   double precision :: x(n), fx, rnd, frac
   double precision :: fdist_mol, frest_mol
   logical :: movebadprint, hasbad

   if(movebadprint) write(*,*) ' Moving worst molecules ... '

   icart = 0
   do itype = 1, ntype
      if(.not.comptype(itype)) then
         icart = icart + nmols(itype)*natoms(itype)
      else
         do imol = 1, nmols(itype)
            do iatom = 1, natoms(itype)
               icart = icart + 1
               fdist_atom(icart) = 0.d0
               frest_atom(icart) = 0.d0
            end do
         end do
      end if
   end do

   move = .true.
   if(movebadprint) write(*,*) ' Function value before moving molecules:',fx
   do i = 1, ntotat
      radiuswork(i) = radius(i)
      radius(i) = radius_ini(i)
   end do
   call computef(n,x,fx)
   move = .false.

   ! Moving the worst molecules

   hasbad = .false.
   icart = 0
   do itype = 1, ntype
      if(.not.comptype(itype)) then
         icart = icart + nmols(itype)*natoms(itype)
      else

         ! Checking the function value for each molecule

         nbad = 0
         do imol = 1, nmols(itype)
            fdist_mol = 0.d0
            frest_mol = 0.d0
            do iatom = 1, natoms(itype)
               icart = icart + 1
               fdist_mol = dmax1(fdist_mol,fdist_atom(icart))
               frest_mol = dmax1(frest_mol,frest_atom(icart))
            end do
            if(fdist_mol > precision .or. frest_mol > precision ) then
               hasbad = .true.
               nbad = nbad + 1
               fmol(imol) = fdist_mol + frest_mol
            else
               fmol(imol) = 0.d0
            end if
         end do
         frac = dfloat(nbad)/dfloat(nmols(itype))
         if(movebadprint) write(*,"( a,i9,a,f8.2,a )") &
            '  Type ',itype,' molecules with non-zero contributions:', &
            100.d0*frac,'%'

         if(nbad.gt.0) then

            frac = dmin1(movefrac,frac)

            ! Ordering molecules from best to worst

            mflash = 1 + nmols(itype)/10
            call flash1(fmol,nmols(itype),lflash,mflash,indflash)

            ! Moving molecules

            nmove = min0(maxmove(itype),max0(int(nmols(itype)*frac),1))
            if(movebadprint) then
               write(*,"( a,i9,a,i9 )") '  Moving ',nmove,' molecules of type ',itype
               if ( movebadrandom ) then
                  write(*,*) ' New positions will be aleatory (movebadrandom is set) '
               else
                  write(*,*) ' New positions will be based on good molecules (movebadrandom is not set) '
               end if
            end if
            imol = 0
            do i = 1, itype - 1
               if(comptype(i)) imol = imol + nmols(i)
            end do
            write(*,prog2_line)
            write(*,"( '          |',$)")
            j = 0
            do i = 1, nmove
               ibad = nmols(itype) - i + 1
               igood = int(rnd()*nmols(itype)*frac) + 1
               ilubar = 3*(indflash(ibad)+imol-1)
               ilugan = 3*(indflash(ibad)+imol-1)+3*ntotmol
               ilubar2 = 3*(indflash(igood)+imol-1)
               ilugan2 = 3*(indflash(igood)+imol-1)+3*ntotmol
               if ( movebadrandom ) then
                  x(ilubar+1) = sizemin(1) + rnd()*(sizemax(1)-sizemin(1))
                  x(ilubar+2) = sizemin(2) + rnd()*(sizemax(2)-sizemin(2))
                  x(ilubar+3) = sizemin(3) + rnd()*(sizemax(3)-sizemin(3))
               else
                  x(ilubar+1) = x(ilubar2+1) - 0.3*dmax(itype)+0.6*rnd()*dmax(itype)
                  x(ilubar+2) = x(ilubar2+2) - 0.3*dmax(itype)+0.6*rnd()*dmax(itype)
                  x(ilubar+3) = x(ilubar2+3) - 0.3*dmax(itype)+0.6*rnd()*dmax(itype)
               end if
               x(ilugan+1) = x(ilugan2+1)
               x(ilugan+2) = x(ilugan2+2)
               x(ilugan+3) = x(ilugan2+3)
               call restmol(itype,ilubar,n,x,fx,.true.)
               do while( j <= 60*i/nmove )
                  write(*,"('*',$)")
                  j = j + 1
               end do
            end do
            write(*,"('|')")
         end if
      end if
   end do

   call computef(n,x,fx)
   if(movebadprint) write(*,*) ' Function value after moving molecules:', fx
   do i = 1, ntotat
      radius(i) = radiuswork(i)
   end do

   return
end subroutine movebad

!  
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!  

! Routine to print the title 

subroutine title()

    use ahestetic
    write(*,hash3_line)
    write(*,"(' PACKMOL - Packing optimization for the automated generation of', /&
             &' starting configurations for molecular dynamics simulations.', /&
             &' ',/&
             &t61,' Version 21.2.1 ')")
    write(*,hash3_line)

end subroutine title

!  
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!  
! Subroutines that set the indexes of a three-dimensional array
! given the undimensional counter of the vector (for an array
! with dimensions (0:nboxes(1)+1,0:nboxes(2)+1,0:nboxes(3)+1), and
! vice-versa.
!

subroutine ibox_to_ijk(ibox,i,j,k)

  use compute_data, only : nb2
  implicit none
  integer :: ibox, i, j, k, iibox

  k = mod(ibox,nb2(3))
  if ( k == 0 ) k = nb2(3)

  iibox = ibox - k 
  iibox = iibox / nb2(3) + 1 
  j = mod(iibox,nb2(2))
  if ( j == 0 ) j = nb2(2)

  iibox = iibox - j
  iibox = iibox / nb2(2) + 1
  i = mod(iibox,nb2(1))
  if ( i == 0 ) i = nb2(1)

  k = k - 1
  j = j - 1
  i = i - 1

end subroutine ibox_to_ijk

subroutine ijk_to_ibox(i,j,k,ibox)

  use compute_data, only : nb2
  implicit none
  integer :: i, j, k, ibox

  ibox = i*nb2(2)*nb2(3) + j*nb2(3) + k + 1

end subroutine ijk_to_ibox

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Module that carries the input parameters read from the input file
!

module input

   use sizes
   implicit none

   integer :: nlines
   integer :: nrest
   integer :: seed
   integer :: nloop, nloop_all
   integer :: writeout
   integer :: ntype_with_fixed
   integer :: ntcon(9)

   integer, allocatable :: nconnect(:,:)  ! (ntotat,9)
   integer, allocatable :: irestline(:) ! (maxrest)
   integer, allocatable :: linestrut(:,:) ! (ntype,2)
   integer, allocatable :: resnumbers(:) ! (ntype)
   integer, allocatable :: maxcon(:) ! (ntotat)
   integer, allocatable :: input_itype(:) ! (ntype)
   integer, allocatable :: nloop_type(:) ! (ntype)
   integer, allocatable :: nloop0_type(:) ! (ntype)
   integer, allocatable :: maxmove(:) ! (ntype)

   double precision :: dism
   double precision :: precison
   double precision :: sidemax
   double precision :: discale
   double precision :: movefrac
   double precision :: add_sides_fix
   double precision :: precision
   double precision :: fbins
   double precision :: short_tol_dist
   double precision :: short_tol_scale

   double precision, allocatable :: amass(:) ! (ntotat)
   double precision, allocatable :: charge(:) ! (ntotat)

   logical :: writebad
   logical :: tinker
   logical :: pdb
   logical :: crd
   logical :: xyz
   logical :: check
   logical :: chkgrad
   logical :: randini
   logical :: movebadrandom
   logical :: add_amber_ter, amber_ter_preserve
   logical :: add_box_sides
   logical :: fix
   logical :: avoidoverlap
   logical :: packall
   logical :: use_short_tol
   logical :: hexadecimal_indices
   logical :: disable_movebad

   logical, allocatable :: changechains(:) ! (ntype)
   logical, allocatable :: fixedoninput(:) ! (ntype)
   logical, allocatable :: connect(:) ! (ntype)

   character(len=1), parameter :: forbidden_char = '~'
   character(len=strl) :: xyzout
   character(len=strl) :: crdfile

   character(len=1), allocatable :: chain(:) ! (ntype)
   character(len=3), allocatable :: ele(:) ! (ntotat)
   character(len=8), allocatable :: segid(:) ! (segment identifier)
   character(len=strl), allocatable :: pdbfile(:) ! (ntype)
   character(len=strl), allocatable :: name(:) ! (ntype)
   character(len=strl), allocatable :: keyword(:,:) ! (nlines,maxkeywords)
   character(len=strl), allocatable :: inputfile(:) ! (nlines)
   character(len=strl), allocatable :: restart_from(:), restart_to(:) ! (0:ntype)

end module input

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! subroutine tobar: moves molecules to their baricentres
!

subroutine tobar()

   use sizes
   use compute_data, only : coor, ntype, natoms, idfirst
   implicit none
   integer :: idatom, itype, iatom
   double precision :: xcm, ycm, zcm

   do itype = 1, ntype
      idatom = idfirst(itype) - 1
      xcm = 0.d0
      ycm = 0.d0
      zcm = 0.d0
      do iatom = 1, natoms(itype)
         idatom = idatom + 1
         xcm = xcm + coor(idatom,1)
         ycm = ycm + coor(idatom,2)
         zcm = zcm + coor(idatom,3)
      end do
      xcm = xcm / natoms(itype)
      ycm = ycm / natoms(itype)
      zcm = zcm / natoms(itype)
      idatom = idfirst(itype) - 1
      do iatom = 1, natoms(itype)
         idatom = idatom + 1
         coor(idatom,1) = coor(idatom,1) - xcm
         coor(idatom,2) = coor(idatom,2) - ycm
         coor(idatom,3) = coor(idatom,3) - zcm
      end do
   end do

   return
end subroutine tobar

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine resetcells: Subroutine that resets the occupancy of
!                        linked cell cells
!

subroutine resetcells()
   use input, only: fix, ntype_with_fixed
   use cell_indexing, only: icell_to_cell, index_cell, setcell
   use compute_data, only: latomfirst, lcellfirst, lcellnext, empty_cell, ncells, &
                           ntype, natoms, ntotat, nfixedat, xcart, latomnext
   implicit none
   integer :: cell(3), icell, iftype, icart, ifatom

   ! Reset data for cells that contain fixed atom
   lcellnext(:) = 0
   lcellfirst = 0
   latomfirst(:,:,:) = 0
   latomnext(:) = 0
   empty_cell(:,:,:) = .true.
   if(fix) then
      icart = ntotat - nfixedat
      do iftype = ntype + 1, ntype_with_fixed
         do ifatom = 1, natoms(iftype)
            icart = icart + 1
            call setcell(xcart(icart,:),cell)
            latomnext(icart) = latomfirst(cell(1),cell(2),cell(3))
            latomfirst(cell(1),cell(2),cell(3)) = icart
            if ( empty_cell(cell(1),cell(2),cell(3)) ) then
               empty_cell(cell(1),cell(2),cell(3)) = .false.
               icell = index_cell(cell,ncells)
               lcellnext(icell) = lcellfirst
               lcellfirst = icell
            end if
         end do
      end do
   end if

end subroutine resetcells

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine initial: Subroutine that reset parameters and
!                     builds the initial point
!

subroutine initial(n,x)

   use exit_codes
   use sizes
   use cell_indexing, only: setcell
   use compute_data
   use input, only : randini, ntype_with_fixed, fix, chkgrad, avoidoverlap,&
      discale, precision, sidemax, restart_from, input_itype,&
      nloop0_type
   use usegencan
   use ahestetic
   use pbc
   implicit none
   integer :: n, i, j, idatom, iatom, ilubar, ilugan, icart, itype, &
      imol, ntry, cell(3), ic, jc, kc, ifatom, &
      idfatom, iftype, jatom, ioerr, max_guess_try

   double precision :: x(n), beta, gamma, theta, &
      fx, cell_side, rnd, xrnd(3), v1(3), v2(3), v3(3), xcm(3)
   double precision :: scale_rnd_guess
   double precision, parameter :: twopi = 8.d0*datan(1.d0)
   double precision, allocatable :: cm_min(:,:), cm_max(:,:)

   logical :: overlap, movebadprint, hasbad

   character(len=strl) :: record

   ! We need to initialize the move logical variable
   move = .false.

   ! Default status of the function evaluation
   init1 = .false.
   lcellfirst = 0

   ! Initialize the comptype logical array
   comptype(1:ntype_with_fixed) = .true.

   ! Penalty factors for the objective function relative to restrictions
   ! Default values: scale = 1.d2, scale2 = 1.d1

   scale = 1.d0
   scale2 = 1.d-2
   call tobar()

   ! Compute maximum internal distance within each type of molecule

   do itype = 1, ntype
      dmax(itype) = 0.d0
      idatom = idfirst(itype) - 1
      do iatom = 1, natoms(itype) - 1
         do jatom = iatom + 1, natoms(itype)
            dmax(itype) = dmax1 ( dmax(itype),&
               (coor(idatom+iatom,1)-coor(idatom+jatom,1))**2+&
               (coor(idatom+iatom,2)-coor(idatom+jatom,2))**2+&
               (coor(idatom+iatom,3)-coor(idatom+jatom,3))**2 )
         end do
      end do
      dmax(itype) = dsqrt(dmax(itype))
      write(*,*) ' Maximum internal distance of type ',itype,': ',&
         dmax(itype)
      if(dmax(itype).eq.0.) dmax(itype) = 1.d0
   end do

   ! Maximum size of the system: if you system is very large (about
   ! 80 nm wide), increase the sidemax parameter.
   ! Otherwise, the packing can be slow and unsucesful
   allocate(cm_min(ntype,3), cm_max(ntype,3))
   x(:) = 0.d0
   call restmol(1,0,n,x,fx,.true.)
   sizemin(1:3) = x(1:3) - sidemax
   sizemax(1:3) = x(1:3) + sidemax
   write(*,*) ' All atoms must be within these coordinates: '
   write(*,*) '  x: [ ', sizemin(1),', ', sizemax(1), ' ] '
   write(*,*) '  y: [ ', sizemin(2),', ', sizemax(2), ' ] '
   write(*,*) '  z: [ ', sizemin(3),', ', sizemax(3), ' ] '
   write(*,*) ' If the system is larger than this, increase the sidemax parameter. '

   ! Create first aleatory guess

   i = 0
   j = ntotmol*3
   do itype = 1, ntype
      do imol = 1, nmols(itype)
         x(i+1) = sizemin(1) + rnd()*(sizemax(1)-sizemin(1))
         x(i+2) = sizemin(2) + rnd()*(sizemax(2)-sizemin(2))
         x(i+3) = sizemin(3) + rnd()*(sizemax(3)-sizemin(3))
         if ( constrain_rot(itype,1) ) then
            x(j+1) = ( rot_bound(itype,1,1) - dabs(rot_bound(itype,1,2)) ) + &
               2.d0*rnd()*dabs(rot_bound(itype,1,2))
         else
            x(j+1) = twopi*rnd()
         end if
         if ( constrain_rot(itype,2) ) then
            x(j+2) = ( rot_bound(itype,2,1) - dabs(rot_bound(itype,2,2)) ) + &
               2.d0*rnd()*dabs(rot_bound(itype,2,2))
         else
            x(j+2) = twopi*rnd()
         end if
         if ( constrain_rot(itype,3) ) then
            x(j+3) = ( rot_bound(itype,3,1) - dabs(rot_bound(itype,3,2)) ) + &
               2.d0*rnd()*dabs(rot_bound(itype,3,2))
         else
            x(j+3) = twopi*rnd()
         end if
         i = i + 3
         j = j + 3
      end do
   end do

   ! Initialize cartesian coordinate array for the first time

   ilubar = 0
   ilugan = ntotmol*3
   icart = 0
   do itype = 1, ntype
      do imol = 1, nmols(itype)
         xcm = x(ilubar+1:ilubar+3)
         beta = x(ilugan+1)
         gamma = x(ilugan+2)
         theta = x(ilugan+3)
         call eulerrmat(beta,gamma,theta,v1,v2,v3)
         idatom = idfirst(itype) - 1
         do iatom = 1, natoms(itype)
            icart = icart + 1
            idatom = idatom + 1
            call compcart(xcart(icart,1:3),xcm,coor(idatom,1:3),v1,v2,v3)
            fixedatom(icart) = .false.
         end do
      end do
   end do
   if(fix) then
      icart = ntotat - nfixedat
      do iftype = ntype + 1, ntype_with_fixed
         idfatom = idfirst(iftype) - 1
         do ifatom = 1, natoms(iftype)
            idfatom = idfatom + 1
            icart = icart + 1
            xcart(icart,1) = coor(idfatom,1)
            xcart(icart,2) = coor(idfatom,2)
            xcart(icart,3) = coor(idfatom,3)
            fixedatom(icart) = .true.
            ! Check if fixed molecules are compatible with PBC given
            if (using_pbc) then
               do i = 1, 3
                  if (xcart(icart, i) < pbc_min(i) .or. xcart(icart, i) > pbc_max(i)) then
                     write(*,*) "ERROR: Fixed molecule are outside the PBC box:"
                     write(*,*) "   Atom: ", ifatom, " of molecule: ", input_itype(iftype), " - coordinate: ", i
                     write(*,*) "  ", xcart(icart, i), " not in [", pbc_min(i), ", ", pbc_max(i), "]"
                     write(*,*) "(after translating/rotation the fixed molecule with the given orientation)"
                     stop exit_code_input_error
                  end if
               end do
            end if
         end do
      end do
   end if

   ! Performing some steps of optimization for the restrictions only

   write(*,hash3_line)
   write(*,"('  Building initial approximation ... ' )")
   write(*,hash3_line)
   write(*,"('  Adjusting initial point to fit the constraints ')")
   write(*,dash2_line)
   init1 = .true.
   call swaptype(n,x,itype,0) ! Initialize swap arrays
   itype = 0
   do while( itype <= ntype )
      itype = itype + 1
      if ( itype <= ntype ) then
         call swaptype(n,x,itype,1) ! Set arrays for this type
      else
         call swaptype(n,x,itype,3) ! Restore arrays if itype = ntype + 1
         exit
      end if
      write(*,dash3_line)
      write(*,*) ' Molecules of type: ', input_itype(itype)
      write(*,*)
      i = 0
      hasbad = .true.
      call computef(n,x,fx)
      do while( frest > precision .and. i.le. nloop0_type(itype)-1 .and. hasbad)
         i = i + 1
         write(*,prog1_line)
         call pgencan(n,x,fx)
         call computef(n,x,fx)
         if(frest > precision) then
            write(*,"( a,i6,a,i6 )")'  Fixing bad orientations ... ', i,' of ', nloop0_type(itype)
            movebadprint = .true.
            call movebad(n,x,fx,movebadprint)
         end if
      end do
      write(*,*)
      write(*,*) ' Restraint-only function value: ', fx
      write(*,*) ' Maximum violation of the restraints: ', frest

      call swaptype(n,x,itype,2) ! Save current type results

      if( hasbad .and. frest > precision ) then
         write(*,*) ' ERROR: Packmol was unable to put the molecules'
         write(*,*) '        in the desired regions even without'
         write(*,*) '        considering distance tolerances. '
         write(*,*) '        Probably there is something wrong with'
         write(*,*) '        the constraints, since it seems that'
         write(*,*) '        the molecules cannot satisfy them at'
         write(*,*) '        at all. '
         write(*,*) '        Please check the spatial constraints and'
         write(*,*) '        try again.'
         if ( i .ge. nloop0_type(itype)-1 ) then
         end if
         write(*,*) ' >The maximum number of cycles (',nloop0_type(itype),') was achieved.'
         write(*,*) '  You may try increasing it with the',' nloop0 keyword, as in: nloop0 1000 '
         stop exit_code_failed_to_converge
      end if
   end do
   init1 = .false.

   ! Rescaling sizemin and sizemax in order to build the patch of cells

   write(*,dash3_line)
   write(*,*) ' Rescaling maximum and minimum coordinates... '
   sizemin(1:3) = 1.d20
   sizemax(1:3) = -1.d20
   ! Maximum and minimum coordinates of fixed molecules
   icart = ntotat - nfixedat
   do itype = ntype + 1, ntype_with_fixed
      do imol = 1, nmols(itype)
         do iatom = 1, natoms(itype)
            icart = icart + 1
            sizemin(1) = dmin1(sizemin(1),xcart(icart,1))
            sizemin(2) = dmin1(sizemin(2),xcart(icart,2))
            sizemin(3) = dmin1(sizemin(3),xcart(icart,3))
            sizemax(1) = dmax1(sizemax(1),xcart(icart,1))
            sizemax(2) = dmax1(sizemax(2),xcart(icart,2))
            sizemax(3) = dmax1(sizemax(3),xcart(icart,3))
         end do
      end do
   end do
   icart = 0
   do itype = 1, ntype
      do imol = 1, nmols(itype)
         do iatom = 1, natoms(itype)
            icart = icart + 1
            sizemin(1) = dmin1(sizemin(1),xcart(icart,1))
            sizemin(2) = dmin1(sizemin(2),xcart(icart,2))
            sizemin(3) = dmin1(sizemin(3),xcart(icart,3))
            sizemax(1) = dmax1(sizemax(1),xcart(icart,1))
            sizemax(2) = dmax1(sizemax(2),xcart(icart,2))
            sizemax(3) = dmax1(sizemax(3),xcart(icart,3))
         end do
      end do
   end do
   write(*,*) ' Mininum and maximum coordinates after constraint fitting: '
   write(*,*) '  x: [ ', sizemin(1),', ', sizemax(1), ' ] '
   write(*,*) '  y: [ ', sizemin(2),', ', sizemax(2), ' ] '
   write(*,*) '  z: [ ', sizemin(3),', ', sizemax(3), ' ] '
   sizemin = sizemin - 1.1d0 * radmax
   sizemax = sizemax + 1.1d0 * radmax
   ! When *not* using PBC, actually PBCs are used, but particles
   ! wont interact across the PBC because there is an empty layer
   ! of cells, given by the shift in the sizemin and sizemax dimensions,
   ! above defined. 
   if (.not. using_pbc) then
      pbc_min = sizemin
      pbc_max = sizemax
      pbc_length = pbc_max - pbc_min
   end if 

   ! Computing the size of the patches
   write(*,*) ' Computing size of patches... '
   cell_side = discale * (1.01d0 * radmax)
   do i = 1, 3
      ncells(i) = max(1,floor(pbc_length(i)/cell_side))
      cell_length(i) = pbc_length(i) / ncells(i)
   end do
   write(*,*) ' Number of cells in each direction and cell sides: '
   write(*,*) '  x: ', ncells(1), ' cells of size ', cell_length(1)
   write(*,*) '  y: ', ncells(2), ' cells of size ', cell_length(2)
   write(*,*) '  z: ', ncells(3), ' cells of size ', cell_length(3)
   write(*,"(a, 3(f10.5))") '  Cell-system length: ', pbc_length(1:3) 

   ! Allocate arrays depending on the number of cells
   allocate(latomfirst(ncells(1),ncells(2),ncells(3)))
   allocate(latomfix(ncells(1),ncells(2),ncells(3)))
   allocate(lcellnext(ncells(1)*ncells(2)*ncells(3)))
   allocate(empty_cell(ncells(1),ncells(2),ncells(3)))

   ! Reseting linked lists arrays
   latomfix(:,:,:) = 0
   latomfirst(:,:,:) = 0
   latomnext(:) = 0
   empty_cell(:,:,:) = .true.

   ! If there are fixed molecules, add them permanently to the latomfix array
   if(fix) then
      write(*,*) ' Add fixed molecules to permanent arrays... '
      icart = ntotat - nfixedat
      do iftype = ntype + 1, ntype_with_fixed
         do ifatom = 1, natoms(iftype)
            icart = icart + 1
            call setcell(xcart(icart,:),cell)
            latomnext(icart) = latomfix(cell(1),cell(2),cell(3))
            latomfix(cell(1),cell(2),cell(3)) = icart
            latomfirst(cell(1),cell(2),cell(3)) = icart
            ibtype(icart) = iftype
            ibmol(icart) = 1
         end do
      end do
   end if

   ! Reseting mass centers to be within the regions

   write(*,*) ' Reseting center of mass... '
   cm_min = 1.d20
   cm_max = -1.d20
   icart = 0
   do itype = 1, ntype
      do imol = 1, nmols(itype)
         xcm(:) = 0.d0
         do iatom = 1, natoms(itype)
            icart = icart + 1
            xcm(:) = xcm(:) + xcart(icart,1:3)
         end do
         xcm(:) = xcm(:) / natoms(itype)
         cm_min(itype,:) = dmin1(cm_min(itype,:),xcm(:))
         cm_max(itype,:) = dmax1(cm_max(itype,:),xcm(:))
      end do
   end do

   ! If there is a restart file for all system, read it

   if ( restart_from(0) /= 'none' ) then
      record = restart_from(0)
      write(*,*) ' Restarting all system from file: ', trim(adjustl(record))
      open(10,file=restart_from(0),status='old',action='read',iostat=ioerr)
      ilubar = 0
      ilugan = ntotmol*3
      do i = 1, ntotmol
         read(10,*,iostat=ioerr) x(ilubar+1), x(ilubar+2), x(ilubar+3), &
            x(ilugan+1), x(ilugan+2), x(ilugan+3)
         if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Could not read restart file: ', trim(adjustl(record))
            stop exit_code_open_file
         end if
         ilubar = ilubar + 3
         ilugan = ilugan + 3
      end do
      close(10)
      return
   end if

   ! Building random initial point

   write(*,dash3_line)
   write(*,*) ' Setting initial trial coordinates ... '
   write(*,dash2_line)

   if ( chkgrad ) then
      write(*,*) ' For checking gradient, will set avoidoverlap to false. '
      avoidoverlap = .false.
      max_guess_try = 1
      scale_rnd_guess = 1.5d0 ! move guess outside the constraints/box
   else
      max_guess_try = 20
      scale_rnd_guess = 1.d0
   end if

   ! Setting random center of mass coordinates, within size limits

   ilubar = 0
   do itype = 1, ntype
      if ( restart_from(itype) /= 'none' ) then
         ilubar = ilubar + nmols(itype)*3
         cycle
      end if
      do imol = 1, nmols(itype)
         if ( .not. avoidoverlap ) then
            fx = 1.d0
            ntry = 0
            do while((fx > precision) .and. (ntry < max_guess_try))
               ntry = ntry + 1
               call random_number(xrnd)
               x(ilubar+1:ilubar+3) = &
                  cm_min(itype,:) + xrnd(:)*(cm_max(itype,:)-cm_min(itype,:)) * scale_rnd_guess
               call restmol(itype,ilubar,n,x,fx,.false.)
            end do
         else
            fx = 1.d0
            ntry = 0
            overlap = .false.
            do while((overlap .or. fx > precision) .and. (ntry < max_guess_try))
               overlap = .false.
               ntry = ntry + 1
               call random_number(xrnd)
               x(ilubar+1:ilubar+3) = &
                  cm_min(itype,:) + xrnd(:)*(cm_max(itype,:)-cm_min(itype,:)) * scale_rnd_guess
               if(fix) then
                  call setcell(x(ilubar+1:ilubar+3),cell)
                  icell: do ic = -1, 1 
                     do jc = -1, 1
                        do kc = -1, 1
                           if(latomfix(cell_ind(cell(1)+ic,ncells(1)),&
                                       cell_ind(cell(2)+jc,ncells(2)),&
                                       cell_ind(cell(3)+kc,ncells(3)) &
                                      ) /= 0) then
                              overlap = .true.
                              exit icell
                           end if
                        end do
                     end do
                  end do icell
               end if
               if(.not.overlap) call restmol(itype,ilubar,n,x,fx,.false.)
            end do
         end if
         ilubar = ilubar + 3
      end do
   end do

   ! Setting random angles, except if the rotations were constrained

   ilugan = ntotmol*3
   do itype = 1, ntype
      if ( restart_from(itype) /= 'none' ) then
         ilugan = ilugan + nmols(itype)*3
         cycle
      end if
      do imol = 1, nmols(itype)
         if ( constrain_rot(itype,1) ) then
            x(ilugan+1) = ( rot_bound(itype,1,1) - dabs(rot_bound(itype,1,2)) ) + &
               2.d0*rnd()*dabs(rot_bound(itype,1,2))
         else
            x(ilugan+1) = twopi*rnd()
         end if
         if ( constrain_rot(itype,2) ) then
            x(ilugan+2) = ( rot_bound(itype,2,1) - dabs(rot_bound(itype,2,2)) ) + &
               2.d0*rnd()*dabs(rot_bound(itype,2,2))
         else
            x(ilugan+2) = twopi*rnd()
         end if
         if ( constrain_rot(itype,3) ) then
            x(ilugan+3) = ( rot_bound(itype,3,1) - dabs(rot_bound(itype,3,2)) ) + &
               2.d0*rnd()*dabs(rot_bound(itype,3,2))
         else
            x(ilugan+3) = twopi*rnd()
         end if
         ilugan = ilugan + 3
      end do
   end do

   ! Compare analytical and finite-difference gradients

   if(chkgrad) then
      cell_side = discale * (1.01d0 * radmax)
      do i = 1, 3
         ncells(i) = max(1,floor(pbc_length(i)/cell_side))
         cell_length(i) = pbc_length(i) / ncells(i)
      end do
      call comparegrad(n,x)
      stop
   end if

   !
   ! Reading restart files of specific molecule types, if available
   !

   ilubar = 0
   ilugan = ntotmol*3
   do itype = 1, ntype
      if ( restart_from(itype) /= 'none' ) then
         record = restart_from(itype)
         write(*,dash3_line)
         write(*,*) ' Molecules of type: ', input_itype(itype)
         write(*,*) ' Will restart coordinates from: ', trim(adjustl(record))
         open(10,file=record,status='old',action='read',iostat=ioerr)
         if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Could not open restart file: ', trim(adjustl(record))
            stop exit_code_open_file
         end if
         do i = 1, nmols(itype)
            read(10,*,iostat=ioerr) x(ilubar+1), x(ilubar+2), x(ilubar+3), &
               x(ilugan+1), x(ilugan+2), x(ilugan+3)
            if ( ioerr /= 0 ) then
               write(*,*) ' ERROR: Could not read restart file: ', trim(adjustl(record))
               stop exit_code_open_file
            end if
            ilubar = ilubar + 3
            ilugan = ilugan + 3
         end do
         close(10)
         call swaptype(n,x,itype,0) ! Initialize swap arrays
         call swaptype(n,x,itype,1) ! Set arrays for this type
         call computef(n,x,fx)
         write(*,*) ' Maximum violation of the restraints: ', frest
         write(*,*) ' Maximum violation of minimum atom distances: ', fdist
         call swaptype(n,x,itype,3) ! Restore all-molecule arrays
      else
         ilubar = ilubar + nmols(itype)*3
         ilugan = ilugan + nmols(itype)*3
      end if
   end do

   ! Return with current random point (not default)

   if(randini) return

   ! Adjusting current point to fit the constraints

   init1 = .true.
   call swaptype(n,x,itype,0) ! Initialize swap arrays
   itype = 0
   do while( itype <= ntype )
      itype = itype + 1
      if ( itype == ntype + 1 ) then
         call swaptype(n,x,itype,3) ! Restore arrays for all molecules
         exit
      end if
      if ( restart_from(itype) /= 'none' ) cycle
      call swaptype(n,x,itype,1) ! Set arrays for this type
      write(*,dash3_line)
      write(*,*) ' Molecules of type: ', input_itype(itype)
      write(*,*) ' Adjusting random positions to fit the constraints. '
      i = 0
      call computef(n,x,fx)
      hasbad = .true.
      do while( frest > precision .and. i <= nloop0_type(itype)-1 .and. hasbad)
         i = i + 1
         write(*,prog1_line)
         call pgencan(n,x,fx)
         call computef(n,x,fx)
         if(frest > precision) then
            write(*,"( a,i6,a,i6 )")'  Fixing bad orientations ... ', i,' of ', nloop0_type(itype)
            movebadprint = .true.
            call movebad(n,x,fx,movebadprint)
         end if
      end do
      write(*,*) ' Restraint-only function value: ', fx
      write(*,*) ' Maximum violation of the restraints: ', frest
      call swaptype(n,x,itype,2) ! Save results for this type
   end do
   init1 = .false.
   write(*,hash3_line)

   ! Deallocate allocated arrays
   deallocate(cm_min, cm_max)

   return
end subroutine initial

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Gradient relative to restraints
!

subroutine gwalls(icart,irest)

   use sizes
   use compute_data

   implicit none
   integer :: icart, irest
   double precision :: a1, a2, a3, a4, a5, a6, xmin, ymin, zmin, &
      xmax, ymax, zmax, &
      clength, b1, b2, b3, c1, c2, w, d, rg(3), &
      vnorm, vv1, vv2, vv3, frab, frac, frbc, &
      dfra(3), dfrb(3), dfrc(3)
   double precision :: xmed, ymed, zmed
   double precision :: x, y, z

   if(ityperest(irest).eq.2) then
      clength = restpars(irest,4)
      xmin = restpars(irest,1)
      ymin = restpars(irest,2)
      zmin = restpars(irest,3)
      xmax = restpars(irest,1) + clength
      ymax = restpars(irest,2) + clength
      zmax = restpars(irest,3) + clength
      a1 = xcart(icart,1) - xmin
      a2 = xcart(icart,2) - ymin
      a3 = xcart(icart,3) - zmin
      if(a1.lt.0.d0) gxcar(icart,1) = gxcar(icart,1) + scale * 2.d0 * a1
      if(a2.lt.0.d0) gxcar(icart,2) = gxcar(icart,2) + scale * 2.d0 * a2
      if(a3.lt.0.d0) gxcar(icart,3) = gxcar(icart,3) + scale * 2.d0 * a3
      a1 = xcart(icart,1) - xmax
      a2 = xcart(icart,2) - ymax
      a3 = xcart(icart,3) - zmax
      if(a1.gt.0.d0) gxcar(icart,1) = gxcar(icart,1) + scale * 2.d0 * a1
      if(a2.gt.0.d0) gxcar(icart,2) = gxcar(icart,2) + scale * 2.d0 * a2
      if(a3.gt.0.d0) gxcar(icart,3) = gxcar(icart,3) + scale * 2.d0 * a3
   else if(ityperest(irest).eq.3) then
      xmin = restpars(irest,1)
      ymin = restpars(irest,2)
      zmin = restpars(irest,3)
      xmax = restpars(irest,4)
      ymax = restpars(irest,5)
      zmax = restpars(irest,6)
      a1 = xcart(icart,1) - xmin
      a2 = xcart(icart,2) - ymin
      a3 = xcart(icart,3) - zmin
      if(a1.lt.0.d0) gxcar(icart,1) = gxcar(icart,1) + scale * 2.d0 * a1
      if(a2.lt.0.d0) gxcar(icart,2) = gxcar(icart,2) + scale * 2.d0 * a2
      if(a3.lt.0.d0) gxcar(icart,3) = gxcar(icart,3) + scale * 2.d0 * a3
      a1 = xcart(icart,1) - xmax
      a2 = xcart(icart,2) - ymax
      a3 = xcart(icart,3) - zmax
      if(a1.gt.0.d0) gxcar(icart,1) = gxcar(icart,1) + scale * 2.d0 * a1
      if(a2.gt.0.d0) gxcar(icart,2) = gxcar(icart,2) + scale * 2.d0 * a2
      if(a3.gt.0.d0) gxcar(icart,3) = gxcar(icart,3) + scale * 2.d0 * a3
   else if(ityperest(irest).eq.4) then
      d = (xcart(icart,1)-restpars(irest,1))**2 + &
         (xcart(icart,2)-restpars(irest,2))**2 + &
         (xcart(icart,3)-restpars(irest,3))**2 - &
         restpars(irest,4)**2
      if(d.gt.0.d0) then
         gxcar(icart,1) = gxcar(icart,1) + 4.d0 * scale2 * &
            (xcart(icart,1)-restpars(irest,1))*d
         gxcar(icart,2) = gxcar(icart,2) + 4.d0 * scale2 * &
            (xcart(icart,2)-restpars(irest,2))*d
         gxcar(icart,3) = gxcar(icart,3) + 4.d0 * scale2 * &
            (xcart(icart,3)-restpars(irest,3))*d
      end if
   else if(ityperest(irest).eq.5) then
      a1 = xcart(icart,1)-restpars(irest,1)
      b1 = xcart(icart,2)-restpars(irest,2)
      c1 = xcart(icart,3)-restpars(irest,3)
      a2 = restpars(irest,4)**2
      b2 = restpars(irest,5)**2
      c2 = restpars(irest,6)**2
      d = a1**2/a2+b1**2/b2+c1**2/c2-restpars(irest,7)**2
      if(d.gt.0) then
         gxcar(icart,1) = gxcar(icart,1) + scale2*4.d0*d*a1/a2
         gxcar(icart,2) = gxcar(icart,2) + scale2*4.d0*d*b1/b2
         gxcar(icart,3) = gxcar(icart,3) + scale2*4.d0*d*c1/c2
      end if
   else if(ityperest(irest).eq.6) then ! outside cube
      xmin = restpars(irest,1)
      ymin = restpars(irest,2)
      zmin = restpars(irest,3)
      xmax = restpars(irest,1) + restpars(irest,4)
      ymax = restpars(irest,2) + restpars(irest,4)
      zmax = restpars(irest,3) + restpars(irest,4)
      x = xcart(icart, 1)
      y = xcart(icart, 2)
      z = xcart(icart, 3)
      a1 = 0.0
      a2 = 0.0
      a3 = 0.0
      a4 = 0.0
      a5 = 0.0
      a6 = 0.0
      if ( ( x > xmin .and. x < xmax ) .and. &
           ( y > ymin .and. y < ymax ) .and. &
           ( z > zmin .and. z < zmax ) ) then
         xmed = (xmax - xmin) / 2
         ymed = (ymax - ymin) / 2
         zmed = (zmax - zmin) / 2
         if ( x <= xmed ) a1 = 1.0
         if ( x > xmed ) a4 = -1.0
         if ( y <= ymed ) a2 = 1.0
         if ( y > ymed ) a5 = -1.0
         if ( z <= zmed ) a3 = 1.0
         if ( z > zmed ) a6 = -1.0
      end if
      gxcar(icart,1) = gxcar(icart,1) + scale * (a1 + a4)
      gxcar(icart,2) = gxcar(icart,2) + scale * (a2 + a5) 
      gxcar(icart,3) = gxcar(icart,3) + scale * (a3 + a6)
   else if(ityperest(irest).eq.7) then ! outside box
      xmin = restpars(irest,1)
      ymin = restpars(irest,2)
      zmin = restpars(irest,3)
      xmax = restpars(irest,4)
      ymax = restpars(irest,5)
      zmax = restpars(irest,6)
      x = xcart(icart, 1)
      y = xcart(icart, 2)
      z = xcart(icart, 3)
      a1 = 0.0
      a2 = 0.0
      a3 = 0.0
      a4 = 0.0
      a5 = 0.0
      a6 = 0.0
      if ( ( x > xmin .and. x < xmax ) .and. &
           ( y > ymin .and. y < ymax ) .and. &
           ( z > zmin .and. z < zmax ) ) then
         xmed = (xmax - xmin) / 2
         ymed = (ymax - ymin) / 2
         zmed = (zmax - zmin) / 2
         if ( x <= xmed ) a1 = 1.0
         if ( x > xmed ) a4 = -1.0
         if ( y <= ymed ) a2 = 1.0
         if ( y > ymed ) a5 = -1.0
         if ( z <= zmed ) a3 = 1.0
         if ( z > zmed ) a6 = -1.0
      end if
      gxcar(icart,1) = gxcar(icart,1) + scale * (a1 + a4)
      gxcar(icart,2) = gxcar(icart,2) + scale * (a2 + a5)
      gxcar(icart,3) = gxcar(icart,3) + scale * (a3 + a6)
   else if(ityperest(irest).eq.8) then
      d = (xcart(icart,1)-restpars(irest,1))**2 + &
         (xcart(icart,2)-restpars(irest,2))**2 + &
         (xcart(icart,3)-restpars(irest,3))**2 - &
         restpars(irest,4)**2
      if(d.lt.0.d0) then
         gxcar(icart,1) = gxcar(icart,1) + 4.d0 * scale2 * &
            (xcart(icart,1)-restpars(irest,1))*d
         gxcar(icart,2) = gxcar(icart,2) + 4.d0 * scale2 * &
            (xcart(icart,2)-restpars(irest,2))*d
         gxcar(icart,3) = gxcar(icart,3) + 4.d0 * scale2 * &
            (xcart(icart,3)-restpars(irest,3))*d
      end if
   else if(ityperest(irest).eq.9) then
      a1 = xcart(icart,1)-restpars(irest,1)
      b1 = xcart(icart,2)-restpars(irest,2)
      c1 = xcart(icart,3)-restpars(irest,3)
      a2 = restpars(irest,4)**2
      b2 = restpars(irest,5)**2
      c2 = restpars(irest,6)**2
      d = a1**2/a2+b1**2/b2+c1**2/c2-restpars(irest,7)**2
      if(d.lt.0) then
         d = scale2 * d
         gxcar(icart,1) = gxcar(icart,1) + 4.d0*d*a1/a2
         gxcar(icart,2) = gxcar(icart,2) + 4.d0*d*b1/b2
         gxcar(icart,3) = gxcar(icart,3) + 4.d0*d*c1/c2
      end if
   else if(ityperest(irest).eq.10) then
      d = restpars(irest,1)*xcart(icart,1) + &
         restpars(irest,2)*xcart(icart,2) + &
         restpars(irest,3)*xcart(icart,3) - &
         restpars(irest,4)
      if(d.lt.0.d0) then
         d = scale * d
         gxcar(icart,1) = gxcar(icart,1) + 2.d0*restpars(irest,1)*d
         gxcar(icart,2) = gxcar(icart,2) + 2.d0*restpars(irest,2)*d
         gxcar(icart,3) = gxcar(icart,3) + 2.d0*restpars(irest,3)*d
      end if
   else if(ityperest(irest).eq.11) then
      d = restpars(irest,1)*xcart(icart,1) + &
         restpars(irest,2)*xcart(icart,2) + &
         restpars(irest,3)*xcart(icart,3) - &
         restpars(irest,4)
      if(d.gt.0.d0) then
         d = scale * d
         gxcar(icart,1) = gxcar(icart,1) + 2.d0*restpars(irest,1)*d
         gxcar(icart,2) = gxcar(icart,2) + 2.d0*restpars(irest,2)*d
         gxcar(icart,3) = gxcar(icart,3) + 2.d0*restpars(irest,3)*d
      end if
   else if(ityperest(irest).eq.12) then
      rg(1) = 0.0d0
      rg(2) = 0.0d0
      rg(3) = 0.0d0
      a1 = xcart(icart,1) - restpars(irest,1)
      a2 = xcart(icart,2) - restpars(irest,2)
      a3 = xcart(icart,3) - restpars(irest,3)
      vnorm = sqrt(restpars(irest,4)**2 + restpars(irest,5)**2 &
         + restpars(irest,6)**2)
      vv1 = restpars(irest,4)/vnorm
      vv2 = restpars(irest,5)/vnorm
      vv3 = restpars(irest,6)/vnorm
      b1 = vv1 * a1
      b2 = vv2 * a2
      b3 = vv3 * a3
      w = b1 + b2 + b3
      d = (a1 - vv1*w)**2 + (a2 - vv2*w)**2 + (a3 - vv3*w)**2
      rg(1) = scale2 * ( &
         -2*dmax1(-w , 0.d0) * vv1 + &
         2*dmax1(w - restpars(irest,9), 0.d0) * vv1 + &
         2*dmax1(d - restpars(irest,7)**2 , 0.d0) * &
         (2*(a1 - vv1*w)*(1 - vv1**2)+ &
         2*(a2 - vv2*w)*(-vv2*vv1)+ &
         2*(a3 - vv3*w)*(-vv3*vv1) ))
      rg(2) = scale2 * ( &
         -2*dmax1(-w , 0.d0) * vv2 + &
         2*dmax1(w - restpars(irest,9), 0.d0) * vv2 + &
         2*dmax1(d - restpars(irest,7)**2 , 0.d0) * &
         (2*(a1 - vv1*w)*(-vv1*vv2)+ &
         2*(a2 - vv2*w)*(1 - vv2**2)+ &
         2*(a3 - vv3*w)*(-vv3*vv2) ))
      rg(3) = scale2 * ( &
         -2*dmax1(-w , 0.d0) * vv3 + &
         2*dmax1(w - restpars(irest,9), 0.d0) * vv3 + &
         2*dmax1(d - restpars(irest,7)**2 , 0.d0) * &
         (2*(a1 - vv1*w)*(-vv1*vv3)+ &
         2*(a2 - vv2*w)*(-vv2*vv3)+ &
         2*(a3 - vv3*w)*(1 - vv3**2) ))
      gxcar(icart,1) = gxcar(icart,1) + rg(1)
      gxcar(icart,2) = gxcar(icart,2) + rg(2)
      gxcar(icart,3) = gxcar(icart,3) + rg(3)
   else if(ityperest(irest).eq.13) then
      rg(1) = 0.0d0
      rg(2) = 0.0d0
      rg(3) = 0.0d0
      a1 = xcart(icart,1) - restpars(irest,1)
      a2 = xcart(icart,2) - restpars(irest,2)
      a3 = xcart(icart,3) - restpars(irest,3)
      vnorm = sqrt(restpars(irest,4)**2 + restpars(irest,5)**2 &
         + restpars(irest,6)**2)
      vv1 = restpars(irest,4)/vnorm
      vv2 = restpars(irest,5)/vnorm
      vv3 = restpars(irest,6)/vnorm
      b1 = vv1 * a1
      b2 = vv2 * a2
      b3 = vv3 * a3
      w = b1 + b2 + b3
      d = (a1 - vv1*w)**2 + (a2 - vv2*w)**2 + (a3 - vv3*w)**2
      frab = dmin1(-w , 0.d0)**2 * dmin1(w - restpars(irest,9), 0.d0)**2
      frac = dmin1(-w , 0.d0)**2 * dmin1(d - restpars(irest,7)**2 , 0.d0 )**2
      frbc = dmin1(w - restpars(irest,9), 0.d0)**2 * &
         dmin1(d - restpars(irest,7)**2 , 0.d0 )**2
      dfra(1) = -2*dmin1(-w , 0.d0) * vv1
      dfrb(1) = 2*dmin1(w - restpars(irest,9), 0.d0) * vv1
      dfrc(1) = 2*dmin1(d - restpars(irest,7)**2 , 0.d0) * &
         (2*(a1 - vv1*w)*(1 - vv1**2)+ &
         2*(a2 - vv2*w)*(-vv2*vv1)+  &
         2*(a3 - vv3*w)*(-vv3*vv1) )
      dfra(2) = -2*dmin1(-w , 0.d0) * vv2
      dfrb(2) = 2*dmin1(w - restpars(irest,9), 0.d0) * vv2
      dfrc(2) = 2*dmin1(d - restpars(irest,7)**2 , 0.d0) * &
         (2*(a1 - vv1*w)*(-vv1*vv2)+  &
         2*(a2 - vv2*w)*(1 - vv2**2)+ &
         2*(a3 - vv3*w)*(-vv3*vv2) )
      dfra(3) = -2*dmin1(-w , 0.d0) * vv3
      dfrb(3) = 2*dmin1(w - restpars(irest,9), 0.d0) * vv3
      dfrc(3) = 2*dmin1(d - restpars(irest,7)**2 , 0.d0) * &
         (2*(a1 - vv1*w)*(-vv1*vv3)+ &
         2*(a2 - vv2*w)*(-vv2*vv3)+ &
         2*(a3 - vv3*w)*(1 - vv3**2) )
      rg(1) = scale2 * ( dfra(1)*frbc + dfrb(1)*frac + dfrc(1)*frab)
      rg(2) = scale2 * ( dfra(2)*frbc + dfrb(2)*frac + dfrc(2)*frab)
      rg(3) = scale2 * ( dfra(3)*frbc + dfrb(3)*frac + dfrc(3)*frab)
      gxcar(icart,1) = gxcar(icart,1) + rg(1)
      gxcar(icart,2) = gxcar(icart,2) + rg(2)
      gxcar(icart,3) = gxcar(icart,3) + rg(3)

      ! Addition of Gaussian surface on xy plane
      ! Based on eq. of type h*exp(-(x-a)**2/2c**2 -(y-b)**2/2d**2)-(z-g)
   else if(ityperest(irest).eq.14) then
      a1 = -(xcart(icart,1) - restpars(irest,1))**2/(2*restpars(irest,3)**2)
      a2 = -(xcart(icart,2) - restpars(irest,2))**2/(2*restpars(irest,4)**2)
      if(a1+a2<=-50) then
         d = -(xcart(icart,3)-restpars(irest,5))
      else
         d = restpars(irest,6)*exp(a1+a2)-(xcart(icart,3)-restpars(irest,5))
      end if
      if(d.gt.0.d0) then
         d = scale * d
         gxcar(icart,1) = gxcar(icart,1) - 2.d0*d*(xcart(icart,1)-restpars(irest,1)) &
            * (d+(xcart(icart,3)-restpars(irest,5))) / restpars(irest,3)**2
         gxcar(icart,2) = gxcar(icart,2) - 2.d0*d*(xcart(icart,2)-restpars(irest,2)) &
            * (d+(xcart(icart,3)-restpars(irest,5))) / restpars(irest,4)**2
         gxcar(icart,3) = gxcar(icart,3) - 2.d0*d
      end if
   else if(ityperest(irest).eq.15) then
      a1 = -(xcart(icart,1) - restpars(irest,1))**2/(2*restpars(irest,3)**2)
      a2 = -(xcart(icart,2) - restpars(irest,2))**2/(2*restpars(irest,4)**2)
      if(a1+a2<=-50) then
         d = -(xcart(icart,3)-restpars(irest,5))
      else
         d = restpars(irest,6)*exp(a1+a2)-(xcart(icart,3)-restpars(irest,5))
      end if
      if(d.lt.0.d0) then
         d = scale * d
         gxcar(icart,1) = gxcar(icart,1) - 2.d0*d*(xcart(icart,1)-restpars(irest,1)) &
            * (d+(xcart(icart,3)-restpars(irest,5))) / restpars(irest,3)**2
         gxcar(icart,2) = gxcar(icart,2) - 2.d0*d*(xcart(icart,2)-restpars(irest,2)) &
            * (d+(xcart(icart,3)-restpars(irest,5))) / restpars(irest,4)**2
         gxcar(icart,3) = gxcar(icart,3) - 2.d0*d
      end if
   end if

   return
end subroutine gwalls

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine setibox: set box index for given coordinates
!

subroutine setibox(x,y,z,sizemin,boxl,nboxes,iboxx,iboxy,iboxz)

   use pbc

   implicit none
   double precision :: x, y, z, sizemin(3), boxl(3), xtemp, ytemp, ztemp
   integer :: nboxes(3), iboxx, iboxy, iboxz

   if (using_pbc) then
      x = x - floor(x / pbc_length(1)) * pbc_length(1)
      y = y - floor(y / pbc_length(2)) * pbc_length(2)
      z = z - floor(z / pbc_length(3)) * pbc_length(3)
   end if

   xtemp = x - sizemin(1)
   ytemp = y - sizemin(2)
   ztemp = z - sizemin(3)
   iboxx = int(xtemp/boxl(1)) + 1
   iboxy = int(ytemp/boxl(2)) + 1
   iboxz = int(ztemp/boxl(3)) + 1
   if(xtemp.le.0) iboxx = 1
   if(ytemp.le.0) iboxy = 1
   if(ztemp.le.0) iboxz = 1
   if(iboxx.gt.nboxes(1)) iboxx = nboxes(1)
   if(iboxy.gt.nboxes(2)) iboxy = nboxes(2)
   if(iboxz.gt.nboxes(3)) iboxz = nboxes(3)

   return
end subroutine setibox

module cell_indexing

implicit none
public :: setcell, icell_to_cell, index_cell

contains 
!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine setcell: set cell indices for given coordinates
!
subroutine setcell(x,cell)
   use pbc, only : v_in_box, pbc_min, pbc_length, cell_ind
   use compute_data, only : cell_length, ncells
   double precision, intent(in) :: x(3)
   integer, intent(out) :: cell(3)
   double precision :: xt(3)
   xt = v_in_box(x, pbc_min, pbc_length)
   cell(:) = floor((xt(:) - pbc_min(:))/cell_length(:)) + 1
   ! safeguard for xt == pbc_max
   cell(:) = min(cell(:), ncells(:))
   return
end subroutine setcell

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutines that set the indexes of a three-dimensional array
! given the undimensional counter of the vector (for an array
! with dimensions (ncells(1),ncells(2),ncells(3)), and
! vice-versa.
!
subroutine icell_to_cell(icell,ncells,cell)
   integer, intent(in) :: icell, ncells(3)
   integer, intent(out) :: cell(3)
   integer :: iicell

   cell(3) = modulo(icell,ncells(3))
   if ( cell(3) == 0 ) cell(3) = ncells(3)

   iicell = icell - cell(3)
   iicell = iicell / ncells(3) + 1
   cell(2) = modulo(iicell,ncells(2))
   if ( cell(2) == 0 ) cell(2) = ncells(2)

   iicell = iicell - cell(2)
   iicell = iicell / ncells(2) + 1
   cell(1) = modulo(iicell,ncells(1))
   if ( cell(1) == 0 ) cell(1) = ncells(1)

end subroutine icell_to_cell

integer function index_cell(cell, ncells)
   integer, intent(in) :: ncells(3), cell(3)
   index_cell = (cell(1)-1)*ncells(2)*ncells(3) + (cell(2)-1)*ncells(3) + (cell(3)-1) + 1
end

end

!
!  Written by Misael Díaz-Maldonado, 2025.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!

module cli_parser

    use sizes, only: strl
    use exit_codes, only: exit_code_command_line_error
    use input, only: output_file_name => xyzout
    use input, only: input_file_name

    implicit none

    integer, parameter :: INPUT_FLAG = 0
    integer, parameter :: OUTPUT_FLAG = 1
    character(len=*), parameter :: errmsg = &
        "ERROR: packmol command-line error" // new_line('a') // &
        "Command-line execution examples (you may use any): " // new_line('a') // &
        "" // new_line('a') // &
        "packmol < input.inp" // new_line('a') // &
        "" // new_line('a') // &
        "packmol -i input.inp" // new_line('a') // &
        "" // new_line('a') // &
        "packmol -i input.inp -o output.pdb" // new_line('a')

    private
    public :: parse_command_line_args

contains

function parse_command(cmd) result(res)
    integer :: res
    integer :: idx
    character(*), intent(in) :: cmd
    character(*), parameter :: cmdin = "-i"
    character(*), parameter :: cmdout = "-o"
    character(*), parameter :: err = "ERROR: unrecognized command-line argument: "

    idx = index(cmd, "-i")
    if (idx /= 0) then

        if (len(trim(cmd)) /= len(cmdin)) then
                write(*,*) err // trim(cmd)
                write(*,*) errmsg
                stop exit_code_command_line_error
        end if
        res = INPUT_FLAG

    else

        idx = index(cmd, "-o")
        if (idx == 0) then
                write(*,*) err // trim(cmd)
                write(*,*) errmsg
                stop exit_code_command_line_error
        end if
        if (len(trim(cmd)) /= len(cmdout)) then
                write(*,*) err // trim(cmd)
                write(*,*) errmsg
                stop exit_code_command_line_error
        end if
        res = OUTPUT_FLAG

    end if

    return
end function parse_command

subroutine get_filename(cmdno, filename)
    integer, intent(in) :: cmdno
    character(*), intent(out) :: filename

    call get_command_argument(cmdno + 1, filename)

    return
end subroutine get_filename

subroutine parse_command_line_args
    integer :: idx
    integer :: stat
    integer :: argc
    integer :: cmdno
    integer :: length
    logical :: specified_input_file
    logical :: specified_output_file
    character(len=strl) :: cmd
    character(len=*), parameter :: errcmp = "ERROR: packmol expects different " // &
        "for the input and output files"

    ! NOTE: Packmol will check the length of these strings later so don't remove this
    input_file_name = ""
    output_file_name = ""
    specified_input_file = .false.
    specified_output_file = .false.

    argc = command_argument_count()
    if (argc == 0) then ! packmol default mode with input redirection

        cmdno = 0
        call get_command_argument(cmdno, value=cmd, length=length, status=stat)
        if (stat == -1) then
            write(*,*) "ERROR: truncation error"
            write(*,*) errmsg
            stop exit_code_command_line_error
        else if (stat > 0) then
            write(*,*) "ERROR: command-line retrieval error"
            write(*,*) errmsg
            stop exit_code_command_line_error
        end if

        idx = index(cmd, "packmol")
        if (idx == 0) then
            write(*, *) "WARN: packmol detected non-standard command-line handling"
        end if

        ! NOTE: Packmol expects these to be initialized to empty strings
        if (len(trim(input_file_name)) /= 0) then
            write(*,*) "ERROR: packmol command-line implementation error"
            stop exit_code_command_line_error
        end if

        if (len(trim(output_file_name)) /= 0) then
            write(*,*) "ERROR: packmol command-line implementation error"
            stop exit_code_command_line_error
        end if

    else if (argc == 2) then ! user must specify the input file

        cmdno = 1
        call get_command_argument(cmdno, value=cmd, length=length, status=stat)
        if (stat == -1) then
            write(*,*) "ERROR: truncation error"
            write(*,*) errmsg
            stop exit_code_command_line_error
        else if (stat > 0) then
            write(*,*) "ERROR: command-line retrieval error"
            write(*,*) errmsg
            stop exit_code_command_line_error
        end if

        if (parse_command(cmd) == INPUT_FLAG) then
            call get_filename(cmdno, input_file_name)
            specified_input_file = .true.
        else
            write(*,*) errmsg
            stop exit_code_command_line_error
        end if

        if (.not. specified_input_file) then
            write(*,*) "ERROR: packmol received invalid command-line arguments"
            write(*,*) errmsg
            stop exit_code_command_line_error
        end if

        if (len(trim(input_file_name)) == 0) then
            write(*,*) "ERROR: invalid input filename"
            write(*,*) errmsg
            stop exit_code_command_line_error
        end if

    else if (argc == 4) then ! user has specified both the input and output files

        cmdno = 1
        call get_command_argument(cmdno, value=cmd, length=length, status=stat)
        if (stat == -1) then
            write(*,*) "ERROR: truncation error"
            write(*,*) errmsg
            stop exit_code_command_line_error
        else if (stat > 0) then
            write(*,*) "ERROR: command-line retrieval error"
            write(*,*) errmsg
            stop exit_code_command_line_error
        end if

        if (parse_command(cmd) == INPUT_FLAG) then
            call get_filename(cmdno, input_file_name)
            specified_input_file = .true.
        else if (parse_command(cmd) == OUTPUT_FLAG) then
            call get_filename(cmdno, output_file_name)
            specified_output_file = .true.
        else
            write(*,*) "ERROR: packmol received invalid command-line arguments"
            write(*,*) errmsg
            stop exit_code_command_line_error
        end if

        cmdno = 3
        call get_command_argument(cmdno, value=cmd, length=length, status=stat)
        if (specified_input_file) then
            if (parse_command(cmd) == OUTPUT_FLAG) then
                call get_filename(cmdno, output_file_name)
                specified_output_file = .true.
            end if
        else
            if (parse_command(cmd) == INPUT_FLAG) then
                call get_filename(cmdno, input_file_name)
                specified_input_file = .true.
            else
                write(*,*) "ERROR: packmol received invalid command-line arguments"
                write(*,*) errmsg
                stop exit_code_command_line_error
            end if
        end if

        ! assertion: both must be true if not we have a logic error in the code
        if (.not. specified_input_file .or. .not. specified_output_file) then
            write(*,*) "ERROR: packmol received invalid command-line arguments"
            write(*,*) errmsg
            stop exit_code_command_line_error
        end if

        ! NOTE: we want to catch implementation errors in development
        if (len(trim(input_file_name)) == 0) then
            write(*,*) "ERROR: invalid input filename"
            write(*,*) errmsg
            stop exit_code_command_line_error
        end if

        if (len(trim(output_file_name)) == 0) then
            write(*,*) "ERROR: invalid output filename"
            write(*,*) errmsg
            stop exit_code_command_line_error
        end if

        if (trim(input_file_name) == trim(output_file_name)) then
            write(*,*) errcmp
            write(*,*) errmsg
            stop exit_code_command_line_error
        end if

    else ! user provided invalid command-line arguments
        write(*,*) errmsg
        stop exit_code_command_line_error
    end if

    return
end subroutine parse_command_line_args

end module cli_parser

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
!  Subroutine that swaps indexes for packing molecules one at a time
!

subroutine swaptype(n,x,itype,action)

   use sizes, only : nn
   use compute_data, only : ntype, comptype, nmols, ntotmol
   use input, only : nloop, nloop_all, nloop_type
   use swaptypemod
   use ahestetic
   implicit none
   integer ::n, itype, ilubar, ilugan, i, action
   double precision :: x(nn)

   ! Save original data

   if ( action == 0 ) then
      do i = 1, nn
         xfull(i) = x(i)
      end do
      ntemp = n
      ntottemp = ntotmol
   end if

   ! Swapping data for packing this itype

   if ( action == 1 ) then
      do i = 1, ntype
         if(i == itype) then
            comptype(i) = .true.
         else
            comptype(i) = .false.
         end if
      end do
      n = nmols(itype) * 6
      ntotmol = nmols(itype)
      nloop = nloop_type(itype)
      ilubar = 0
      do i = 1, itype - 1
         ilubar = ilubar + nmols(i) * 3
      end do
      ilubar = ilubar + 1
      ilugan = ntemp/2 + ilubar
      do i = 1, n / 2
         x(i) = xfull(ilubar)
         x(i+n/2) = xfull(ilugan)
         ilubar = ilubar + 1
         ilugan = ilugan + 1
      end do
   end if

   ! Save results for this type

   if ( action == 2 ) then
      ilubar = 0
      do i = 1, itype - 1
         ilubar = ilubar + nmols(i)*3
      end do
      ilubar = ilubar + 1
      ilugan = ntemp/2 + ilubar
      do i = 1, n/2
         xfull(ilubar) = x(i)
         xfull(ilugan) = x(i+n/2)
         ilubar = ilubar + 1
         ilugan = ilugan + 1
      end do
   end if

   ! Restore all-molecule vectors

   if ( action == 3 ) then
      n = ntemp
      ntotmol = ntottemp
      nloop = nloop_all
      do i = 1, n
         x(i) = xfull(i)
      end do
      do i = 1, ntype
         comptype(i) = .true.
      end do
   end if

end subroutine swaptype

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine that computes the analytical derivatives
!

subroutine computeg(n,x,g)

   use sizes
   use cell_indexing, only: index_cell, icell_to_cell, setcell
   use compute_data
   use pbc
   implicit none

   integer :: n
   integer :: idatom, iatom, irest
   integer :: i, j, k, ilubar, ilugan, icart, itype, imol
   integer :: icell, cell(3)
   integer :: k1, k2
   integer :: iratcount

   double precision :: x(n), g(n)
   double precision :: dv1beta(3), dv1gama(3), dv1teta(3),&
      dv2beta(3), dv2gama(3), dv2teta(3),&
      dv3beta(3), dv3gama(3), dv3teta(3)
   double precision :: v1(3), v2(3), v3(3)
   double precision :: xcm(3)
   double precision :: beta, gama, teta, cb, sb, cg, sg, ct, st

   ! Reset gradients
   gxcar(:,:) = 0.d0

   ! Reset cells

   if(.not.init1) call resetcells()

   ! Transform baricenter and angles into cartesian coordinates

   ! Computes cartesian coordinates from vector x and coor

   ilubar = 0
   ilugan = ntotmol*3
   icart = 0

   do itype = 1, ntype

      if(.not.comptype(itype)) then
         icart = icart + nmols(itype)*natoms(itype)
         cycle
      end if

      do imol = 1, nmols(itype)
         xcm = x(ilubar+1:ilubar+3)
         ! Compute the rotation matrix
         beta = x(ilugan + 1)
         gama = x(ilugan + 2)
         teta = x(ilugan + 3)
         call eulerrmat(beta,gama,teta,v1,v2,v3)
         idatom = idfirst(itype) - 1

         do iatom = 1, natoms(itype)
            icart = icart + 1
            idatom = idatom + 1
            call compcart(xcart(icart,1:3),xcm,coor(idatom,1:3),v1,v2,v3)

            ! Gradient relative to the wall distace
            do iratcount = 1, nratom(icart)
               irest = iratom(icart,iratcount)
               call gwalls(icart,irest)
            end do

            if(.not.init1) then
               call setcell(xcart(icart,:),cell)
               ! Atom linked list
               latomnext(icart) = latomfirst(cell(1),cell(2),cell(3))
               latomfirst(cell(1),cell(2),cell(3)) = icart

               ! cell with atoms linked list
               if ( empty_cell(cell(1),cell(2),cell(3))) then
                  empty_cell(cell(1),cell(2),cell(3)) = .false.
                  icell = index_cell(cell,ncells)
                  lcellnext(icell) = lcellfirst
                  lcellfirst = icell
               end if

               ibtype(icart) = itype
               ibmol(icart) = imol
            end if

         end do
         ilugan = ilugan + 3
         ilubar = ilubar + 3
      end do

   end do

   if( .not. init1 ) then

      !
      ! Gradient relative to minimum distance
      !

      icell = lcellfirst
      do while( icell > 0 )

         call icell_to_cell(icell,ncells,cell)
         i = cell(1)
         j = cell(2)
         k = cell(3)

         icart = latomfirst(i,j,k)
         do while( icart > 0 )

            if(comptype(ibtype(icart))) then
               ! Interactions inside cell
               call gparc(icart,latomnext(icart))
               ! Interactions of cells that share faces (6 faces - 3 forward)
               call gparc(icart,latomfirst(cell_ind(i+1, ncells(1)),j,k)) ! 4 - (1, 0, 0)
               call gparc(icart,latomfirst(i,cell_ind(j+1, ncells(2)),k)) ! 5 - (0, 1, 0)
               call gparc(icart,latomfirst(i,j,cell_ind(k+1, ncells(3)))) ! 6 - (0, 0, 1)
               ! Interactions of cells that share axes (12 edges - 6 forward)
               call gparc(icart,latomfirst(i,cell_ind(j+1, ncells(2)),cell_ind(k+1, ncells(3)))) ! 5 - (0, 1, 1)
               call gparc(icart,latomfirst(i,cell_ind(j+1, ncells(2)),cell_ind(k-1, ncells(3)))) ! 6 - (0, 1, -1)
               call gparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j+1, ncells(2)),k)) ! 9 - (1, 1, 0)
               call gparc(icart,latomfirst(cell_ind(i+1, ncells(1)),j,cell_ind(k+1, ncells(3)))) ! 10 - (1, 0, 1)
               call gparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j-1, ncells(2)),k)) ! 11 - (1, -1, 0)
               call gparc(icart,latomfirst(cell_ind(i+1, ncells(1)),j,cell_ind(k-1, ncells(3)))) ! 12 - (1, 0, -1)
               ! Interactions of cells that share vertices (8 vertices, 4 forward)
               call gparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j+1, ncells(2)),cell_ind(k+1, ncells(3)))) ! 1 - (1, 1, 1)
               call gparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j+1, ncells(2)),cell_ind(k-1, ncells(3)))) ! 2 - (1, 1, -1)
               call gparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j-1, ncells(2)),cell_ind(k+1, ncells(3)))) ! 3 - (1, -1, 1)
               call gparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j-1, ncells(2)),cell_ind(k-1, ncells(3)))) ! 4 - (1, -1, -1)
            end if

            icart = latomnext(icart)
         end do

         icell = lcellnext(icell)
      end do

   end if

   ! Computing the gradient using chain rule

   g(1:n) = 0.d0
   k1 = 0
   k2 = ntotmol * 3
   icart = 0
   do itype = 1, ntype

      if(.not.comptype(itype)) then
         icart = icart + nmols(itype)*natoms(itype)
      else
         do imol = 1, nmols(itype)

            beta = x(k2 + 1)
            gama = x(k2 + 2)
            teta = x(k2 + 3)

            cb = dcos(beta)
            sb = dsin(beta)
            cg = dcos(gama)
            sg = dsin(gama)
            ct = dcos(teta)
            st = dsin(teta)

            dv1beta(1) = - cb * sg * ct - sb * cg
            dv2beta(1) = - sb * sg * ct + cb * cg
            dv3beta(1) = 0.d0

            dv1gama(1) = - sb * cg * ct - cb * sg
            dv2gama(1) =   cb * cg * ct - sb * sg
            dv3gama(1) =   cg * st

            dv1teta(1) =   sb * sg * st
            dv2teta(1) = - cb * sg * st
            dv3teta(1) =   sg * ct

            dv1beta(2) = - cb * cg * ct + sb * sg
            dv2beta(2) = - sb * cg * ct - cb * sg
            dv3beta(2) = 0.d0

            dv1gama(2) =   sb * sg * ct - cb * cg
            dv2gama(2) = - sg * cb * ct - cg * sb
            dv3gama(2) = - sg * st

            dv1teta(2) =   sb * cg * st
            dv2teta(2) = - cb * cg * st

            dv3teta(2) =   cg * ct

            dv1beta(3) =   cb * st
            dv2beta(3) =   sb * st
            dv3beta(3) = 0.d0

            dv1gama(3) = 0.d0
            dv2gama(3) = 0.d0
            dv3gama(3) = 0.d0

            dv1teta(3) =   sb * ct
            dv2teta(3) = - cb * ct
            dv3teta(3) = - st

            idatom = idfirst(itype) - 1
            do iatom = 1, natoms(itype)

               icart = icart + 1
               idatom = idatom + 1

               do k = 1, 3
                  g(k1+k) = g(k1+k) + gxcar(icart, k)
               end do

               do k = 1, 3
                  g(k2 + 1) = g(k2 + 1) &
                     + (coor(idatom,1) * dv1beta(k) &
                     + coor(idatom, 2) * dv2beta(k) &
                     + coor(idatom, 3) * dv3beta(k)) &
                     * gxcar(icart, k)

                  g(k2 + 2) = g(k2 + 2) &
                     + (coor(idatom,1) * dv1gama(k) &
                     + coor(idatom, 2) * dv2gama(k) &
                     + coor(idatom, 3) * dv3gama(k)) &
                     * gxcar(icart, k)

                  g(k2 + 3) = g(k2 + 3) &
                     + (coor(idatom,1)  * dv1teta(k) &
                     + coor(idatom, 2) * dv2teta(k) &
                     + coor(idatom, 3) * dv3teta(k)) &
                     * gxcar(icart, k)
               end do

            end do
            k2 = k2 + 3
            k1 = k1 + 3
         end do
      end if
   end do

   return
end subroutine computeg

!  
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!  
!-----------------------------------------------------------------------------
!
! http://m3g.iqm.unicamp.br/packmol
!
! Usage (see the page above for further information):
!
! ./packmol < inputfile.inp
!
! References:
!
! L. Martinez, R. Andrade, E. G. Birgin, J. M. Martinez,
! PACKMOL: A package for building initial configurations for
! molecular dynamics simulations, J. Comp. Chem. 30:2157-2164, 2009.
!
! J. M. Martinez and L. Martinez, 
! Packing optimization for the automated generation of complex
! system's initial configurations for molcular dynamics and
! docking. J. Comp. Chem. 24:819-825, 2003.
!
! This version of Packmol uses the optimization method GENCAN which
! is a part of the TANGO (Trustable Algorithms for Nonlinear General
! Optimization) project.
! Reference:
! E. G. Birgin, J. M. Martinez, Comp. Opt. Appl. 23:101-125, 2002.
! http://www.ime.usp.br/~egbirgin/tango
!
!

program packmol

  use exit_codes
  use sizes
  use compute_data
  use input
  use usegencan
  use flashsort
  use swaptypemod
  use ahestetic
  use pbc
  implicit none

  integer :: itype, irest, idatom, iatom
  integer :: idtemp, nmtemp, natemp, input_itypetemp
  integer :: linesttmp1, linesttmp2, jtype
  integer :: ntmol, n, iftype, icart, imol, iicart, iline_atoms
  integer :: i, iline, iiatom, iat, iirest, iratcount, ival
  integer :: loop
  integer :: resntemp, nloop_tmp
  integer :: ioerr
  integer :: maxmove_tmp
  integer :: exit_code = 0
      
  double precision, allocatable :: x(:), xprint(:) ! (nn)
  double precision :: v1(3),v2(3),v3(3)
  double precision :: radscale, value
  double precision :: xcm(3), beta, gama, teta
  double precision :: xtemp(3)
  double precision :: fx, bestf, flast, fprint, all_type_fx
  double precision :: fimp, fimprov
  double precision, parameter :: pi=4.d0*datan(1.d0)

  real :: etime, tarray(2), time0, time_writeout
  
  character(len=strl) :: record, restart_from_temp, restart_to_temp
  character(len=strl) :: xyzfile
  character(len=1) :: chain_tmp

  logical :: fixtmp
  logical :: rests
  logical :: movebadprint
  logical :: changechains_tmp, connecttmp

  logical, allocatable :: fixed(:) ! ntype

  ! Printing title

  call title()
      
  ! Set dimensions of all arrays

  call setsizes()

  ! Allocate local array

  allocate(fixed(ntype),x(nn),xprint(nn),xfull(nn))

  ! Start time computation

  time0 = etime(tarray)
  time_writeout = time0

  ! Reading input file

  call getinp()

  ! Put molecules in their center of mass

  call cenmass()
 
  ! Writting some input data
     
  write(*,*) ' Total number of atoms: ', ntotat

  ! Put fixed molecules in the specified position

  fixed(1:ntype) = .false.
  do irest = 1, nrest
    if(ityperest(irest).eq.1) then
      do itype = 1, ntype
        if(irestline(irest).gt.linestrut(itype,1).and.&
           irestline(irest).lt.linestrut(itype,2)) then
          xcm = restpars(irest,1:3)
          beta = restpars(irest,4) 
          gama = restpars(irest,5) 
          teta = restpars(irest,6) 

          ! Compute rotation matrix from euler angles

          call eulerfixed(beta,gama,teta,v1,v2,v3)                 

          idatom = idfirst(itype) - 1
          do iatom = 1, natoms(itype)
            idatom = idatom + 1
            xtemp(1) = coor(idatom,1)*v1(1) &
                     + coor(idatom,2)*v2(1) &
                     + coor(idatom,3)*v3(1) 
            xtemp(2) = coor(idatom,1)*v1(2) &
                     + coor(idatom,2)*v2(2) &
                     + coor(idatom,3)*v3(2) 
            xtemp(3) = coor(idatom,1)*v1(3) &
                     + coor(idatom,2)*v2(3) &
                     + coor(idatom,3)*v3(3) 
            coor(idatom, 1:3) = xtemp + xcm
          end do
          record = name(itype)
          write(*,*) ' Molecule ',trim(adjustl(record)),'(',itype,') will be fixed.' 
          fixed(itype) = .true.
          if(nmols(itype).gt.1) then
            write(*,*)' ERROR: Cannot set number > 1',' for fixed molecules. '
            write(*,*) '       Structure: ', itype,': ', trim(adjustl(record))
            stop exit_code_input_error
          end if
          if ( restart_from(itype) /= 'none' .or. &
               restart_to(itype) /= 'none' ) then
            write(*,*) ' ERROR: Restart files cannot be used for fixed molecules. '
            write(*,*) '        Structure: ', itype,': ', trim(adjustl(record))
            stop exit_code_input_error
          end if
        end if
      end do
    end if
  end do 

  ! Reseting parameters for removing the fixed molecules
  ! fix is the logical variable that informs that there are fixed molecules

  fix = .false.
  ntemp = 0
  do itype = 1, ntype

    ! input_itype and fixedoninput vectors are used only to preserve the
    ! order of input in the output files

    input_itype(itype) = itype
    if(fixed(itype)) then
      fix = .true.
      fixedoninput(itype) = .true.
    else
      ntemp = ntemp + 1
      fixedoninput(itype) = .false.
    end if
  end do
  ntype_with_fixed = ntype
  ntype = ntemp     

  do i = 1, ntype_with_fixed - ntype 
    do itype = 1, ntype_with_fixed - 1
      if(fixed(itype)) then
        record = name(itype)
        restart_to_temp = restart_to(itype)
        restart_from_temp = restart_from(itype)
        fixtmp = fixed(itype)
        idtemp = idfirst(itype)
        input_itypetemp = input_itype(itype)
        nmtemp = nmols(itype)
        natemp = natoms(itype)
        resntemp = resnumbers(itype)
        connecttmp = connect(itype)
        if(pdb) xyzfile = pdbfile(itype)
        linesttmp1 = linestrut(itype,1)
        linesttmp2 = linestrut(itype,2)
        changechains_tmp = changechains(itype)
        maxmove_tmp = maxmove(itype)
        chain_tmp = chain(itype)
        nloop_tmp = nloop_type(itype)
        jtype = itype + 1
        if(.not.fixed(jtype)) then
          name(itype) = name(jtype)
          name(jtype) = record(1:10)
          restart_to(itype) = restart_to(jtype)
          restart_to(jtype) = restart_to_temp
          restart_from(itype) = restart_from(jtype)
          restart_from(jtype) = restart_from_temp
          idfirst(itype) = idfirst(jtype)
          idfirst(jtype) = idtemp
          input_itype(itype) = input_itype(jtype)
          input_itype(jtype) = input_itypetemp
          fixed(itype) = fixed(jtype)
          fixed(jtype) = fixtmp
          nmols(itype) = nmols(jtype)
          nmols(jtype) = nmtemp
          natoms(itype) = natoms(jtype)
          natoms(jtype) = natemp
          resnumbers(itype) = resnumbers(jtype)
          resnumbers(jtype) = resntemp
          connect(itype) = connect(jtype)
          connect(jtype) = connecttmp
          changechains(itype) = changechains(jtype)
          changechains(jtype) = changechains_tmp
          maxmove(itype) = maxmove(jtype)
          maxmove(jtype) = maxmove_tmp
          chain(itype) = chain(jtype)
          chain(jtype) = chain_tmp
          nloop_type(itype) = nloop_type(jtype)
          nloop_type(jtype) = nloop_tmp
          if(pdb) then
            pdbfile(itype) = pdbfile(jtype) 
            pdbfile(jtype) = xyzfile
          end if
          linestrut(itype,1) = linestrut(jtype,1)
          linestrut(itype,2) = linestrut(jtype,2)
          linestrut(jtype,1) = linesttmp1
          linestrut(jtype,2) = linesttmp2
        end if
      end if
    end do
  end do

  ! Computing the number of variables
  !
  ! ntype: 1...ntype (counter for the number of free structures)
  !
  ! ntype_with_fixed: 1...ntype...ntype_with_fixed (counter for the total number of structures)
  !

  ntmol = 0
  do itype = 1, ntype_with_fixed
    ntmol = ntmol + nmols(itype)
  end do
  ntotmol = 0 
  do itype = 1, ntype 
    ntotmol = ntotmol + nmols(itype)       
  end do     
  n = ntotmol * 6
  write(*,*) ' Total number of molecules: ', ntmol
  write(*,*) ' Number of fixed molecules: ', ntmol - ntotmol
  write(*,*) ' Number of free molecules: ', ntotmol
  write(*,*) ' Number of variables: ', n 

  ! Computing the total number of fixed atoms

  nfixedat = 0
  if(fix) then
    do iftype = ntype + 1, ntype_with_fixed
      nfixedat = nfixedat + natoms(iftype)
    end do
  end if       
  write(*,*) ' Total number of fixed atoms: ', nfixedat

  ! Setting the vector that contains the default tolerances

  do i = 1, ntotat
    radius(i) = dism/2.d0
    fscale(i) = 1.d0
    if ( use_short_tol ) then
      use_short_radius(i) = .true.
    else
      use_short_radius(i) = .false.
    end if
    short_radius(i) = short_tol_dist/2.d0
    short_radius_scale(i) = short_tol_scale
  end do

  ! Setting the radius defined for atoms of each molecule, 
  ! but not atom-specific, first

  icart = 0
  do itype = 1, ntype_with_fixed
    iline = linestrut(itype,1)
    iline_atoms = 0 
    do while( iline <= linestrut(itype,2) )
      if ( keyword(iline,1) == "atoms" ) then
        iline_atoms = iline
        iline = iline + 1
        cycle
      end if
      if ( keyword(iline,1) == "end" .and. &    
           keyword(iline,2) == "atoms" ) then
        iline_atoms = 0  
        iline = iline + 1
        cycle
      end if
      if ( iline_atoms == 0 ) then
        !
        ! Read radius
        !
        if ( keyword(iline,1) == "radius" ) then
          read(keyword(iline,2),*,iostat=ioerr) value
          if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Could not read radius from keyword. '
            stop exit_code_input_error
          end if
          iicart = icart
          do imol = 1, nmols(itype)
            do iatom = 1, natoms(itype)
              iicart = iicart + 1
              radius(iicart) = value
            end do
          end do
        end if
        !
        ! Read minimum-distance function scale
        !
        if ( keyword(iline,1) == "fscale" ) then
          read(keyword(iline,2),*,iostat=ioerr) value
          if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Could not read fscale value from keyword. '
            stop exit_code_input_error
          end if
          iicart = icart
          do imol = 1, nmols(itype)
            do iatom = 1, natoms(itype)
              iicart = iicart + 1
              fscale(iicart) = value
            end do
          end do
        end if
        !
        ! Read short_radius
        !  
        if ( keyword(iline,1) == "short_radius" ) then
          read(keyword(iline,2),*,iostat=ioerr) value
          if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Could not read short_radius value from keyword. '
            stop exit_code_input_error
          end if
          iicart = icart
          do imol = 1, nmols(itype)
            do iatom = 1, natoms(itype)
              iicart = iicart + 1
              short_radius(iicart) = value
              use_short_radius(iicart) = .true.
            end do
          end do
        end if
        !
        ! Read short_radius scale
        !  
        if ( keyword(iline,1) == "short_radius_scale" ) then
          read(keyword(iline,2),*,iostat=ioerr) value
          if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Could not read short_radius_scale value from keyword. '
            stop exit_code_input_error
          end if
          iicart = icart
          do imol = 1, nmols(itype)
            do iatom = 1, natoms(itype)
              iicart = iicart + 1
              short_radius_scale(iicart) = value
              use_short_radius(iicart) = .true.
            end do
          end do
        end if
      end if
      iline = iline + 1
    end do
    icart = icart + nmols(itype)*natoms(itype)
  end do

  ! If some radius was defined using atom-specific definitions, overwrite
  ! the general radius defined for the molecule

  icart = 0
  do itype = 1, ntype_with_fixed
    iline = linestrut(itype,1)
    iline_atoms = 0 
    do while( iline <= linestrut(itype,2) )
      if ( keyword(iline,1) == "atoms" ) then
        iline_atoms = iline
        iline = iline + 1
        cycle
      end if
      if ( keyword(iline,1) == "end" .and. &    
           keyword(iline,2) == "atoms" ) then
        iline_atoms = 0  
        iline = iline + 1
        cycle
      end if
      if ( iline_atoms /= 0 ) then
        !
        ! Read atom specific radius
        !
        if ( keyword(iline,1) == "radius" ) then
          read(keyword(iline,2),*,iostat=ioerr) value
          if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Could not read radius from keyword. '
            stop exit_code_input_error
          end if
          ival = 2
          do
            read(keyword(iline_atoms,ival),*,iostat=ioerr) iat
            if ( ioerr /= 0 ) exit
            if ( iat > natoms(itype) ) then
              write(*,*) ' ERROR: atom selection with index greater than number of '
              write(*,*) '        atoms in structure ', itype
              stop exit_code_input_error
            end if
            radius(icart+iat) = value
            ival = ival + 1
          end do
        end if
        !
        ! Read atom specific function scale
        !
        if ( keyword(iline,1) == "fscale" ) then
          read(keyword(iline,2),*,iostat=ioerr) value
          if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Could not read fscale value from keyword. '
            stop exit_code_input_error
          end if
          ival = 2
          do
            read(keyword(iline_atoms,ival),*,iostat=ioerr) iat
            if ( ioerr /= 0 ) exit
            if ( iat > natoms(itype) ) then
              write(*,*) ' ERROR: atom selection with index greater than number of '
              write(*,*) '        atoms in structure ', itype
              stop exit_code_input_error
            end if
            fscale(icart+iat) = value
            ival = ival + 1
          end do
        end if
        !
        ! Read atom specific short radius
        !
        if ( keyword(iline,1) == "short_radius" ) then
          read(keyword(iline,2),*,iostat=ioerr) value
          if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Could not read short_radius value from keyword. '
            stop exit_code_input_error
          end if
          ival = 2
          do
            read(keyword(iline_atoms,ival),*,iostat=ioerr) iat
            if ( ioerr /= 0 ) exit
            if ( iat > natoms(itype) ) then
              write(*,*) ' ERROR: atom selection with index greater than number of '
              write(*,*) '        atoms in structure ', itype
              stop exit_code_input_error
            end if
            short_radius(icart+iat) = value
            use_short_radius(icart+iat) = .true.
            ival = ival + 1
          end do
        end if
        !
        ! Read atom specific short radius function scale
        !
        if ( keyword(iline,1) == "short_radius_scale" ) then
          read(keyword(iline,2),*,iostat=ioerr) value
          if ( ioerr /= 0 ) then
            write(*,*) ' ERROR: Could not read short_radius_scale value from keyword. '
            stop exit_code_input_error
          end if
          ival = 2
          do
            read(keyword(iline_atoms,ival),*,iostat=ioerr) iat
            if ( ioerr /= 0 ) exit
            if ( iat > natoms(itype) ) then
              write(*,*) ' ERROR: atom selection with index greater than number of '
              write(*,*) '        atoms in structure ', itype
              stop exit_code_input_error
            end if
            short_radius_scale(icart+iat) = value
            use_short_radius(icart+iat) = .true.
            ival = ival + 1
          end do
        end if
      end if
      iline = iline + 1
    end do
    iicart = icart
    icart = icart + natoms(itype)
    do imol = 2, nmols(itype)
      do iatom = 1, natoms(itype)
        icart = icart + 1
        radius(icart) = radius(iicart+iatom)
        fscale(icart) = fscale(iicart+iatom)
        short_radius(icart) = short_radius(iicart+iatom)
        short_radius_scale(icart) = short_radius_scale(iicart+iatom)
        use_short_radius(icart) = use_short_radius(iicart+iatom)
      end do
    end do
  end do

  ! Check if the short radii were set correctly, if the case

  ioerr = 0
  do i = 1, ntotat
    if ( use_short_radius(i) ) then
     if ( short_radius(i) >= radius(i) ) then 
       write(*,*) ' ERROR: The short radius must be smaller than the default radius. '
       write(*,*) '        (the default radius is one half of the default tolerance).'
       stop exit_code_input_error
     end if
   end if
  end do

  ! If using PBC, add the extra constraint

  radmax = 0.d0
  do i = 1, ntotat
    radmax = dmax1(radmax,2.d0*radius(i))
  end do

  if (using_pbc) then
    nrest = nrest + 1
    irestline(nrest) = -1
    ityperest(nrest) = 3
    restpars(nrest,1:3) = pbc_min
    restpars(nrest,4:6) = pbc_max
    write(*,*) " PBC on: Constraint automatically added to non-fixed atoms:"
    write(*,"(a, 6f8.2)") "  -> inside box ", restpars(nrest,1:6)
    write(*,*) ' Updated total number of restrictions: ', nrest
  end if

  ! Setting the array that contains the restrictions per atom

  icart = 0
  do itype = 1, ntype
    rests = .false.
    do imol = 1, nmols(itype)
      idatom = idfirst(itype) - 1      
      do iatom = 1, natoms(itype) 
        icart = icart + 1
        idatom = idatom + 1
        nratom(icart) = 0
        iratcount = 0
        do i = 1, mrperatom
          iratom(icart,i) = 0
        end do
        iline = linestrut(itype,1)
        do while(iline.lt.linestrut(itype,2))
          iline = iline + 1
          if(keyword(iline,1).eq.'atoms') then
            iiatom = -1
            do iat = 2, maxkeywords
              read(keyword(iline,iat),*,iostat=ioerr) iiatom
              if ( ioerr /= 0 ) then
                if ( iiatom == -1 ) then 
                  write(*,*) ' ERROR: Could not read atom selection for type: ', itype
                  stop exit_code_input_error
                else
                  exit
                end if
              end if
              if ( iiatom > natoms(itype) ) then
                write(*,*) ' ERROR: atom selection with index greater than number of '
                write(*,*) '        atoms in structure ', itype
                stop exit_code_input_error
              end if
              if(iatom.eq.iiatom) exit
            end do
            do while(keyword(iline,1).ne.'end'.and.&
                     keyword(iline,2).ne.'atoms')
              iline = iline + 1
              if(iatom.eq.iiatom) then
                if(keyword(iline,1).eq.'inside'.or.&
                   keyword(iline,1).eq.'outside'.or.&
                   keyword(iline,1).eq.'over'.or.&
                   keyword(iline,1).eq.'above'.or.&
                   keyword(iline,1).eq.'below') then
                  nratom(icart) = nratom(icart) + 1
                  iratcount = iratcount + 1
                  do irest = 1, nrest
                    if(irestline(irest).eq.iline) iirest = irest
                  end do
                  iratom(icart,iratcount) = iirest
                end if
              end if
            end do
            iline = iline - 1
          else if(keyword(iline,1).eq.'inside'.or.&
                  keyword(iline,1).eq.'outside'.or.&
                  keyword(iline,1).eq.'over'.or.&
                  keyword(iline,1).eq.'above'.or.&
                  keyword(iline,1).eq.'below') then
            nratom(icart) = nratom(icart) + 1    
            iratcount = iratcount + 1
            do irest = 1, nrest
              if(irestline(irest).eq.iline) iirest = irest
            end do
            iratom(icart,iratcount) = iirest
          end if
        end do
        if (using_pbc) then
          nratom(icart) = nratom(icart) + 1
          iratcount = iratcount + 1
          do irest = 1, nrest
            if (irestline(irest).eq.-1) iratom(icart,iratcount) = irest
          end do
        end if
        if(nratom(icart).gt.0) rests = .true.
      end do 
      if(.not.rests) then
        write(*,*) ' ERROR: Some molecule has no geometrical',&
                   ' restriction defined: nothing to do.'
        stop exit_code_input_error
      end if
    end do
  end do

  ! Read the constraints to rotations about axis, if set

  do itype = 1, ntype
    constrain_rot(itype,1) = .false.
    constrain_rot(itype,2) = .false.
    constrain_rot(itype,3) = .false.
    iline = linestrut(itype,1)
    do while(iline.lt.linestrut(itype,2))
      iline = iline + 1
      if(keyword(iline,1).eq.'constrain_rotation') then
        if(iline.gt.linestrut(itype,1).and.&
           iline.lt.linestrut(itype,2)) then

           ! Note that for movable molecules, teta is a rotation on the x-axis,
           !                                  gama is a rotation on the z-axis,
           !                                  beta is a rotation on the y-axis
           !                                  (see eulerrmat routine)

          if(keyword(iline,2).eq.'x') then
            constrain_rot(itype,3) = .true.
            read(keyword(iline,3),*) rot_bound(itype,3,1)
            read(keyword(iline,4),*) rot_bound(itype,3,2)
            rot_bound(itype,3,1) = rot_bound(itype,3,1)*pi/180.d0
            rot_bound(itype,3,2) = rot_bound(itype,3,2)*pi/180.d0
  
            write(*,*) ' Rotations about x axis of molecules of ',&
                       ' type ', itype, ' will be constrained. '
          end if
          if(keyword(iline,2).eq.'y') then
            constrain_rot(itype,1) = .true.
            read(keyword(iline,3),*) rot_bound(itype,1,1)
            read(keyword(iline,4),*) rot_bound(itype,1,2)
            rot_bound(itype,1,1) = rot_bound(itype,1,1)*pi/180.d0
            rot_bound(itype,1,2) = rot_bound(itype,1,2)*pi/180.d0

            write(*,*) ' Rotations about y axis of molecules of ',&
                       ' type ', itype, ' will be constrained. '
          end if
          if(keyword(iline,2).eq.'z') then
            constrain_rot(itype,2) = .true.
            read(keyword(iline,3),*) rot_bound(itype,2,1)
            read(keyword(iline,4),*) rot_bound(itype,2,2)
            rot_bound(itype,2,1) = rot_bound(itype,2,1)*pi/180.d0
            rot_bound(itype,2,2) = rot_bound(itype,2,2)*pi/180.d0

            write(*,*) ' Rotations about z axis of molecules of ',&
                       ' type ', itype, ' will be constrained. '
          end if
          if ( keyword(iline,2) /= 'x' .and. &
               keyword(iline,2) /= 'y' .and. &
               keyword(iline,2) /= 'z' ) then
            write(*,*) ' ERROR: constrain_rotation option not properly defined (not x, y, or z) '
            stop exit_code_input_error
          end if
        end if
      end if
    end do
  end do
 
  ! If there are no variables (only fixed molecules, stop)

  if(n.eq.0) then
    call output(n,x, xyzout)
    write(*,dash1_line)
    write(*,*) ' Success! There are only fixed molecules, therefore there is nothing to pack. '
    write(*,*) ' The output file contains the fixed molecules in the desired positions. '
    write(*,dash1_line)
    write(*,*) ' Wrote output file: ', trim(adjustl(xyzout))
    if ( crd ) write(*,*) ' ... and to CRD file: ', trim(adjustl(crdfile))
    write(*,dash1_line)
    stop
  end if
  
  !
  ! (Re)setting parameters and building initial point
  !

  call initial(n,x)

  ! Computing the energy at the initial point

  radscale = 1.d0
  do i = 1, ntotat
    radius_ini(i) = radius(i)
  end do
  call computef(n,x,all_type_fx)
  write(*,*) ' Objective function at initial point: ', all_type_fx
  fprint = all_type_fx
  do i = 1, n 
    xprint(i) = x(i)
  end do

  ! Stop if only checking the initial approximation

  if(check) then
    call output(n,x,xyzout)
    write(*,*) ' Wrote initial point to output file: ', trim(adjustl(xyzout)) 
    if ( crd ) write(*,*) ' ... and to CRD file: ', trim(adjustl(crdfile))
    stop
  end if

  !
  ! Main loop: first pack types of molecules separately, then
  ! pack all molecules together
  !

  call swaptype(n,x,itype,0) ! Save all-molecule vector data
  itype = 0
  main : do while(itype <= ntype)
    itype = itype + 1
    if ( packall ) itype = ntype + 1
 
    ! Use larger tolerance than required to improve separation

    radscale = discale
    do i = 1, ntotat
      radius(i) = discale*radius_ini(i)
    end do

    ! Set vectors for specific or all-molecule packing
    
    if ( itype <= ntype ) then
      call swaptype(n,x,itype,1) ! Set vectors to pack only this type of molecule
    else 
      call swaptype(n,x,itype,3) ! Restore all-molecule vectors
    end if

    ! Print titles

    write(*,hash3_line)
    if ( itype <= ntype ) then
      write(*,*) ' Packing molecules of type: ', input_itype(itype)
    else
      write(*,*) ' Packing all molecules together '
    end if
    write(*,hash3_line)

    ! Checking if first approximation is a solution

    call computef(n,x,fx)

    if ( fdist < precision .and. frest < precision ) then

      write(*,*)
      write(*,*) ' Initial approximation is a solution. Nothing to do. '
      write(*,*)
      call swaptype(n,x,itype,3) ! Restore all-molecule vectors
      call output(n,x,xyzout)
      if( itype == ntype + 1 ) then
        write(*,*) ' Solution written to file: ', trim(adjustl(xyzout))
        if ( crd ) write(*,*) ' ... and to CRD file: ', trim(adjustl(crdfile))
      else
        write(*,*) ' Current point written to file: ', trim(adjustl(xyzout))
        if ( crd ) write(*,*) ' ... and to CRD file: ', trim(adjustl(crdfile))
      end if
      call writesuccess(itype,fdist,frest,fx)

    ! Otherwise, pack the molecules
    
    else 

      loop = -1

      ! Initializing parameters relative to the improvement of the function
      fimp = 1.d99
      fimprov = fimp
      do i = 1, ntotat
        radiuswork(i) = radius(i) 
        radius(i) = radius_ini(i)
      end do
      call computef(n,x,fx)
      do i = 1, ntotat
        radius(i) = radiuswork(i)
      end do
      bestf = fx
      flast = fx

      gencanloop : do while(loop.lt.nloop)
        loop = loop + 1

        ! Moving bad molecules
        if(.not. disable_movebad .and. radscale == 1.d0 .and. fimp.le.10.d0) then
          movebadprint = .true.
          call movebad(n,x,fx,movebadprint)
          flast = fx
        end if


        write(*,dash3_line)
        write(*,*) ' Starting GENCAN loop: ', loop
        write(*,*) ' Scaling radii by: ', radscale
        write(*,*)

        ! CALL GENCAN

        write(*,prog1_line)
        call pgencan(n,x,fx)

        !
        ! Compute the statistics of the last optimization loop
        !

        ! Use the user-specified radii for statistics

        do i = 1, ntotat
          radiuswork(i) = radius(i)
          radius(i) = radius_ini(i)
        end do
        call computef(n,x,fx)

        if(bestf.gt.0.d0) fimprov = -100.d0 * (fx - bestf) / bestf
        if(bestf.eq.0.d0) fimprov = 100.d0
        if(flast.gt.0.d0) fimp = -100.d0 * (fx - flast) / flast
        if(flast.eq.0.d0) fimp = 100.d0
        fimp = dmin1(99.99d0,dmax1(-99.99d0,fimp))
        fimprov = dmin1(99.99d0,dmax1(-99.99d0,fimprov))

        write(*,"(/&
                  &'  Function value from last GENCAN loop: f = ', e10.5, /&
                  &'  Best function value before: f = ', e10.5,           /&
                  &'  Improvement from best function value: ', f8.2, ' %',/&
                  &'  Improvement from last loop: ', f8.2, ' %',          /&
                  &'  Maximum violation of target distance: ', f12.6,     /&
                  &'  Maximum violation of the constraints: ', e10.5       &
                  &)") fx, bestf, fimprov, fimp, fdist, frest
        flast = fx

        !
        ! Analysis of final loop packing and output data
        !
        
        if ( itype <= ntype ) then

          ! Save best function value for this packing

          if ( fx < bestf ) bestf = fx

          ! Check if this point is a solution

          call swaptype(n,x,itype,2) ! Save this type current point 
          ! If the solution was found for this type
          if( fdist < precision .and. frest < precision ) then
            call swaptype(n,x,itype,3) ! Restore all molecule vectors
            call output(n,x,xyzout)
            write(*,*) ' Current structure written to file: ', trim(adjustl(xyzout))
            if ( crd ) write(*,*) ' ... and to CRD file: ', trim(adjustl(crdfile))
            call writesuccess(itype,fdist,frest,fx)
            exit gencanloop
          end if

          ! Compute and report function value for all-type packing

          call swaptype(n,x,itype,3) ! Restore all molecule vectors
          call computef(n,x,all_type_fx)
          write(*,"('  All-type function value: ', e10.5 )") all_type_fx

        else

          call computef(n,x,fx)
          all_type_fx = fx
          if ( fx < bestf ) bestf = fx
          ! If solution was found for all system
          if ( fdist < precision .and. frest < precision ) then
            call output(n,x,xyzout)
            call writesuccess(itype,fdist,frest,fx)
            write(*,*) ' Solution written to file: ', trim(adjustl(xyzout))
            if ( crd ) write(*,*) ' ... and to CRD file: ', trim(adjustl(crdfile))
            write(*,dash3_line)
            exit main
          end if

        end if
        write(*,dash3_line)

        ! If this is the best structure so far
        if(etime(tarray) - time_writeout > writeout) then
          time_writeout = etime(tarray)
          if(all_type_fx < fprint ) then
            call output(n,x,xyzout)
            write(*,*) ' Current solution written to file: ', trim(adjustl(xyzout))
            if ( crd ) write(*,*) ' ... and to CRD file: ', trim(adjustl(crdfile))
            fprint = all_type_fx
            do i = 1, n
              xprint(i) = x(i)
            end do
          ! If the user required printing even bad structures
          else if (writebad) then
            call output(n,x,xyzout)
            write(*,*) ' Writing current (perhaps bad) structure to file: ', trim(adjustl(xyzout))
            if ( crd ) write(*,*) ' ... and to CRD file: ', trim(adjustl(crdfile))
          end if
        end if

        ! Restore vector for packing this type of molecule, if the case

        if ( itype <= ntype ) then
          call swaptype(n,x,itype,0) ! Reset type vectors
          call swaptype(n,x,itype,1) ! Set vector for molecules of this type
          call computef(n,x,fx)
        end if

        ! Restore the working radii 

        do i = 1, ntotat
          radius(i) = radiuswork(i)
        end do
        if ( radscale > 1.d0 ) then
          if( ( fdist < precision .and. fimp < 10.d0 ) .or. &
                fimp < 2.d0 ) then
            radscale = dmax1(0.9*radscale,1.d0)
            do i = 1, ntotat
              radius(i) = dmax1(radius_ini(i),0.9d0*radius(i))
            end do
          end if
        end if

        if(loop.eq.nloop) then
          if ( itype .eq. ntype+1 ) then
            write(*,*)' STOP: Maximum number of GENCAN loops achieved.'
            call checkpoint(n,xprint)
            exit_code = exit_code_failed_to_converge
            exit main
          else
            write(*,*)' Maximum number of GENCAN loops achieved.'
          end if
        end if

      end do gencanloop

    end if

  end do main

  write(*,*) '  Running time: ', etime(tarray) - time0,' seconds. ' 
  write(*,dash3_line)
  write(*,*) 

  ! Fortran < 2008 doesn't support non-constant exit codes
  if (exit_code == 0) then
    stop
  elseif (exit_code == exit_code_failed_to_converge) then
    stop exit_code_failed_to_converge
  else
    stop exit_code_general_error
  end if

end program packmol

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine eulerrmat: Computes the rotation matrix from the
!                       Euler angles
!
! Note that:
! In this routine, beta is a rotation about the y-axis
!                  gama is a rotation about the z-axis
!                  teta is a rotation about the x-axis

subroutine eulerrmat(beta,gama,teta,v1,v2,v3)

   implicit none
   double precision :: beta, gama, teta
   double precision :: cb, sb, cg, sg, ct, st
   double precision :: v1(3), v2(3), v3(3)

   cb = dcos(beta)
   sb = dsin(beta)
   cg = dcos(gama)
   sg = dsin(gama)
   ct = dcos(teta)
   st = dsin(teta)

   v1(1)=-sb * sg * ct + cb * cg
   v1(2)=-sb * cg * ct - cb * sg
   v1(3)= sb * st

   v2(1)= cb * sg * ct + sb * cg
   v2(2)= cb * cg * ct - sb * sg
   v2(3)=-cb * st

   v3(1)= sg * st
   v3(2)= cg * st
   v3(3)= ct

   return
end subroutine eulerrmat

!
! Subroutine compcart: Compute cartesian coordinates using
!                      the center of mass, the canonical coordinates
!                      and the rotation matrix
!

subroutine compcart(x,xcm,xref,v1,v2,v3)
   implicit none
   double precision, intent(inout) :: x(3)
   double precision, intent(in) :: xcm(3), xref(3)
   double precision, intent(in) :: v1(3), v2(3), v3(3)
   x(1) = xcm(1) + xref(1)*v1(1) + xref(2)*v2(1) + xref(3)*v3(1)
   x(2) = xcm(2) + xref(1)*v1(2) + xref(2)*v2(2) + xref(3)*v3(2)
   x(3) = xcm(3) + xref(1)*v1(3) + xref(2)*v2(3) + xref(3)*v3(3)
   return
end subroutine compcart

!
! Subroutine eulerfixed: This routine was added because it defines
!                        the rotation in the "human" way, an is thus used
!                        to set the position of the fixed molecules.
!     That means: beta is a counterclockwise rotation around x axis.
!                 gama is a counterclockwise rotation around y axis.
!                 teta is a counterclockwise rotation around z axis.
!     The other routine should better do this as well, but then we need to change
!     all the derivative calculations, just for the sake of human interpretation
!     of the rotation which, in that case, is not really important. Maybe some day.
!

subroutine eulerfixed(beta,gama,teta,v1,v2,v3)

   implicit none
   double precision :: beta, gama, teta
   double precision :: c1, s1, c2, s2, c3, s3
   double precision :: v1(3), v2(3), v3(3)

   c1 = dcos(beta)
   s1 = dsin(beta)
   c2 = dcos(gama)
   s2 = dsin(gama)
   c3 = dcos(teta)
   s3 = dsin(teta)

   v1(1) = c2*c3
   v1(2) = c1*s3 + c3*s1*s2
   v1(3) = s1*s3 - c1*c3*s2

   v2(1) = -c2*s3
   v2(2) = c1*c3 - s1*s2*s3
   v2(3) = c1*s2*s3 + c3*s1

   v3(1) = s2
   v3(2) = -c2*s1
   v3(3) = c1*c2

   return
end subroutine eulerfixed

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!

!
! Subroutine that writes the last point obtained when
! a solution was not found
!

subroutine checkpoint(n,x)

   use sizes
   use compute_data
   use input
   use usegencan
   use ahestetic

   implicit none
   integer :: i
   integer :: n
   double precision :: x(n)
   double precision :: fx
   logical :: movebadprint
   character(len=strl) :: xyzout_forced

   ! All molecules are important

   do i = 1, ntype_with_fixed
      comptype(i) = .true.
   end do

   ! Call the subroutine that computes de function value

   call computef(n,x,fx)

   write(*,dash3_line)
   write(*,"(&
   &' Packmol was not able to find a solution to your',/,&
   &' packing problem with the desired distance tolerance.',/,/,&
   &' First of all, be sure if the molecules fit in the',/,&
   &' regions specified and if the constraints were set',/,&
   &' correctly. ',/,/,&
   &' Secondly, try simply running it again with a different ',/,&
   &' seed for the random number generator of the initial ',/,&
   &' point. This is done by adding the keyword seed to the',/,&
   &' input file, as in: ',/,/,&
   &' seed 192911 ',/,/,&
   &' The best configuration found has a function value of',/,&
   &' f = ', e14.7,/,/,&
   &' IMPORTANT: ',/,&
   &' If the number of molecules and the restraints are',/,&
   &' correct, it is still very likely that the current point',/,&
   &' fits your needs if your purpose is to run a MD',/,&
   &' simulation.',/,&
   &' Therefore, we recommend to minimize the energy of the',/,&
   &' solution found, equilibrate it and run with it as well.',/&
   &)") fx
   write(*,dash3_line)

   call output(n,x,xyzout)

   write(*,*) ' The solution with the best function value was '
   write(*,*) ' written to the output file: ', trim(adjustl(xyzout))
   if ( crd ) write(*,*) ' ... and to CRD file: ', trim(adjustl(crdfile))
   write(*,dash1_line)
   write(*,*) ' Forcing the solution to fit the constraints...'

   ! CALL GENCAN

   init1 = .true.
   do i = 1, nloop
      iprint1 = 0
      iprint2 = 0
      call pgencan(n,x,fx)
      movebadprint = .false.
      call movebad(n,x,fx,movebadprint)
   end do
   init1 = .false.

   write(*,*)
   write(*,dash1_line)
   xyzout_forced = trim(adjustl(xyzout))//'_FORCED'
   call output(n,x,xyzout_forced)

   write(*,*) ' The forced point was writen to the '
   write(*,*) ' output file: ', trim(adjustl(xyzout_forced))
   if ( crd ) write(*,*) ' ... and to CRD file: ', trim(adjustl(crdfile))
   write(*,*)
   write(*,*) ' If you want that the packing procedure continues'
   write(*,*) ' for a longer time, add the following keyword '
   write(*,*) ' to the input file: '
   write(*,*)
   write(*,*) ' nloop [integer]      (ex: nloop 200) '
   write(*,*)
   write(*,*) ' The default nloop value is 50 for each molecule.'
   write(*,*)

   write(*,hash1_line)
   write(*,*) ' ENDED WITHOUT PERFECT PACKING: '
   write(*,*) ' The output file:'
   write(*,*)
   write(*,*) '   ', trim(adjustl(xyzout))
   if ( crd ) write(*,*) ' (... and to CRD file: ', trim(adjustl(crdfile)), ')'
   write(*,*)
   write(*,*) ' contains the best solution found. '
   write(*,*)
   write(*,*) ' Very likely, if the input data was correct, '
   write(*,*) ' it is a reasonable starting configuration.'
   write(*,*) ' Check commentaries above for more details. '
   write(*,hash1_line)

   return
end subroutine checkpoint

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!

!
! Function that returns a real random number between 0. and 1.
!

double precision function rnd()
   call random_number(rnd)
   return
end function rnd

!
! Subroutine that initializes the random number generator given a seed
!
subroutine init_random_number(iseed)
   integer :: size
   integer :: i, iseed
   integer, allocatable :: seed(:)
   call random_seed(size=size)
   allocate(seed(size))
   do i = 1, size
      seed(i) = i*iseed
   end do
   call random_seed(put=seed)
   deallocate(seed)
   return
end subroutine init_random_number

!
! Subroutine that uses the date to create a random seed
!

subroutine seed_from_time(seed)

   implicit none
   integer :: seed, value(8)
   character(len=10) :: b(3)
   call date_and_time( b(1), b(2), b(3), value )
   seed = value(1)+value(2)+value(3)+value(4)+value(5)+value(6)+value(7)+value(8)
   seed = seed + value(1)+value(2)+value(3)+value(4)+value(5)/100+value(6)*100+value(7)/10+value(8)*10

end subroutine seed_from_time

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!                                                             c
!     Subroutine Flash1                                       c
!     SORTS ARRAY A WITH N ELEMENTS BY USE OF INDEX VECTOR L  c
!     OF DIMENSION M WITH M ABOUT 0.1 N.                      c
!     Karl-Dietrich Neubert, FlashSort1 Algorithm             c
!     in  Dr. Dobb's Journal Feb.1998,p.123                   c
!                                                             c
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine flash1 (A, N, L, M, ind)

   implicit none
   double precision :: a(*), anmin, c1, hold, flash
   integer :: L(*), ind(*), i, n, nmax, m, k, ihold, nmove, j, iflash
   !============================ CLASS FORMATION =====


   do i = 1, n
      ind(i) = i
   end do

   ANMIN=A(1)
   NMAX=1
   DO I=1,N
      IF( A(I).LT.ANMIN) ANMIN=A(I)
      IF( A(I).GT.A(NMAX)) NMAX=I
   END DO

   IF (ANMIN.EQ.A(NMAX)) RETURN
   C1=(M - 1) / (A(NMAX) - ANMIN)
   DO K=1,M
      L(K)=0
   END DO
   DO I=1,N
      K=1 + INT(C1 * (A(I) - ANMIN))
      L(K)=L(K) + 1
   END DO
   DO K=2,M
      L(K)=L(K) + L(K - 1)
   END DO
   HOLD=A(NMAX)
   A(NMAX)=A(1)
   A(1)=HOLD

   ihold = ind(nmax)
   ind(nmax) = ind(1)
   ind(1) = ihold


   !=============================== PERMUTATION =====
   NMOVE=0
   J=1
   K=M
   DO WHILE (NMOVE.LT.N - 1)
      DO WHILE (J.GT.L(K))
         J=J + 1
         K=1 + INT(C1 * (A(J) - ANMIN))
      END DO
      FLASH=A(J)
      iflash=ind(j)

      DO WHILE (.NOT.(J.EQ.L(K) + 1))
         K=1 + INT(C1 * (FLASH - ANMIN))
         HOLD=A(L(K))
         ihold = ind(L(k))
         A(L(K))=FLASH
         ind(L(k)) = iflash
         iflash = ihold
         FLASH=HOLD
         L(K)=L(K) - 1
         NMOVE=NMOVE + 1
      END DO
   END DO

   !========================= STRAIGHT INSERTION =====
   DO I=N-2,1,-1
      IF  (A(I + 1).LT.A(I)) THEN
         HOLD=A(I)
         ihold = ind(i)
         J=I
         DO WHILE  (A(J + 1).LT.HOLD)
            A(J)=A(J + 1)
            ind(j) = ind(j+1)
            J=J + 1
         END DO
         A(J)=HOLD
         ind(j) = ihold
      ENDIF
   END DO

   !=========================== RETURN,END FLASH1 =====
   RETURN
END

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
!  Module that contains some ahestetic output definitions
!
module ahestetic

   character(len=13), parameter :: dash1_line = "(  80('-')  )",&
      dash2_line = "(/,80('-')  )",&
      dash3_line = "(/,80('-'),/)"

   character(len=13), parameter :: hash1_line = "(  80('#')  )",&
      hash2_line = "(/,80('#')  )",&
      hash3_line = "(/,80('#'),/)"

   character(len=31), parameter :: prog1_line = "('  Packing:|0 ',tr55,'100%|' )",&
      prog2_line = "('   Moving:|0 ',tr55,'100%|' )"

end module ahestetic


subroutine printbar(iprint, iter, maxit)
   integer :: iter, maxit
   itprint = 60 / (maxit)
   if( iprint .ge. 2 ) then
      if( iter.eq.0) then
         write(*,"('          |')",advance='no')
      else if(iter.eq.maxit) then
         do i = itprint*(maxit-1), 60 
            write(*,"('*')", advance='no')
         end do
         write(*,"('|')")
      else
         do i = 1, itprint
            write(*,"('*')", advance='no')
         end do
      end if
   end if
end subroutine printbar

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
!
! sizes.i: Define the maximum dimensions of the problems
!
!   maxrest:     Maximum number of restrictions
!   mrperatom:   Maximum number of restrictions per atom
!   maxtry:      Number of tries for building the initial point
!   nn:          Maximum number of variables
!                (at least the number of molecules*6)
!   maxkeywords: Maximum number of keywords in input file
!

module sizes

   integer :: maxrest
   integer :: mrperatom
   integer :: maxtry
   integer :: nn
   integer :: maxkeywords

   integer, parameter :: strl = 1000
   character(len=*), parameter :: str_format = "( a1000 )"

end module sizes

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Compute gradient relative to atom-to-atom distances
!

subroutine gparc(icart,firstjcart)

   use sizes
   use compute_data
   use pbc, only : delta_vector, pbc_length
   implicit none

   ! SCALAR ARGUMENTS
   integer, intent(in) :: icart, firstjcart

   ! LOCAL SCALARS
   integer :: jcart
   double precision :: datom, dtemp, xdiff, tol, short_tol, short_tol_scale
   double precision :: vdiff(3)

   jcart = firstjcart
   do while ( jcart > 0 )
      !
      ! Cycle if this type is not to be computed
      !
      if ( .not. comptype(ibtype(jcart))) then
         jcart = latomnext(jcart)
         cycle
      end if
      !
      ! Cycle if the atoms are from the same molecule
      !
      if ( ibmol(icart) == ibmol(jcart) .and. &
         ibtype(icart) == ibtype(jcart) ) then
         jcart = latomnext(jcart)
         cycle
      end if
      !
      ! Cycle if both atoms are from fixed molecules
      !
      if ( fixedatom(icart) .and. fixedatom(jcart) ) then
         jcart = latomnext(jcart)
         cycle
      end if
      !
      ! Otherwise, compute distance and evaluate function for this pair
      !
      tol = (radius(icart)+radius(jcart))**2
      vdiff = delta_vector(xcart(icart,:), xcart(jcart,:), pbc_length)
      datom = (vdiff(1))**2 + (vdiff(2))**2 + (vdiff(3))**2
      if( datom < tol ) then
         dtemp = fscale(icart)*fscale(jcart) * 4.d0 * (datom - tol)
         xdiff = dtemp*vdiff(1)
         gxcar(icart,1)= gxcar(icart,1) + xdiff
         gxcar(jcart,1)= gxcar(jcart,1) - xdiff
         xdiff = dtemp*vdiff(2)
         gxcar(icart,2)= gxcar(icart,2) + xdiff
         gxcar(jcart,2)= gxcar(jcart,2) - xdiff
         xdiff = dtemp*vdiff(3)
         gxcar(icart,3)= gxcar(icart,3) + xdiff
         gxcar(jcart,3)= gxcar(jcart,3) - xdiff
         if ( use_short_radius(icart) .or. use_short_radius(jcart) ) then
            short_tol = ( short_radius(icart) + short_radius(jcart) )**2
            if ( datom < short_tol ) then
               short_tol_scale = dsqrt(short_radius_scale(icart)*short_radius_scale(jcart))
               short_tol_scale = short_tol_scale*( tol**2 / short_tol**2 )
               dtemp = fscale(icart)*fscale(jcart) * 4.d0 * short_tol_scale*(datom - short_tol)
               xdiff = dtemp*vdiff(1)
               gxcar(icart,1)= gxcar(icart,1) + xdiff
               gxcar(jcart,1)= gxcar(jcart,1) - xdiff
               xdiff = dtemp*vdiff(2)
               gxcar(icart,2)= gxcar(icart,2) + xdiff
               gxcar(jcart,2)= gxcar(jcart,2) - xdiff
               xdiff = dtemp*vdiff(3)
               gxcar(icart,3)= gxcar(icart,3) + xdiff
               gxcar(jcart,3)= gxcar(jcart,3) - xdiff
            end if
         end if
      end if
      jcart = latomnext(jcart)
   end do
   return
end subroutine gparc

!
!  Written by Alexandr Fonari, 2022.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!

module exit_codes

   implicit none

   ! Codes 1, 2, 126 – 165 and 255 have special meaning
   integer, parameter :: exit_code_success = 0
   integer, parameter :: exit_code_general_error = 170
   integer, parameter :: exit_code_input_error = 171
   integer, parameter :: exit_code_open_file = 172
   integer, parameter :: exit_code_failed_to_converge = 173
   integer, parameter :: exit_code_command_line_error = 174

end module exit_codes

subroutine gp_ieee_signal1(gpsupn, acgeps, bcgeps, cgepsf, cgepsi, cggpnf)
   implicit none
   double precision :: gpsupn, acgeps, cgepsf, cgepsi, cggpnf, bcgeps
   if ( gpsupn .gt. 0.d0 ) then
      acgeps = log10( cgepsf / cgepsi ) / log10( cggpnf / gpsupn )
      bcgeps = log10( cgepsi ) - acgeps * log10( gpsupn )
   else
      acgeps = 0.0d0
      bcgeps = cgepsf
   end if
end subroutine gp_ieee_signal1

subroutine gp_ieee_signal2(&
   cgmaxit, nind, nearlyq, ucgmaxit, cgscre, &
   kappa, gpeucn2, gpeucn20, epsgpen2, epsgpsn, &
   cgeps, acgeps, bcgeps, cgepsf, cgepsi, gpsupn, gpsupn0)
   implicit none
   logical :: nearlyq
   integer :: cgmaxit, nind, ucgmaxit, cgscre
   double precision :: kappa, gpeucn2, gpeucn20, epsgpen2, epsgpsn, &
      cgeps, acgeps, bcgeps, cgepsf, cgepsi, gpsupn, gpsupn0
   if( ucgmaxit .le. 0 ) then
      if ( nearlyq ) then
         cgmaxit = nind
      else
         if ( cgscre .eq. 1 ) then
            kappa = log10( gpeucn2 / gpeucn20 )/log10( epsgpen2 / gpeucn20 )
         else ! if ( cgscre .eq. 2 ) then
            kappa= log10( gpsupn / gpsupn0 ) / log10( epsgpsn / gpsupn0 )
         end if
         kappa = max( 0.0d0, min( 1.0d0, kappa ) )
         cgmaxit = int(( 1.0d0 - kappa ) * max( 1.0d0, 10.0d0 * log10( dfloat( nind ) ) ) + kappa * dfloat( nind ) )
         ! L. Martinez added to accelerate the iterations near the solution
         cgmaxit = min(20,cgmaxit)
      end if
   else
      cgmaxit = ucgmaxit
   end if
   if ( cgscre .eq. 1 ) then
      cgeps = sqrt( 10.0d0 ** ( acgeps * log10( gpeucn2 ) + bcgeps ) )
   else ! if ( cgscre .eq. 2 ) then
      cgeps = 10.0d0 ** ( acgeps * log10( gpsupn ) + bcgeps )
   end if
   cgeps = max( cgepsf, min( cgepsi, cgeps ) )
end subroutine gp_ieee_signal2

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! subroutine restmol: either compute the restraint function
!                     value for a single molecule or solve
!                     the problem of puting this molecule
!                     in the restraint region
!

subroutine restmol(itype,ilubar,n,x,fx,solve)

   use sizes
   use compute_data
   use usegencan
   implicit none

   integer :: n, nsafe, ntotsafe, itype, i, ilubar, nmoltype, ip1, ip2
   double precision :: x(n), fx
   logical :: solve, initsafe

   ! Saving global problem variables

   nsafe = n
   ntotsafe = ntotmol
   nmoltype = nmols(itype)
   compsafe(1:ntype) = comptype(1:ntype)
   initsafe = init1

   ! Preparing system to solve for this molecule
   n = 6
   ntotmol = 1
   nmols(itype) = 1
   xmol(1:3) = x(ilubar+1:ilubar+3)
   xmol(4:6) = x(ilubar+ntotsafe*3+1:ilubar+ntotsafe*3+3)
   do i = 1, ntype
      if(i.eq.itype) then
         comptype(i) = .true.
      else
         comptype(i) = .false.
      end if
   end do
   init1 = .true.

   ! If not going to solve the problem, compute energy and return
   if(.not.solve) then
      call computef(n,xmol,fx)
      ! Otherwise, put this molecule in its constraints
   else
      ip1 = iprint1
      ip2 = iprint2
      iprint1 = 0
      iprint2 = 0
      call pgencan(n,xmol,fx)
      iprint1 = ip1
      iprint2 = ip2
   end if

   ! Restoring original problem data
   ntotmol = ntotsafe
   n = nsafe
   nmols(itype) = nmoltype
   x(ilubar+1:ilubar+3) = xmol(1:3)
   x(ilubar+ntotmol*3+1:ilubar+ntotmol*3+3) = xmol(4:6)
   comptype(1:ntype) = compsafe(1:ntype)
   init1 = initsafe

   return
end subroutine restmol

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine that computes the function value
!

subroutine computef(n,x,f)

   use sizes
   use cell_indexing, only: index_cell, icell_to_cell, setcell
   use compute_data
   use pbc
   implicit none

   integer :: n, i, j, k, icell
   integer :: ilugan, ilubar, icart, itype, imol, iatom, idatom
   integer :: cell(3)

   double precision :: v1(3), v2(3), v3(3)
   double precision :: x(n)
   double precision :: f,fparc,fplus
   double precision :: xcm(3)
   double precision :: beta, gama, teta

   ! Reset function value

   f = 0.d0
   frest = 0.d0
   fdist = 0.d0

   ! Reset cells

   if(.not.init1) call resetcells()

   ! Transform baricenter and angles into cartesian coordinates
   ! Computes cartesian coordinates from vector x and coor

   ilubar = 0
   ilugan = ntotmol*3
   icart = 0

   do itype = 1, ntype
      if(.not.comptype(itype)) then
         icart = icart + nmols(itype)*natoms(itype)
         cycle
      end if

      do imol = 1, nmols(itype)

         xcm = x(ilubar+1:ilubar+3)

         ! Computing the rotation matrix

         beta = x(ilugan+1)
         gama = x(ilugan+2)
         teta = x(ilugan+3)

         call eulerrmat(beta,gama,teta,v1,v2,v3)

         ! Looping over the atoms of this molecule

         idatom = idfirst(itype) - 1
         do iatom = 1, natoms(itype)

            icart = icart + 1
            idatom = idatom + 1

            ! Computing the cartesian coordinates for this atom

            call compcart(xcart(icart,1:3),xcm,coor(idatom,1:3),v1,v2,v3)

            ! Adding to f the value relative to constraints for this atom

            call comprest(icart,fplus)
            f = f + fplus
            frest = dmax1(frest,fplus)
            if(move) frest_atom(icart) = frest_atom(icart) + fplus

            ! Putting atoms in their cells

            if(.not.init1) then
               call setcell(xcart(icart,:), cell)

               ! Atom linked list
               latomnext(icart) = latomfirst(cell(1),cell(2),cell(3))
               latomfirst(cell(1),cell(2),cell(3)) = icart

               ! cell with atoms linked list
               if ( empty_cell(cell(1),cell(2),cell(3)) ) then
                  empty_cell(cell(1),cell(2),cell(3)) = .false.
                  icell = index_cell(cell,ncells)
                  lcellnext(icell) = lcellfirst
                  lcellfirst = icell
               end if

               ibtype(icart) = itype
               ibmol(icart) = imol

            end if

         end do

         ilugan = ilugan + 3
         ilubar = ilubar + 3

      end do
   end do

   if(init1) return

   ! Minimum distance function evaluation

   icell = lcellfirst
   do while( icell > 0 )

      call icell_to_cell(icell,ncells,cell)
      i = cell(1)
      j = cell(2)
      k = cell(3)

      icart = latomfirst(i,j,k)
      do while( icart > 0 )

         if(comptype(ibtype(icart))) then
            ! Interactions inside cell
            f = f + fparc(icart,latomnext(icart))
            ! Interactions of cells that share faces (6 faces - 3 forward)
            f = f + fparc(icart,latomfirst(cell_ind(i+1, ncells(1)),j,k)) ! 4 - (1, 0, 0)
            f = f + fparc(icart,latomfirst(i,cell_ind(j+1, ncells(2)),k)) ! 5 - (0, 1, 0)
            f = f + fparc(icart,latomfirst(i,j,cell_ind(k+1, ncells(3)))) ! 6 - (0, 0, 1)
            ! Interactions of cells that share axes (12 edges - 6 forward)
            f = f + fparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j-1, ncells(2)),k)) ! 4 - (1, -1, 0)
            f = f + fparc(icart,latomfirst(cell_ind(i+1, ncells(1)),j,cell_ind(k-1, ncells(3)))) ! 5 - (1, 0, -1)
            f = f + fparc(icart,latomfirst(i,cell_ind(j+1, ncells(2)),cell_ind(k-1, ncells(3)))) ! 6 - (0, 1, -1)
            f = f + fparc(icart,latomfirst(i,cell_ind(j+1, ncells(2)),cell_ind(k+1, ncells(3)))) ! 9 - (0, 1, 1)
            f = f + fparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j+1, ncells(2)),k)) ! 10 - (1, 1, 0)
            f = f + fparc(icart,latomfirst(cell_ind(i+1, ncells(1)),j,cell_ind(k+1, ncells(3)))) ! 11 - (1, 0, 1)
            ! Interactions of cells that share vertices (8 vertices, 8 forward)
            f = f + fparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j-1, ncells(2)),cell_ind(k-1, ncells(3)))) ! 5 - (1, -1, -1)
            f = f + fparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j-1, ncells(2)),cell_ind(k+1, ncells(3)))) ! 6 - (1, -1, 1)
            f = f + fparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j+1, ncells(2)),cell_ind(k-1, ncells(3)))) ! 7 - (1, 1, -1)
            f = f + fparc(icart,latomfirst(cell_ind(i+1, ncells(1)),cell_ind(j+1, ncells(2)),cell_ind(k+1, ncells(3)))) ! 8 - (1, 1, 1)
         end if

         icart = latomnext(icart)
      end do

      icell = lcellnext(icell)
   end do

   return
end subroutine computef

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!  
! Subroutine writesuccess
!
!    Writes the success messages for good packings    
!

subroutine writesuccess(itype,fdist,frest,f)

    use input, only : input_itype
    use compute_data, only : ntype
    use ahestetic
    implicit none
    integer :: itype
    double precision :: fdist, frest, f
  
    if(itype.le.ntype) then
        write(*,dash1_line)
        write(*,*)' Packing solved for molecules of type', input_itype(itype)
        write(*,*)' Objective function value: ', f
        write(*,*)' Maximum violation of target distance: ',fdist
        write(*,*)' Max. constraint violation: ', frest
        write(*,dash1_line)
    else
        write(*,hash3_line)
        write(*,"(&
                  &t33, ' Success! ',                               /,&
                  &t14, ' Final objective function value: ', e10.5, /,&
                  &t14, ' Maximum violation of target distance: ', f10.6, /,&
                  &t14, ' Maximum violation of the constraints: ', e10.5 &
                  &)") f, fdist, frest
        write(*,dash3_line)
        write(*,"(&
                  &t14,' Please cite this work if Packmol was useful: ',/,/,&
                  &t11,' L. Martinez, R. Andrade, E. G. Birgin, J. M. Martinez, ',/,&
                  &t9,' PACKMOL: A package for building initial configurations for',/,&
                  &t19,' molecular dynamics simulations. ',/,&
                  &t8,' Journal of Computational Chemistry, 30(13) pp. 2157-2164, 2009.', /,&
                  &t18,' https://doi.org/10.1002/jcc.21224' &
                  &)")
        write(*,hash3_line)
    end if

end subroutine writesuccess

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!

!
! Arrays required by the flashsort package. Used only in heuristics, but
! defined here to be allocated dynamically
!

module flashsort

   use sizes
   implicit none
   integer, allocatable :: indflash(:) ! (ntotat)
   integer, allocatable :: lflash(:) ! (ntotat)
   integer :: mflash

end module flashsort

!
!  Written by Yi Yao (yaoyi92@gmail.com)
!

module pbc

   implicit none

   logical, public :: using_pbc = .false.
   double precision, public :: pbc_min(3), pbc_max(3), pbc_length(3)
   public v_in_box, delta_vector, cell_ind

contains

   elemental double precision function v_in_box(v, pbc_min, pbc_length)
      double precision, intent(in) :: v, pbc_min, pbc_length
      v_in_box = pbc_min + modulo((v - pbc_min), pbc_length)
   end function v_in_box

   elemental double precision function delta_vector(v1,v2, pbc_length)
      double precision, intent(in) :: v1, v2, pbc_length
      delta_vector = v1 - v2
      delta_vector =  delta_vector - pbc_length * nint(delta_vector/pbc_length)
   end function delta_vector

   integer function cell_ind(icell, ncells)
      integer :: icell, ncells
      cell_ind = modulo(icell - 1 + ncells, ncells) + 1
   end function cell_ind

end module pbc

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!
! Subroutine cenmass
!
!            Computes the center of mass of free molecules and
!            for fixed molecules, if required.
!
subroutine cenmass()

   use sizes
   use compute_data, only : ntype, coor, idfirst, natoms
   use input, only : keyword, amass, nlines, linestrut

   implicit none
   integer :: k, iline
   integer :: itype, iatom, idatom
   double precision, allocatable :: cm(:,:), totm(:)
   logical, allocatable :: domass(:)

   ! Allocate local vectors

   allocate(cm(ntype,3),totm(ntype),domass(ntype))

   ! Setting the molecules for which the center of mass is computed

   do itype = 1, ntype
      domass(itype) = .true.
   end do

   do iline = 1, nlines
      if(keyword(iline,1).eq.'fixed') then
         do itype = 1, ntype
            if(iline.gt.linestrut(itype,1).and. &
               iline.lt.linestrut(itype,2)) then
               domass(itype) = .false.
            end if
         end do
      end if
   end do

   do iline = 1, nlines
      if(keyword(iline,1).eq.'centerofmass'.or. &
         keyword(iline,1).eq.'center') then
         do itype = 1, ntype
            if(iline.gt.linestrut(itype,1).and. &
               iline.lt.linestrut(itype,2)) then
               domass(itype) = .true.
            end if
         end do
      end if
   end do

   ! Computing the center of mass

   do itype = 1, ntype
      do k = 1, 3
         cm(itype, k) = 0.d0
      end do
   end do

   do itype = 1, ntype
      totm(itype) = 0.d0
      idatom = idfirst(itype) - 1
      do iatom = 1, natoms(itype)
         idatom = idatom + 1
         totm(itype) = totm(itype) + amass(idatom)
      end do
   end do

   do itype = 1, ntype
      idatom = idfirst(itype) - 1
      do iatom = 1, natoms(itype)
         idatom = idatom + 1
         do k = 1, 3
            cm(itype, k) = cm(itype, k)  + coor(idatom, k)*amass(idatom)
         end do
      end do
      do k = 1, 3
         cm(itype, k) = cm(itype, k) / totm(itype)
      end do
   end do

   ! Putting molecules in their center of mass

   do itype = 1, ntype
      if(domass(itype)) then
         idatom = idfirst(itype) - 1
         do iatom = 1, natoms(itype)
            idatom = idatom + 1
            do k = 1, 3
               coor(idatom, k) = coor(idatom, k) - cm(itype, k)
            end do
         end do
      end if
   end do

   deallocate(cm,totm,domass)

   return
end subroutine cenmass

!
!  Written by Leandro Martínez, 2009-2011.
!  Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
!  Ernesto G. Birgin.
!

!
! Subroutine that performs finite difference and analytical gradient
! comparision. Used only for test purpouses
!

subroutine comparegrad(n,x)

   use sizes
   implicit none

   integer :: n, i, iworst
   double precision :: x(n), fx, step, gcomp, gbest, eworst, &
      error, steperror, stepbest
   double precision, allocatable :: g(:)
   real :: time0, tarray(2), etime

   ! Allocate local array

   allocate(g(nn))

   write(*,*)
   write(*,*) ' Comparing analytical and finite-difference '
   write(*,*) ' gradients... may take a while. '
   write(*,*)
   write(*,*) ' Five first center of masses and angles of tested point: '
   do i = 1, 15, 3
      write(*,"( i4,6(tr2,f8.3) )") (i+2)/3, x(i), x(i+1), x(i+2), x(n/2+i),&
         x(n/2+i+1),x(n/2+i+2)
   end do
   write(*,*)
   write(*,*) ' Computing gradient ... '

   call computef(n,x,fx)
   write(*,*) ' Function value on test point: ', fx
   open(98, file = 'chkgrad.log',status='unknown')
   write(98, *)'Function Value = ', fx
   call computeg(n,x,g)

   write(98,"( t2,'Component',t16,'Analytical',t33,'Discrete', &
   &t51,'Error',t62,'Best step' )")
   time0 = etime(tarray)
   eworst = 0.d0
   do i = 1, n
      if(etime(tarray)-time0.gt.10.) then
         time0 = etime(tarray)
         write(*,*) ' Computing the ',i,'th of ',n,' components. Worst error: ', eworst
      end if
      error = 1.d20
      step = 1.d-2
      do while(error.gt.1.d-6.and.step.ge.1.d-20)
         call discret(i,n,x,gcomp,step)
         if(dmin1(abs(g(i)),abs(gcomp)).gt.1.d-10) then
            steperror = abs( ( gcomp - g(i) ) / g(i) )
         else
            steperror = abs( gcomp - g(i) )
         end if
         if( steperror .lt. error ) then
            error = steperror
            gbest = gcomp
            stepbest = step
         end if
         step = step / 10.d0
      end do
      write(98,"(i10,5(tr2,d13.7))") i, g(i), gbest, error, stepbest
      if(error.gt.eworst) then
         iworst = i
         eworst = error
      end if
   end do
   write(98,*) 'Maximum difference = ', iworst,' Error= ', eworst
   write(*,*) ' Done. '
   stop

end subroutine comparegrad

subroutine discret(icomp,n,x,gcomp,step)

   implicit none
   integer :: n, icomp
   double precision :: save, step, x(n), fplus, fminus, gcomp

   save = x(icomp)
   x(icomp) = save + step
   call computef(n,x,fplus)
   x(icomp) = save - step
   call computef(n,x,fminus)
   gcomp = (fplus - fminus) / (2.d0 * step)
   x(icomp) = save

   return
end subroutine discret

#!/bin/bash
#
echo "Starting to run test.sh script... "
# Julia executable path:
julia_exe=`which julia`
echo "Output of which_julia: $julia_exe"
# Raise error in case of failure
set -e
if [[ -z "$julia_exe" ]]; then
    echo "julia executable not found in path, setting to ~/.juliaup/bin/julia - this might be wrong."
    julia_exe=~/.juliaup/bin/julia
fi
echo "Julia executable: $julia_exe"
# Run the tests
echo "Running runtests.jl script."
$julia_exe runtests.jl ./input_files/water_box.inp \
                  ./input_files/ieee_signaling.inp \
                  ./input_files/mixture.inp \
                  ./input_files/mixture_pbc.inp \
                  ./input_files/toy_with_fixed.inp \
                  ./input_files/spherical.inp \
                  ./input_files/bilayer.inp \
                  ./input_files/solvprotein.inp \
                  ./input_files/water_box_pbc.inp \
                  ./input_files/water_box_pbc2.inp \
                  ./input_files/water_box_pbc_negative_coordinates.inp \
                  ./input_files/water_box_pbc_slab.inp \
                  ./input_files/water_box_pbc_outside_box.inp \
                  ./input_files/bilayer_pbc.inp \
                  ./input_files/solvprotein_pbc.inp \
                  ./input_files/spherical_pbc.inp \
                  ./input_files/only_one_fixed.inp

# check if output files are properly generated in a failed run
./test_failed.sh ./input_files/water_box_failed.inp packmol.log "FORCED" 
./test_failed.sh ./input_files/protein_outside_pbc_error.inp packmol.log "outside"

# Test connectivity
./test_connectivity.sh 

# Test command-line interface
./test_cli.sh ../packmol

#!/bin/bash

# Fortran compiler to use
export FC=gfortran
# Compiler flags to use
export FFLAGS="-g -O2 -Wall"
#export FFLAGS="-g -O2 -Wall -fbounds-check"
#export FFLAGS="-g -O0 -Wall -fbounds-check"

# Installation directory
export target=$(pwd) # this installs packmol under bin/ in the present directory

# Number of parallel processes in build
export npar=4

# No changes should be necessary hereafter.
if [[ ! -d objdir ]]; then
    mkdir objdir
fi
cd objdir
cmake .. \
      -DCMAKE_INSTALL_PREFIX=${target} \
      -DCMAKE_BUILD_TYPE=Release \
      -DCMAKE_Fortran_FLAGS_RELEASE:STRING="-DNDEBUG"
make -j ${npar} install VERBOSE=1
cd ..

####################################################################################################

#
# How to release the software:
#
# run ./release. 20.14.1 (for example)
#
# go to the github site and release the version corresponding to the new tag.
#

# Software name:

package=packmol

# Release version, read from command line:
version="$1"

# GIT URL:

giturl=https://github.com/m3g/packmol

# Name of files containing version number

versionfile=./src/title.f90
fpmfile=./fpm.toml

####################################################################################################

#git log --pretty=oneline 16.323...16.330 | awk '{$1=""; print "-"$0}'

year=`date +%y`
day=`date +%j`
#version="${year:0:1}${year:1:1}.$day"
if [[ $version < " " ]]; then
  version=`grep version fpm.toml`
  echo "ERROR: Please provide version number, with: ./release.sh 20.1.1"
  echo "       current $version"
  exit
fi

cat $versionfile | sed -e "s/Version.*/Version\ $version \')\")/" > tmpfile.txt
\mv -f tmpfile.txt $versionfile

cat $fpmfile | sed -e "s/version.*/version = \"$version\"/" > tmpfile.txt
\mv -f tmpfile.txt $fpmfile

git add -A .
git commit -m "Changed version file to $version"
git tag -a "v$version" -m "Release $version"
git push origin master tag "v$version"

echo "----------------------"
echo "CHANGE LOG:"
echo "----------------------"
range=`git tag | sort -V | tail -n 2 | xargs | sed 's! !...!'`
git log --pretty=oneline $range | awk '{$1=""; print "-"$0}'
echo "----------------------"

echo " Done. "   

#!/bin/bash
echo "Running connectivity test..."

../packmol < ./input_files/benzene2.inp > /dev/null

if diff <(grep "^CONECT" ./output.pdb) <(grep "^CONECT" ./output_files/benzene2.pdb) >/dev/null; then
    exit 0  # Files are identical
else
    echo "Connectivity test failed."
    exit 1  # Files are different
fi

#!/bin/bash
#
# Synopsis:
# Test the command-line interface by checking if executing packmol with command-line
# arguments changes results. The script checks for differences in the output files with
# the GNU diffutil. All the supported ways to invoke packmol are considered.
#
# Written by Misael Díaz-Maldonado, 2025
#
# Copyright (c) 2009-2018, Leandro Martínez, Jose Mario Martinez,
# Ernesto G. Birgin.
#
# Example invokation of this shell script: ./test_cli.sh /usr/bin/packmol
#
# NOTES:
# We skip tests designed to fail and we patch input files with a seed equal to -1 because
# that will also fail our test because that signals packmol to generate a seed based on
# the current time and so results are expected to be different.
#

verbose=0

# checks number of command-line arguments given
if [ "$#" -ne 1 ] ; then
	echo "Error: expects the path to packmol as the first command-line argument"
	echo "Example: ./test_cli.sh /usr/bin/packmol"
	exit 1
fi

packmol="$1"
# checks that we can execute packmol
if ! [ -f "$packmol" ] ; then
	echo "Error: packmol does not exist"
	exit 1
fi

if ! [ -x "$packmol" ] ; then
	echo "Error: cannot execute packmol"
	exit 1
fi

# checks that the input_files directo exists
if ! [ -d input_files ] ; then
	echo "Error: the 'input_files' directory does not exist"
	exit 1
fi

# checks that all the commands this script depends exists for the sake of completeness
ls=$(which ls)
if ! [ -x "$ls" ] ; then
	echo "Error: ls command not found"
	exit 1
fi

cp=$(which cp)
if ! [ -x "$cp" ] ; then
	echo "Error: cp command not found"
	exit 1
fi

rm=$(which rm)
if ! [ -x "$rm" ] ; then
	echo "Error: rm command not found"
	exit 1
fi

wc=$(which wc)
if ! [ -x "$wc" ] ; then
	echo "Error: wc command not found"
	exit 1
fi

cat=$(which cat)
if ! [ -x "$cat" ] ; then
	echo "Error: cat command not found"
	exit 1
fi

sed=$(which sed)
if ! [ -x "$sed" ] ; then
	echo "Error: sed command not found"
	exit 1
fi

diff=$(which diff)
if ! [ -x "$diff" ] ; then
	echo "Error: diff command not found"
	exit 1
fi

grep=$(which grep)
if ! [ -x "$grep" ] ; then
	echo "Error: grep command not found"
	exit 1
fi

uname=$(which uname)
if ! [ -x "$uname" ] ; then
	echo "Error: uname command not found"
	exit 1
fi

os=$("$uname")
# OSX does not ship with GNU gawk by default so we need to use what they provide
if [ "Darwin" == "$os" ] ; then
	gawk=$(which awk)
else
	gawk=$(which gawk)
fi

if ! [ -x "$gawk" ] ; then
	echo "Error: gawk command not found"
	exit 1
fi

# for each input file in the input_files directory run packmol and check that we get the
# same results (same contents in the output file) regardless of the invokation method
# used to execute packmol
"$ls" input_files/*.inp | while read input_file
do
	# here we use pattern matching to exclude input_files that we know would fail
	# because they are meant to fail; since that would mess our test we filter
	# those out with grep
	sw=$(echo "$input_file" | "$grep" -v "error" | "$grep" -v "fail" | "$wc" -c)
	if [ "$sw" -eq 0 ] ; then
		if [ "$verbose" -eq 1 ] ; then
			echo "Skipping test $input_file because it is designed to fail"
		fi
		continue
	fi

	# we need to patch some of the data in the original input files this is why we
	# create .txt and .tmp versions; we use regex to replace the .inp with either
	# .txt or .tmp extensions
	input_txt=$(\
		echo "$input_file" |\
		"$sed" 's/\.inp/.txt/g'
	)

	input_tmp=$(\
		echo "$input_file" |\
		"$sed" 's/\.inp/.tmp/g'
	)

	# We fix the `seed` value on those input_files that set it to -1; otherwise
	# packmol could yield different results and we don't want that of course, we
	# want reproducible results for the same input. That is why we provide a fix
	# value for the seed.
	"$cp" "$input_file" "$input_txt"
	"$sed" -e 's/seed -1/seed 1024/g' -i'.tmp' "$input_txt"
	"$cp" "$input_txt" "$input_tmp"
	"$sed" -e 's/output\.pdb/output.tmp/g' -i'.tmp' "$input_tmp"
	"$rm" "$input_txt.tmp"
	"$rm" "$input_tmp.tmp"

	# here we extract the name of the output file from the input-file
	output_pdb=$(\
		"$cat" "$input_txt" | \
		"$grep" "output" | \
		"$gawk" '{print $2}'
	)

	# uses substitution to produce an output file with a .txt file extension
	output_txt=$(\
		echo "$output_pdb" | \
		"$sed" 's/\.pdb/.txt/g'
	)

	# uses substitution to produce an output file with a .tmp file extension
	output_tmp=$(\
		echo "$output_pdb" | \
		"$sed" 's/\.pdb/.tmp/g'
	)

	echo -n "Running test $input_txt ... "

	# runs packmol in the usual way with input redirection
	if ! "$packmol" < "$input_txt" 1>/dev/null 2>/dev/null ; then
		echo "FAIL"
		"$rm" -f "$input_tmp"
		"$rm" -f "$input_txt"
		"$rm" -f "$output_txt"
		"$rm" -f "$output_pdb"
		"$rm" -f "$output_tmp"
		exit 1
	fi

	# Provides the input file via command-line to packmol and executes it;
	# we redirect the standard output and error to the null-device to keep
	# our test output clean. In this case the output file is determined from
	# the input-file `input_tmp`; note that the output file will have a .tmp
	# file extension because of the preprocessing that we have done.
	if ! "$packmol" -i "$input_tmp" 1>/dev/null 2>/dev/null ; then
		echo "FAIL"
		"$rm" -f "$input_tmp"
		"$rm" -f "$input_txt"
		"$rm" -f "$output_txt"
		"$rm" -f "$output_pdb"
		"$rm" -f "$output_tmp"
		exit 1
	fi

	# provides both the input and output files to packmol and executes it
	if ! "$packmol" -i "$input_txt" -o "$output_txt" 1>/dev/null 2>/dev/null ; then
		echo "FAIL"
		"$rm" -f "$input_tmp"
		"$rm" -f "$input_txt"
		"$rm" -f "$output_txt"
		"$rm" -f "$output_pdb"
		"$rm" -f "$output_tmp"
		exit 1
	fi

	# here we check that the output files are identical via GNU diffutil;
	# to do that we concatenate the diff contents and determine the number of
	# bytes (we should get zero bytes when they are the same)
	res1=$("$diff" --normal "$output_pdb" "$output_txt" | "$wc" -c)
	res2=$("$diff" --normal "$output_pdb" "$output_tmp" | "$wc" -c)
	if [ "$res1" -eq 0 ] && [ "$res2" -eq 0 ] ; then
		echo "OK"
	else
		echo "FAIL"
		"$rm" -f "$input_tmp"
		"$rm" -f "$input_txt"
		"$rm" -f "$output_txt"
		"$rm" -f "$output_pdb"
		"$rm" -f "$output_tmp"
		exit 1
	fi

	# we clean up the testing directory from our temporary files
	"$rm" -f "$input_tmp"
	"$rm" -f "$input_txt"
	"$rm" -f "$output_txt"
	"$rm" -f "$output_pdb"
	"$rm" -f "$output_tmp"
done

# if we get here packmol passed all the tests successfully
exit 0

####################################################################################################
#
# How to update the version number:
#
# run: ./update_version 21.0.1 (for example)
#

# Software name:

package=packmol

# Release version, read from command line:
version="$1"

# Name of files containing version number

versionfile=./src/title.f90
fpmfile=./fpm.toml
pyprojfile=./pyproject.toml

####################################################################################################
if [[ $version < " " ]]; then
  version=`grep version fpm.toml`
  echo "ERROR: Please provide version number, with: ./release.sh 20.1.1"
  echo "       current $version"
  exit
fi

cat $versionfile | sed -e "s/Version.*/Version\ $version \')\")/" > tmpfile.txt
\mv -f tmpfile.txt $versionfile

cat $fpmfile | sed -e "s/version.*/version = \"$version\"/" > tmpfile.txt
\mv -f tmpfile.txt $fpmfile

cat $pyprojfile | sed -e "s/version.*/version = \"$version\"/" > tmpfile.txt
\mv -f tmpfile.txt $pyprojfile

echo "----------------------"
echo "Please update the CHANGELOG.md file. Commits:"
echo "----------------------"
range=`git tag | sort -V | tail -n 2 | xargs | sed 's! !...!'`
git log --pretty=oneline $range | awk '{$1=""; print "-"$0}'
echo "----------------------"

echo " Done. "   

#!/bin/bash
#
# First argument: input file name
# Second argument: log file name
#
# Third argument: string to be searched in the log file, to declare that
# the test passed
#
# Example: ./test.sh "water_box.inp" "packmol.log" "FORCED"
#
echo "Running failed packing test ... "
if ! [ -f $1 ]; then
    echo "Error: input file not found: $1"
    exit 1
fi
../packmol < $1 > $2
if ! [ -f $2 ]; then
    echo "Error: Log file not generated: $2"
    exit 1
fi
if ! grep -q $3 $2; then
    echo "Error: could not find $3 in $2"
    exit 1
fi
echo "Failed run test $1 OK."
exit 0
